//----------------------------------------------------------------------------
// Projekt "lcwin.exe" - program do testowania i zobrazowania
// moliwoci bibliotek DLL  obsugujcej karty karty AMBEX .
// Gwny plik implementacyjny .
// Autor : Krzysztof Mroczek , 1995,1996
//----------------------------------------------------------------------------
#include <owl\owlpch.h>
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\scroller.h>

#include <owl\statusba.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include <owl\gdiobjec.h>
#include <owl\gauge.h>

#include <owl\dc.h>
#include <stdio.h>
#include <alloc.h>
#include <dir.h>
#include "t011app.rh"
#include "t011.h"
#include "t011abtd.h"
#include "ttestd.h"
#include "user.h"

//////////////////////////////////////////////////////////////////////////////
// deklaracja skadowych statycznych klas okien dialogowych
//////////////////////////////////////////////////////////////////////////////
TD8* TD8::dWindow =NULL;
TD5* TD5::dWindow =NULL;
TTestD*	TTestD::dWindow=NULL;
TParMD* TParMD::dWindow=NULL;
TD7* TD7::dWindow=NULL;

/* wskaniki do funkcji publicznych driver'a DLL */
void (FAR PASCAL _export *ModuleInit)(struct lc0_init FAR *param);
void (FAR PASCAL _export *GetTotalConfiguration)(struct lc0_total FAR *param);
void (FAR PASCAL _export *GetModuleConfiguration)(struct lc0_module FAR *param);
void (FAR PASCAL _export *GetInfo)(struct lc0_info FAR *param);
void (FAR PASCAL _export *Break)(struct lc0_break FAR *param);
void (FAR PASCAL _export *AnalogInput)(struct lc0_analog_in FAR *param);
void (FAR PASCAL _export *AnalogOutput)(struct lc0_analog_out FAR *param);
void (FAR PASCAL _export *Leave)(struct lc0_leave FAR *param);
void (FAR PASCAL _export *SetClock)(struct lc0_clock FAR *param)	;
void (FAR PASCAL _export *SetVoltage)(struct lc0_volt FAR *param)	;
void (FAR PASCAL _export *SetTime)(struct lc0_time FAR *param)	;
void (FAR PASCAL _export *WaitForInt)(struct lc0_wait FAR *param)	;
void (FAR PASCAL _export *Interrupt)(struct lc0_interrupt FAR *param)	;
void (FAR PASCAL _export *DigitalIn)(struct lc0_digital_in FAR *param)	;
void (FAR PASCAL _export *DigitalOut)(struct lc0_digital_out FAR *param)	;
void (FAR PASCAL _export *CTCWrite)(struct lc0_ctc_write FAR *param)	;
void (FAR PASCAL _export *CTCRead)(struct lc0_ctc_read FAR *param)	;
void (FAR PASCAL _export *Config)(struct lc0_config FAR *param)	;
void (FAR PASCAL _export *DataTransmit)(struct lc0_transmit FAR *param);
void (FAR PASCAL _export *MemoryUse)(struct lc0_memory FAR *param);

// identyfikatory stringw wewntrznych DDL-i .

#define IDS_LC_NUMBER	3
#define IDS_LC_COMPANY	4
#define IDS_LC_DLLTYPE	5
#define IDS_LC_VERSION	2
#define IDS_LC_PRODUCTINFO	1

#define NUMDISPL 4
#define NUMSAMPL 4096
#define TPER  40

/* nazwy plikw DLL */
char *DLLDrivers[] =
 {
	"LC1016A.DLL",
	"LC1108A.DLL",
	"LC1116A.DLL",
	"LC1216A.DLL",
	"LC1516A.DLL",
	"LC2008A.DLL",
	"LC2032A.DLL",
	"LC3016A.DLL",
	"LC055PA.DLL",
 };
#define DLLNR 9

int DLLAct[DLLNR] ;
int DLLSingle=0;
char CurrentDLL[20] ;
HINSTANCE	 hDriverInst	  ;		 /* desktyptor drivera				*/
HINSTANCE	 hInst ; /* deskryptor aplikacji */
BOOL IsDriver = FALSE ;
extern lc0_analog_in	SAnalogIn,SGAnalogIn;
extern lc0_module		SModuleInfo ;
extern unsigned long Samples , GSamples,PSamples ;
extern struct SD9 GlobalInfo ;

//////////////////////////////////////////////////////////////////////
// SearchFile()
// szuka pliku AMBEX.INI i go ewentualnie otwiera
// path - cieka do pliku
// Rezultat
//  1 - jest plik , 0 - nie ma
//////////////////////////////////////////////////////////////////////
int SearchFile(char *path)     // 1 jest gdzie 0 -nie ma
{
	char pbuf[144] ;
	UINT wret ;
	FILE *ini ;

	wret = GetWindowsDirectory((LPSTR)pbuf,sizeof(pbuf));
	if(wret!=0)
	 {
	  if(pbuf[wret-1] != '\\')
		strcat(pbuf,"\\");
	  strcat(pbuf,(LPSTR)(path));
	  ini = fopen(pbuf,"r");
	  if(ini != NULL)
		{
		  fclose(ini);
		  return 1 ;
		}
	 }

	 wret = GetSystemDirectory((LPSTR)pbuf,sizeof(pbuf));
	 if(wret!=0)
	 {
	  if(pbuf[wret-1] != '\\')
		strcat(pbuf,"\\");
	  strcat(pbuf,(LPSTR)(path));
	  ini = fopen(pbuf,"r");
	  if(ini != NULL)
		{
		  fclose(ini);
		  return 1 ;
		}
	 }

	(LPSTR)path = searchpath((LPSTR)path);
	if(path == NULL) //nie znaleziono
	 {
		return 0 ;
	 }
	else
	 {
	  ini = fopen((LPSTR)path,"r");
	  if(ini != NULL)
		return 1 ;
	  else
		return 0 ;
	 }
}

///////////////////////////////////////////////////////////////////////////////
// checkdriver
// funkcja sprawdzajca jakie DLL s dostpne
// Rezultat :
//  0 - nie ma zadnej , 1 jest jaka
///////////////////////////////////////////////////////////////////////////////
int checkdriver()
{
  int i ,r=0,res;

  for(i=0 ; i<DLLNR;i++)
	{
	 res=SearchFile(DLLDrivers[i]);
	 if(res != NULL)
	  {
		DLLAct[i]=1;
		r=1;
		DLLSingle++;
		if(DLLSingle==1)
		 {
		  strcpy(CurrentDLL,DLLDrivers[i]);
		 }
	  }
	 else
	  {
		DLLAct[i]=0;
	  }
	}
  return r;
}

//////////////////////////////////////////////////////////////////////////////
// LoadDriver
// Dynamiczne wczytanie driver'a do pamici
// Rezulatat :
//  1 - OK , 0 - bd
//////////////////////////////////////////////////////////////////////////////
BOOL LoadDriver()
{
 FARPROC funptr ;
 hDriverInst = ::LoadLibrary(CurrentDLL);	/* wczytanie do pamici */

 /* ustawienie wskanikw do funkcji */

 if(hDriverInst > HINSTANCE_ERROR)
  {
	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(MODULE_INIT));
	(FARPROC)ModuleInit = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(GET_TOTAL_CONFIGURATION));
	(FARPROC)GetTotalConfiguration = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(GET_MODULE_CONFIGURATION));
	(FARPROC)GetModuleConfiguration = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(GET_INFO));
	(FARPROC)GetInfo = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(BREAK));
	(FARPROC)Break = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(ANALOG_INPUT));
	(FARPROC)AnalogInput = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(ANALOG_OUTPUT));
	(FARPROC)AnalogOutput = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(LEAVE_DRIVER));
	(FARPROC)Leave = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(SET_CLOCK));
	(FARPROC)SetClock = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(SET_VOLTAGE_RANGE));
	(FARPROC)SetVoltage = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(SET_TIME));
	(FARPROC)SetTime = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(WAIT_FOR_END));
	(FARPROC)WaitForInt = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(INTERRUPT_SERVICE));
	(FARPROC)Interrupt = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(DIGITAL_INPUT));
	(FARPROC)DigitalIn = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(DIGITAL_OUTPUT));
	(FARPROC)DigitalOut = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(CTC_WRITE));
	(FARPROC)CTCWrite = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(CTC_READ));
	(FARPROC)CTCRead = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(DATA_TRANSMIT));
	(FARPROC)DataTransmit = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(CONFIG));
	(FARPROC)Config = ::MakeProcInstance(funptr,hInst);

	funptr =::GetProcAddress(hDriverInst,MAKEINTRESOURCE(MEMORY_USE));
	(FARPROC)MemoryUse = ::MakeProcInstance(funptr,hInst);

	return(TRUE);
  }
 else
  {
	return(FALSE);
  }
}

//////////////////////////////////////////////////////////////////////
// FreeInstances() - zwalnia instancje funkcji
//////////////////////////////////////////////////////////////////////
void FreeInstances()
{
  ::FreeProcInstance((FARPROC)ModuleInit);
  ::FreeProcInstance((FARPROC)GetTotalConfiguration);
  ::FreeProcInstance((FARPROC)GetModuleConfiguration);
  ::FreeProcInstance((FARPROC)GetInfo);
  ::FreeProcInstance((FARPROC)Break);
  ::FreeProcInstance((FARPROC)AnalogInput);
  ::FreeProcInstance((FARPROC)AnalogOutput);
  ::FreeProcInstance((FARPROC)Leave);
  ::FreeProcInstance((FARPROC)SetClock);
  ::FreeProcInstance((FARPROC)SetVoltage);
  ::FreeProcInstance((FARPROC)SetTime);
  ::FreeProcInstance((FARPROC)WaitForInt);
  ::FreeProcInstance((FARPROC)Interrupt);
  ::FreeProcInstance((FARPROC)DigitalIn);
  ::FreeProcInstance((FARPROC)DigitalOut);
  ::FreeProcInstance((FARPROC)CTCWrite);
  ::FreeProcInstance((FARPROC)CTCRead);
  ::FreeProcInstance((FARPROC)Config);
  ::FreeProcInstance((FARPROC)DataTransmit);
  ::FreeProcInstance((FARPROC)MemoryUse);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

DEFINE_RESPONSE_TABLE1(t011App, TApplication)
//{{t011AppRSP_TBL_BEGIN}}
	 //EV_OWLVIEW(dnCreate, EvNewView),
	// EV_OWLVIEW(dnClose,  EvCloseView),
	 EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
	 //EV_COMMAND(IDM_CONFIG, OnTestConfig),
	 EV_COMMAND(IDM_FUNCTIONS, OnTestFunction),
	 EV_COMMAND(IDM_PAR, OnMeasurePar),
	 EV_COMMAND(IDC_GEN, OnGen),
	 EV_COMMAND(IDM_MEAS, OnMeasure),
	 EV_COMMAND(IDM_TEKST, OnMeasureTekst),
	 EV_COMMAND(IDM_GRAPH, OnMeasureGraph),
	 EV_COMMAND(IDM_MON1, OnMonitor1),
	 EV_COMMAND(IDM_MON2, OnMonitor2),
	 EV_COMMAND(CM_DRIVER, OnDriver),
	 EV_COMMAND(IDC_WEAC, OnWeAC),
	 EV_COMMAND(IDC_WEWYC, OnWeWyC),
	 EV_COMMAND(CM_KONFIGURACJA, OnInfo),
	 EV_COMMAND(IDC_STATYSTYKA, OnStatystyka),
	 EV_COMMAND(CM_EXIT, OnExit),
	 EV_COMMAND(IDM_CLEAR,OnClear),
	// EV_COMMAND_ENABLE(CM_MEASURE_TEKST, OnMeasureTekstEn),
	// EV_WM_VSCROLL,
//{{t011AppRSP_TBL_END}}
END_RESPONSE_TABLE;

/********************************************************************
 Dodatkowe zmienne globalne
*********************************************************************/
TStatusBar* sb ; //status bar
TWindow *WWW[4]; // wskaniki do okien programu
TWindow *MW ;    // wskaznk do okna gwnego
char *WSamp[]={"XXX","XXX","XXX","XXX"};  //do wywietlenia w oknie 2
int   WPos[4]; 	//nr prbki (prbek wielokanaowo) aktualnie 'kliknitej' prbki
static unsigned char OldDtype=1; //poprzedni sposb wywietlania : tekstowy lub graficzny
HMENU hM;      // dla deskryptora memu
BOOL MON1,MON2,nonend; //czy s okna monitorow wyswietlone ,nonend - czy czyci
							  // okna monitorw kanaowych
tmonwnd *monptr1,*monptr2 ; //ptr-ki do monitorw kanaowych

/* struktury dla funkcji drajwera */
extern lc0_init 		SModuleInit ;
extern lc0_total      STotal ;
extern lc0_module		SModuleInfo ;
extern lc0_break		SBreak ;

extern CValues IValues	 ;  // min i max napicia poszczeglnych torw

///////////////////////////////////////////////////////////////////////////
// okno gwne - konstruktor
// parent - ojciec okna
///////////////////////////////////////////////////////////////////////////
t011Layout::t011Layout(TWindow *parent):TLayoutWindow(parent,0)
{
  int i;
  Attr.Style |=WS_BORDER;

  // tworzymy okna podrzdne
  child_info[0].window = new twnd0(this,1);
  child_info[2].window = new twnd2(this,3);
  child_info[3].window = new t011wnd(this,4);

  WWW[0]=child_info[0].window ;WWW[1]=NULL;//child_info[1].window ;
  WWW[2]=child_info[2].window ;WWW[3]=child_info[3].window ;

  // definiujemy metryk kadego okna
  //okno 0 - gra  na objanienia
  child_info[0].lm.X.Set(lmLeft,lmSameAs,lmParent,lmLeft);
  child_info[0].lm.Y.Set(lmTop,lmSameAs,lmParent,lmTop);
  child_info[0].lm.Width.Set(lmWidth,lmSameAs,lmParent,lmWidth);
  //wysoko
  child_info[0].lm.Height.Units = lmPixels;
  child_info[0].lm.Height.Absolute(30) ;     //30 pikseli

  //okno 1 lewa strona na przyciski
  // okno dolne - pasek stanu na komunikaty graficzne
  child_info[2].lm.X.Set(lmLeft,lmSameAs,lmParent,lmLeft);
  child_info[2].lm.Y.Set(lmBottom,lmSameAs,lmParent,lmBottom);
  child_info[2].lm.Width.Set(lmWidth,lmSameAs,lmParent,lmWidth);
  child_info[2].lm.Height.Units = lmPixels;
  child_info[2].lm.Height.Absolute(30) ;     //30 pikseli

  //okno robocze
  child_info[3].lm.X.Set(lmLeft,lmSameAs,/*child_info[1].window*/lmParent,/*lmRight*/lmLeft);
  child_info[3].lm.Y.Set(lmTop,lmSameAs,child_info[0].window,lmBottom);
  child_info[3].lm.Width.Set(lmRight,lmSameAs,lmParent,lmRight);
  child_info[3].lm.Height.Set(lmBottom,lmSameAs,child_info[2].window,lmTop) ;

 //ustawienie parametrw okien
 for(i=0;i<4;i++)
  {
	if(i!=1)
	 SetChildLayoutMetrics(*child_info[i].window,child_info[i].lm);
  }

 //rozmieszczenie okien
 // kolory okien
 WWW[0]->SetBkgndColor(RGB(200,200,200));
 WWW[2]->SetBkgndColor(RGB(200,200,200));
 WWW[3]->SetBkgndColor(RGB(255,255,255));

 Layout();
}


///////////////////////////////////////////////////////////////////////////
// okno sterujce 1
////////////////////////////////////////////////////
/////////////////////////////////////////////////////
// tego to chyba nie ma ?
/////////////////////////////////////////////////////
#define IDC_T_POMIAR	152
#define IDC_T_OK		151
#define IDC_T_E1		153
#define IDC_T_E2		154
#define IDC_T_E3		155
#define IDC_T_E4		156
#define IDC_T_E6		157
#define IDC_T_TEXT	158
#define IDC_T_GRAPH  159
#define IDC_T_MON1	160
#define IDC_T_MON2	161
#define IDC_T_GEN		162
#define IDC_T_FUN		163

// dodatkowe deklaracje
int FloatToCode(float val);
float CodeToFloat(int val);

extern int huge *ProgBufPtr ; // wskanik do bufora na prbki programu
extern Measure Mes ;				// instancja klasy Measure
extern lc0_analog_in SAnalogIn ; // dla funkcji LC0_AnalogIn
extern char *DriverErrors[],*DriverWarnings[] ; //tablice z opisamy kodw
// ststusu driver'a

/////////////////////////////////////////////////////////////////////////
// okna grne  0   - konstruktor
// parent - ojciec okna
// id		 - identyfikator okna
/////////////////////////////////////////////////////////////////////////
twnd0::twnd0(TWindow* parent,int id): TWindow(parent)
{
  Attr.Style |= WS_CHILD | WS_BORDER | WS_VISIBLE |WS_TABSTOP|WS_CLIPSIBLINGS ;
  Attr.Id = id ;
  //definicje staticw
  int i ;
  for(i=0;i<NUMDISPL+1;i++)
	{
	 e[i]=new TStatic(this,-1,"",5+i*100,5,90,15,2,0);
	 e[i]->SetBkgndColor(RGB(200,200,200));
	 e[i]->Attr.Style |=SS_CENTER ;
	}
}

////////////////////////////////////////////////////////////////////
// ->Opis()
//podpis okna grnego
///////////////////////////////////////////////////////////////////
void twnd0::Opis()
{
 //tworzenie opisu
	 int i ;
	 for(i=0;i<NUMDISPL+1;i++)
	  {
		e[i]->Clear();
		e[i]->SetBkgndColor(RGB(200,200,200));
	  }
	 char *str[] = {"Nr prbki",
							"Kana ",
						};
	 char tab[20],es[10],str1[10];
	 e[0]->Clear();
	 e[0]->SetText(str[0]);
	 e[0]->SetBkgndColor(RGB(200,200,200));
	 switch(Mes.DMode)
	 {
	  case 0	:sprintf(es," [10]");
				 break;
	  case 1	:sprintf(es," [H]");
				 break;
	  case 2	:sprintf(es," [mV]");
				 break;
	 };
	 if(Mes.Single)
	  {
		sprintf(tab,"Kana %d%s",Mes.Chan,es);
		e[1]->Clear();
		e[1]->SetText(tab);
		e[1]->SetBkgndColor(RGB(200,200,200));
	  }
	 else
	  {
		for(i=0;i<Mes.NumD;i++)
		 {
		  e[i+1]->Clear();
		  sprintf(tab,"%s%d %s",str[1],i+1+4*(Mes.GKan-1),es);
		  e[i+1]->SetText(tab);
		  e[i+1]->SetBkgndColor(RGB(200,200,200));
		 }

	  }

	for(i=0;i<NUMDISPL+1;i++)
	  {
		e[i]->UpdateWindow();
	  }
}

//////////////////////////////////////////////////////////////////////
// ->ClearAll()
// czyci okno grne
/////////////////////////////////////////////////////////////////////
void twnd0::ClearAll()
{
  int i ;
  for(i=0;i<NUMDISPL+1;i++)
	{
	  e[i]->Clear();
	  e[i]->SetBkgndColor(RGB(200,200,200));
	  e[i]->UpdateWindow();
	}
}


/////////////////////////////////////////////////////////////////////////
// okna dolne  2 - konstruktor
// parent - ojciec okna
// id		 - identyfikator okna
/////////////////////////////////////////////////////////////////////////
twnd2::twnd2(TWindow* parent,int id): TWindow(parent)
{
  Attr.Style |= WS_CHILD | WS_BORDER | WS_VISIBLE |WS_TABSTOP|WS_CLIPSIBLINGS ;
  Attr.Id = id ;
}

//////////////////////////////////////////////////////////////////////////
// ->Paint() - maluje okno grne
// dc - kontekst wywietlania w postaci TDC
// BOOL - nie wykorzystane
// to ostatnie : tak samo
//////////////////////////////////////////////////////////////////////////
void twnd2::Paint(TDC& dc, BOOL, TRect&)
{
 int i,cd,pos;
 int far* ptrd;
 char tab[50],str[20],e[10];
if(Mes.ptr!=NULL)
{
 ptrd = Mes.ptr ;
 switch(Mes.DMode)
  {
	 case 0	:sprintf(e," [10]");
				 break;
	 case 1	:sprintf(e," H");
				 break;
	 case 2	:sprintf(e," mV");
				 break;
  };
 if(Mes.Dtype==2)
  {
	 if(Mes.Single)
	  {
		 if(WPos[0]<=NUMSAMPL/*Mes.Samples*/)
		  {
			sprintf(tab,"Nr prbki : %d",WPos[0]);
			dc.TextOut(10,5,tab);
			ptrd = Mes.ptr ;
			pos = WPos[0]-1;
			cd=*(ptrd + pos);
			//preparujemy warto
			IValues.CodeToDisplay(1,cd,Mes.DMode,str);  //warto
			sprintf(tab,"K%d = %s%s",Mes.Chan,str,e);
			dc.TextOut(120,5,tab);
		  }
	  }
	 else //wiele kanaw
		{
		 sprintf(tab,"Nr prbki : %d",WPos[0]);
		 dc.TextOut(10,5,tab);
		 for(i=0;i<Mes.NumD;i++)
		  {
			//preparujemy warto
			IValues.CodeToDisplay(1,
			*(Mes.ptr + i +(Mes.GKan-1)*4 + (WPos[0]-1)*Mes.Chan),Mes.DMode,str);  //warto
			sprintf(tab,"K%d = %s%s",i+1+4*(Mes.GKan-1),str,e);
			//sprintf(tab,"K%d = %7.4f V",i+1,Mes.CodeToFloat(*(Mes.ptr +
			//(WPos[0]-1)*Mes.Chan + i)));
			dc.TextOut(120+i*130,5,tab);
		  }
		}
  }
}
}

///////////////////////////////////////////////////////////////////////////
// gwne okno prezentacji
///////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
// tablica komunikatw dla okna
//////////////////////////////////////////////////////////
DEFINE_RESPONSE_TABLE1(t011wnd, TWindow)
//{{t011MDIClientRSP_TBL_BEGIN}}
//{{t011MDIClientRSP_TBL_END}}
 EV_WM_LBUTTONDOWN,
END_RESPONSE_TABLE;

/////////////////////////////////////////////////////////////////////////
// gwne okno prezentacji - konstruktor
// parent 	- ojciec okna
// id       - identyfikator okna
/////////////////////////////////////////////////////////////////////////
t011wnd::t011wnd(TWindow* parent,int id): TWindow(parent)
{
  Attr.Style |= WS_CHILD | WS_BORDER | WS_VISIBLE |WS_TABSTOP|WS_CLIPSIBLINGS |
  WS_HSCROLL | WS_VSCROLL ;
  Attr.Id = id ;
  //definicja scrollbara
  Scroller = new TScroller(this, 10, 60, 80, 512);
  First = TRUE ;
}

//////////////////////////////////////////////////////////////////////////
// ->DrawAxis()
// rysuje osie przebiegu
// dc - kontekst wywietlania okna
// xs,ys - wsprzdne pocztku osi
//////////////////////////////////////////////////////////////////////////
void t011wnd::DrawAxis(TDC &dc,int xs,int ys)
{
 int  y,i,yy=30;
 char str[40];

 char tab[20];
 dc.SetMapMode(MM_TEXT);
 if(Mes.Single)  //pojedynczy
  {
	 //o pionowa
	 dc.MoveTo(xs,ys-50*Mes.Scale);
	 dc.LineTo(xs,ys+50*Mes.Scale);
	 //strzaka lewa
	 dc.MoveTo(xs-5,ys-50*Mes.Scale+5);
	 dc.LineTo(xs,ys-50*Mes.Scale);
	 //strzaka prawa
	 dc.MoveTo(xs+5,ys-50*Mes.Scale+5);
	 dc.LineTo(xs,ys-50*Mes.Scale);

	 //linia pozioma
	 if(Mes.Umin>=0) //0...x
	  {
		y=ys+50*Mes.Scale;
	  }
	 else           //+-x
	  {
		y=ys;
	  }
	 dc.MoveTo(xs,y);
	 dc.LineTo(xs+NUMSAMPL /*Mes.Samples*/,y);

	 //podpisujemy 0V
	 dc.TextOut(xs-20,y-8,"0V");
	 //podpisujemy kana
	 sprintf(tab,"Kana %d ",Mes.Chan);
	 dc.TextOut(xs-20,ys-50*Mes.Scale-20,tab);

  }
 else           //wielokanaowy
  {
	 for(i=0;i<Mes.NumD;i++)
	  {
		//o pionowa
		dc.MoveTo(xs,ys-50*Mes.Scale + i*(Mes.Scale*100 + yy));
		dc.LineTo(xs,ys+50*Mes.Scale + i*(Mes.Scale*100 + yy));
		//strzaka lewa
		dc.MoveTo(xs-5,ys-50*Mes.Scale+5+ i*(Mes.Scale*100 + yy));
		dc.LineTo(xs,ys-50*Mes.Scale+ i*(Mes.Scale*100 + yy));
		//strzaka prawa
		dc.MoveTo(xs+5,ys-50*Mes.Scale+5+ i*(Mes.Scale*100 + yy));
		dc.LineTo(xs,ys-50*Mes.Scale+ i*(Mes.Scale*100 + yy));

		//linia pozioma
		if(Mes.Umin>=0) //0...x
		 {
			y=ys+50*Mes.Scale+ i*(Mes.Scale*100 + yy);
		 }
		else           //+-x
		 {
		  y=ys+ i*(Mes.Scale*100 + yy);
		 }
		dc.MoveTo(xs,y);
		dc.LineTo(xs+NUMSAMPL/*Mes.Samples*/,y);

	  //podpisujemy 0V
	  dc.TextOut(xs-20,y-8,"0V");
	  sprintf(str,"Kana %d",i+1+(Mes.GKan-1)*4);
	  dc.TextOut(xs-20,ys-50*Mes.Scale-20+ i*(Mes.Scale*100 + yy),str);
	  }

  }
}

////////////////////////////////////////////////////////////////////////
// ->DrawPixels() - rysuje przebiegi czasowe w oknie
// dc - kontekst wywietlania okna wyraony w TDC
// xs,ys - pocztek wywietlania
///////////////////////////////////////////////////////////////////////
void t011wnd::DrawPixels(TDC &dc,int xs,int ys) //rysuje przebieg
{
  int i,j,k,l,y,yy=30;
  unsigned int cd;
if(Mes.ptr !=NULL)
 {
  if(Mes.Single) //jeden kana
	{
	 for(i=0;i<NUMSAMPL/*Mes.Samples*/;i++)
	  {
		 if((unsigned long)i==/*(unsigned long)Mes.Samples*/GSamples)
		  break;
		 cd=*(Mes.ptr + i);

		 y = (int)(ys+50.0*Mes.Scale - 100.0*Mes.Scale*(cd)/4096.0);
		 dc.SetPixel(xs+i,y,0);//czarny
	  }
	}
  else           //wiele
	{
	 //k=(NUMSAMPL)/Mes.Chan;
	 k=1024;
	 for(i=0;i<k;i++)
	  {
		l=i*Mes.Chan;
		for(j=0;j<Mes.NumD;j++)
		 {
		  if(Mes.ExMem==0)
			if(j+(Mes.GKan-1)*4+l >= 4096 )
			 break;
		  cd=*(Mes.ptr + j+(Mes.GKan-1)*4+l);

		  y = (int)(ys+50.0*Mes.Scale - 100.0*Mes.Scale*(cd)/4096.0)+
		  j*(Mes.Scale*100.0 + yy);
		  switch(j)
			{
			 case  0 : dc.SetPixel(xs+i,y,RGB(0,0,0));//czarny
						  break;
			 case  1 : dc.SetPixel(xs+i,y,RGB(0,0,0));//czerwony
						  break;
			 case  2 : dc.SetPixel(xs+i,y,RGB(0,0,0));//zielony
						  break;
			 case  3 : dc.SetPixel(xs+i,y,RGB(0,0,0));//niebieski
						  break;
			};
		 }
		if((unsigned long)l>=GSamples)
		  break;
	  }
	}
  }

}


//////////////////////////////////////////////////////////////////////
// ->EvLButtonDown()
// mysza lewa klik - uaktualnienie informacji o wskazanych prbkach
//////////////////////////////////////////////////////////////////////
void t011wnd::EvLButtonDown(UINT modKeys,TPoint &point)
{
 int xx = point.x - 30 + (UINT)Scroller->XPos *(UINT)Scroller->XUnit;

  if((Mes.Dtype==2) && (xx >0)) //grafika
	{
	 WPos[0]=point.x - 30 + (UINT)Scroller->XPos *(UINT)Scroller->XUnit ;
	 WWW[2]->Invalidate(TRUE);
	 WWW[2]->UpdateWindow();
	 //zapamitanie wsprzdnych
	 ppp.x = point.x ; ppp.y = point.y;

	}
}

///////////////////////////////////////////////////////////////////////////
// Paint() - odmalowanie gwnego okna danych programu
// dc - kontekst wywietlania
// b  - 1- odmalowanie tla
// r  - obszar do odmalowania
///////////////////////////////////////////////////////////////////////////
void t011wnd::Paint(TDC& dc, BOOL b, TRect &r)
{
  char tab[100],str[20],es[20];
  int i,j,k,l,m,code;
  static UINT pos =0 ;
  static TEXTMETRIC tm ;
  static int H , odst = 5;
  double fx;

  switch(Mes.DMode)
  {
	 case 0	:sprintf(es,"[10]");
				 break;
	 case 1	:sprintf(es,"[Hex]");
				 break;
	 case 2	:sprintf(es,"[mV]");
				 break;
  };
  //ustalenie parametrw scrolowania
  if(First)
	{
	 First = FALSE ;
	 dc.GetTextMetrics(tm);
	 H = tm.tmHeight + tm.tmExternalLeading ;
	 Scroller->SetUnits(10,H+odst);
	 Scroller->SetRange(60,40);
	 Scroller->XPage=1;
	 Scroller->YPage=10;
	 Scroller->SetPageSize();
	 Scroller->ScrollTo(0,0);
	}

  //funkcja wywietlania zawartoci okna
 if(Mes.ptr!=NULL)
 {
  switch(Mes.Dtype)
	{
	 case 			0 :
							break; //nic
	 case				1 :
							  if(Mes.Single)  //jeden
								{
								  k=NUMSAMPL/4;
								  for(i=0;i<k;i++)
								  {
									if((unsigned long)i>=/*(unsigned long)Mes.Samples*/GSamples)
										break;
									sprintf(tab,"%d",i+1);
									dc.TextOut(20,/*H+odst+*/i*(H+odst),tab);
									//preparujemy warto
									IValues.CodeToDisplay(1,*(Mes.ptr+i),Mes.DMode,str);
									sprintf(tab,"%s",str);
									//sprintf(tab,"%7.4f",Mes.CodeToFloat(*(Mes.ptr+i)));
									dc.TextOut(20+100,/*H+odst+*/i*(H+odst),tab);
								  }
								}
							  else				//wiele
								{
								 k=512;
								 int aaa=0;
								 for(i=0;i<k;i++)
								  {
									sprintf(tab,"%d",i+1);
									dc.TextOut(20,H+odst+i*(H+odst),tab);
									l=i*Mes.Chan;
									for(j=0;j<Mes.NumD;j++)
									 {
									  if((unsigned long)l>=/*(unsigned long)Mes.Samples*/GSamples)
										break;
									  //preparujemy warto
									  if(Mes.ExMem==0)
										if(j+(Mes.GKan-1)*4+l >= 4096 )
										 {
										  aaa=1;
										  break;
										 }
									  IValues.CodeToDisplay(1,*(Mes.ptr+j+(Mes.GKan-1)*4+l),Mes.DMode,str);
									  sprintf(tab,"%s",str);
									  //sprintf(tab,"%7.4f",Mes.CodeToFloat(*(Mes.ptr+j+l)));
									  dc.TextOut(20+100*(j+1),H+odst+i*(H+odst),tab);
									 }
									if(aaa==1)
									 break;
								  }
								}
							break; //tekst
	 case				2 :
							DrawAxis(dc,30,Mes.Scale*50+50);
							DrawPixels(dc,30,Mes.Scale*50+50);
							break ;//grafika
	 case			   3:
							if(Mes.ExMem==0)
							 sprintf(tab,"Parametry statystyczne zmierzonego przebiegu - dane z bufora programu :");
							else
							 sprintf(tab,"Parametry statystyczne zmierzonego przebiegu - dane z bufora pamici rozszerzonej :");
							dc.TextOut(20,5,tab);
							sprintf(tab,"Umin%s",es);
							dc.TextOut(120,30,tab);
							sprintf(tab,"Umax%s",es);
							dc.TextOut(220,30,tab);
							sprintf(tab,"Ur%s",es);
							dc.TextOut(320,30,tab);
							sprintf(tab,"Odchylenie st.[mV]");
							dc.TextOut(400,30,tab);
							dc.TextOut(540,30,"Odchylenie st.[LSB]");
							if(Mes.Single)
							 {
							  sprintf(tab,"Kana %d",Mes.Chan);
							  dc.TextOut(20,30+H+odst,tab);

							  code=IValues.FloatToCode(1,*(Mes.TMin));
							  IValues.CodeToDisplay(1,code,Mes.DMode,str);
							  sprintf(tab,"%s",str);
							  dc.TextOut(140,30+H+odst,tab);

							  code=IValues.FloatToCode(1,*(Mes.TMax));
							  IValues.CodeToDisplay(1,code,Mes.DMode,str);
							  sprintf(tab,"%s",str);
							  dc.TextOut(240,30+H+odst,tab);

							  code=IValues.FloatToCode(1,*(Mes.TMean));
							  IValues.CodeToDisplay(1,code,Mes.DMode,str,1);
							  sprintf(tab,"%s",str);
							  dc.TextOut(340,30+H+odst,tab);

							  sprintf(tab,"%.2f",(*(Mes.TStv))*1000.0);
							  dc.TextOut(420,30+H+odst,tab);

							  fx=(double)(*(Mes.TStv));
							  fx=(fx/((double)IValues.ACV2-(double)IValues.ACV1))*4096.0;
							  sprintf(tab,"%.2f",(float)fx);
							  dc.TextOut(560,30+H+odst,tab);

							 }
							else
							 {
							  for(i=0;i<Mes.Chan;i++)
								{
								 sprintf(tab,"Kana %d",i+1);
								 dc.TextOut(20,30+(H+odst)*(i+1),tab);

								 code=IValues.FloatToCode(1,*(Mes.TMin+i));
								 IValues.CodeToDisplay(1,code,Mes.DMode,str);
								 sprintf(tab,"%s",str);
								 dc.TextOut(140,30+(H+odst)*(i+1),tab);

								 code=IValues.FloatToCode(1,*(Mes.TMax+i));
								 IValues.CodeToDisplay(1,code,Mes.DMode,str);
								 sprintf(tab,"%s",str);
								 dc.TextOut(240,30+(H+odst)*(i+1),tab);

								 code=IValues.FloatToCode(1,*(Mes.TMean+i));
								 IValues.CodeToDisplay(1,code,Mes.DMode,str,1);
								 sprintf(tab,"%s",str);
								 dc.TextOut(340,30+(H+odst)*(i+1),tab);

								 sprintf(tab,"%.2f",(*(Mes.TStv+i))*1000.0);
								 dc.TextOut(420,30+(H+odst)*(i+1),tab);

								 fx=(double)(*(Mes.TStv+i));
								 fx=(fx/((double)IValues.ACV2-(double)IValues.ACV1))*4096.0;
								 sprintf(tab,"%.2f",(float)fx);
								 dc.TextOut(560,30+(H+odst)*(i+1),tab);
								}
							 }
							break; //statystyka
	}
 }
}

//----------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////
// pusty konstruktor klasy aplikacji programu
///////////////////////////////////////////////////////////////////////
t011App::t011App():TApplication("Test bibliotek DLL dla kart LC")
{

}


////////////////////////////////////////////////////////////////////////
// ->CommonFun()
// Wykonanie standardowych czynnoci zwizanych z zaadowaniem DLL a do
// pamici : ustawia pola struktur , robi LC0_ModuleInit , czyta konfiguracj
// moduw , instaluje obsug CTRL - Break
////////////////////////////////////////////////////////////////////////
void t011App::CommonFun()
{
 ///////////////////////////////////////////////////////////////////////////
 // wykonanie podst. funkcji LC
 ///////////////////////////////////////////////////////////////////////////
 int fx=0xff,tx=0xff,sx=0xff,i;
 unsigned char maska[] = {1,2,4,8};

 (*GetTotalConfiguration)(&STotal);
 SBreak.LC0_CODE = BREAK ;
 SBreak.LC0_BMODE = LC0_BREAK_INST,NULL;

 for(i=0;i<4;i++)
	{
	 SModuleInfo.LC0_MMODULE = i+1;
	 (*GetModuleConfiguration)(&SModuleInfo);
	 if(SModuleInfo.LC0_STATUS==LC0_OK)
	  {
		SModuleInit.LC0_IMODULE = maska[i];
		(*ModuleInit)(&SModuleInit);
		if(fx==0xff)
		 {
		  if(SModuleInit.LC0_STATUS==LC0_IS_INIT)
			{
			 if(sx==0xff)
			  sx=i;
			}
		  if(SModuleInit.LC0_STATUS==LC0_OK)
			{
			 fx=i;
			 SetDefModule(i); //ustawia numery modulow A,B,C,D

			}
		 }
	  }
	 if(SModuleInfo.LC0_STATUS==LC0_BAD_CONFIG)
	  {
		 if(tx==0xff)
		  tx=i;
	  }
	}
  if(fx==0xff)	//bd inicjacji
	{
	 if(sx!=0xff) //IS_INIT
	  {
		SetDefModule(sx);
		SModuleInfo.LC0_MMODULE =sx+1;
	  }
	 else
	  {
		if(tx!=0xff) //bad config
		 {
		  SetDefModule(tx);
			SModuleInfo.LC0_MMODULE =tx+1;
		 }
		else //no modules
		 {
		  SetDefModule(0); //modu A
		  SModuleInfo.LC0_MMODULE =1;
		 }
	  }
	}
  else
	SModuleInfo.LC0_MMODULE =fx+1;
	SModuleInfo.LC0_MBASE2 = 0;
  (*GetModuleConfiguration)(&SModuleInfo);
  ////////////////////////////////////////////////////////
  // ustawia flag Mes.ACKod dla check box-w
  ////////////////////////////////////////////////////////
  if((SModuleInfo.LC0_MBASE2 & 0x0008)!=0)
	Mes.ACKod =1;
  else
	Mes.ACKod = 0;
  //////////////////////////////////////////////////////////
  //instalacja BREAK
  (*Break)(&SBreak);

  SetDefaultPar();

}
//////////////////////////////////////////////////////////////////////////////
// tworzenie control baru
//////////////////////////////////////////////////////////////////////////////
const TDecoratedFrame::TLocation Location[] = {
  TDecoratedFrame::Top,
  TDecoratedFrame::Left,
  TDecoratedFrame::Right
};


/////////////////////////////////////////////////////////////////////////////
// BuildControlBar - tworzy nowy control bar
// parent - ojciec dla control baru
// direction - gdzie ma byc zbudowany
// Rezultat :
//  wskanik do utworzonego control-baru lub NULL
/////////////////////////////////////////////////////////////////////////////
static TControlBar*
BuildControlBar(TWindow* parent, TControlBar::TTileDirection direction)
{
  TControlBar* cb = new TControlBar(parent, direction);
  //SYSTEM
  cb->Insert(*new TButtonGadget(CM_DRIVER, CM_DRIVER));
  cb->Insert(*new TButtonGadget(IDM_CLEAR, IDM_CLEAR));
  cb->Insert(*new TSeparatorGadget(10));

  //uytki
  cb->Insert(*new TButtonGadget(CM_KONFIGURACJA, CM_KONFIGURACJA));
  cb->Insert(*new TButtonGadget(IDC_WEAC, IDC_WEAC));
  cb->Insert(*new TButtonGadget(IDC_GEN, IDC_GEN));
  cb->Insert(*new TButtonGadget(IDC_WEWYC, IDC_WEWYC));
  cb->Insert(*new TButtonGadget(IDM_MON1, IDM_MON1));
  cb->Insert(*new TButtonGadget(IDM_MON2, IDM_MON2));
  cb->Insert(*new TButtonGadget(IDC_STATYSTYKA, IDC_STATYSTYKA));
  cb->Insert(*new TSeparatorGadget(10));

  //debugger
  cb->Insert(*new TButtonGadget(IDM_FUNCTIONS, IDM_FUNCTIONS));
  cb->Insert(*new TButtonGadget(IDM_MEAS, IDM_MEAS));
  cb->Insert(*new TButtonGadget(IDM_CONFIG, IDM_CONFIG));
  cb->Insert(*new TSeparatorGadget(10));

  //POMIARY
  cb->Insert(*new TButtonGadget(IDM_PAR, IDM_PAR));
  cb->Insert(*new TButtonGadget(IDM_GRAPH,IDM_GRAPH));
  cb->Insert(*new TButtonGadget(IDM_TEKST, IDM_TEKST));
  cb->Insert(*new TSeparatorGadget(10));

  //HELP
  cb->Insert(*new TButtonGadget(CM_HELPABOUT, CM_HELPABOUT));

  //cb->Attr.Style |= WS_CLIPSIBLINGS;    // since toolbar may move around
  cb->Attr.Id = IDW_TOOLBAR;
  return cb;
}


//////////////////////////////////////////////////////////////////////////////
// ->InitMainWindow
// inicjacja gwnego okna programu
//////////////////////////////////////////////////////////////////////////////
void t011App::InitMainWindow()
{
  TLayoutWindow *tlw;
  TDecoratedFrame *frame ;
  char tab[20];
  int i ;

  EnableCtl3d();
  EnableBWCC();
  Mes.Dtype = 0 ;//nic nie wywietlamy
  Mes.ExMem = TRUE ;
  Mes.ptr = NULL ;
  WPos[0]=1;
  MON1=FALSE;
  MON2=FALSE;
  nonend = TRUE ;

  tlw=new t011Layout(0);
  TMDIClient *Client = (TMDIClient *)tlw ;
  frame = new TDecoratedMDIFrame("Test bibliotek DLL dla kart AMBEX serii LC ",MY_MENU, *Client /*tlw*/, TRUE);
  MW = (TWindow*)MainWindow ;
  MainWindow = frame;

  sb = new TStatusBar(0, TGadget::Recessed,
			  TStatusBar::CapsLock | TStatusBar::NumLock | TStatusBar::Overtype);

  frame->Insert(*sb, TDecoratedFrame::Bottom);
  HintMode = TGadgetWindow::PressHints;
  ControlBar = BuildControlBar(frame, TControlBar::Horizontal);
  ControlBar->SetHintMode(TGadgetWindow::EnterHints);
  frame->Insert(*ControlBar, Location[0]);

  MainWindow->SetIcon(this, IDI_APP);
  hInst = HInstance ;

  //////////////////////////////////////////////////////////////////////////
  // wybr DLL-a
  ////////////////////////////////////////////////////////////////////////////
 if(checkdriver()==0)
	{
	  ::MessageBeep(0);
	  ::MessageBox(GetActiveWindow(),"Nie odnaleziono adnej biblioteki DLL do kart LC ."
	  ,"Bd",MB_OK);
	  ::PostQuitMessage(1);
	}
  else    //tworzyny dialog lub info
	{
	 if(DLLSingle !=1)
	  {
		// wybr pierwszego driver'a z listy
		for(i=0;i<DLLNR;i++)
		  {
			 if(DLLAct[i]==1)
			  {
				 strcpy(CurrentDLL,DLLDrivers[i]);
				 break ;
			  }
		  }
	  }     //gdy 1-a to bez informacji

	  //wczytujemy dynamicznie wybran bibliotek
	  if(LoadDriver()==FALSE)
		{
		  ::MessageBeep(0);
		  sprintf(tab,"Bd przy adowaniu biblioteki %s .",CurrentDLL);
		  ::MessageBox(GetActiveWindow(),tab,"Bd",MB_OK);
		  ::PostQuitMessage(1);
		  IsDriver = FALSE ;
		  return ;
		}
	  else
		IsDriver = TRUE ;

		///////////////////////////////////////////////////////////////////////////
		// wykonanie podst. funkcji
		///////////////////////////////////////////////////////////////////////////
		CommonFun();
	}
}

///////////////////////////////////////////////////////////////////////
// destruktor klasy aplikacji : wyinstalowanie DLL-a z pamici
///////////////////////////////////////////////////////////////////////
t011App::~t011App ()
{
	 // INSERT>> Your destructor code here.
	 lc0_leave		SLeave;
	 nonend = FALSE ;
	 //zwolnienie biblioteki
	 if(IsDriver)
	  {
		(*Leave)(&SLeave);
		::FreeLibrary(hDriverInst);
	  }
}

//////////////////////////////////////////////////////////////////////////
// OnExit - menu EXIT
//////////////////////////////////////////////////////////////////////////
void t011App::OnExit()
{
  nonend = FALSE ;
  if(MON1==TRUE)
	monptr1->KillTimer(1);
  if(MON2==TRUE)
	monptr2->KillTimer(2);

}

//////////////////////////////////////////////////////////////////////////
// OnDriver - menu Biblioteka DLL
//////////////////////////////////////////////////////////////////////////
void t011App::OnDriver()
{
 TD4 *td4 ;
 char name[20];
 lc0_leave		SLeave;

 strcpy(name,CurrentDLL);
 td4 = new TD4(MainWindow);
 td4->Execute();
 if(strcmp(name,CurrentDLL)!=0)
  {
	//czycimy okna i procesy
	//nonend = FALSE ;
	Mes.ExMem = TRUE ;
	SetDefaultPar();
	Mes.Dtype = 0;
	Mes.ProgBufEnable=0;
	Mes.ExBufEnable=0;
	PSamples = 0;
	MyUpdate(FALSE);
	if(MON1==TRUE)
	 {
	  monptr1->KillTimer(1);
	  monptr1->Destroy(0);
	 }
	if(MON2==TRUE)
	 {
	  monptr2->KillTimer(2);
	  monptr2->Destroy(0);
	 }

	/////////////////////////////////////////////////////////////////
	// wyrzucamy okienka
	/////////////////////////////////////////////////////////////////
	if(TD8::dWindow != NULL)
	 {
	  TD8::dWindow->Destroy() ;
	  TD8::dWindow = NULL;
	  delete (TD8*)(TD8::dWindow);
	 }
	if(TD5::dWindow != NULL)
	 {
	  TD5::dWindow->Destroy() ;
	  TD5::dWindow = NULL;
	  delete (TD5*)(TD5::dWindow);
	 }

	if(TD7::dWindow != NULL)
	 {
	  TD7::dWindow->Destroy() ;
	  TD7::dWindow = NULL;
	  delete (TD7*)(TD7::dWindow);
	 }

	 if(TTestD::dWindow != NULL)
	 {
	  TTestD::dWindow->Destroy() ;
	  TTestD::dWindow = NULL;
	  delete (TTestD*)(TTestD::dWindow);
	 }

	if(TParMD::dWindow != NULL)
	 {
	  TParMD::dWindow->Destroy() ;
	  TParMD::dWindow = NULL;
	  delete (TParMD*)(TParMD::dWindow);
	 }

	(*Leave)(&SLeave);
	FreeInstances()  ;
	::FreeLibrary(hDriverInst);
	//nowa biblioteka
	//wczytujemy dynamicznie wybran bibliotek
	if(LoadDriver()==FALSE)
	 {
		  ::MessageBeep(0);
		  sprintf(name,"Bd przy adowaniu biblioteki %s .",CurrentDLL);
		  ::MessageBox(GetActiveWindow(),name,"Bd",MB_OK);
		  ::PostQuitMessage(1);
		  IsDriver = FALSE ;
		  return ;
	 }
	else
	 {
	  Mes.ExMem = TRUE ;
	  SetDefaultPar();
	  Mes.Dtype = 0;
	  MyUpdate(FALSE);
	  CommonFun();
	  SAnalogIn.LC0_AMEMA = SModuleInfo.LC0_MMEMA ;
	 }

  }

  delete td4;
}


//////////////////////////////////////////////////////////////////////////
// OnWeAC - menu Wejscie A/C
//////////////////////////////////////////////////////////////////////////
void t011App::OnWeAC()
{
  static TD8 *td8=NULL ;

  if(TD8::dWindow==NULL)
	{
	 if(td8!=NULL)
	  delete td8 ;
	 td8 = new TD8(MainWindow);
	 td8->Create();
	 //TD8(MainWindow).Create();
	}
  else
	{
	 (TD8::dWindow)->SetActiveWindow();
	 (TD8::dWindow)->ShowWindow(SW_NORMAL);
	}
}

//////////////////////////////////////////////////////////////////////////
// OnWeWyC - menu Wejcie wyjcie TTL
//////////////////////////////////////////////////////////////////////////
void t011App::OnWeWyC()
{
 static TD5 *td5=NULL ;
 if(TD5::dWindow==NULL)
  {
	if(td5!=NULL)
	  delete td5 ;
	td5 = new TD5(MainWindow);
	td5->Create();
  }
 else
  {
	(TD5::dWindow)->SetActiveWindow();
	(TD5::dWindow)->ShowWindow(SW_NORMAL);
  }
}

//////////////////////////////////////////////////////////////////////////
// OnClear - menu Zerowanie DLL
//////////////////////////////////////////////////////////////////////////
void t011App::OnClear()
{
 lc0_init SInit={MODULE_INIT,0,0,0};
 if(GlobalInfo.Module==0)
	GlobalInfo.Module =1;
 switch(GlobalInfo.Module)
	{
	  case 1 :SInit.LC0_IMODULE=1;
				 break;
	  case 2 :SInit.LC0_IMODULE=2;
				 break;
	  case 3 :SInit.LC0_IMODULE=4;
				 break;
	  case 4 :SInit.LC0_IMODULE=8;
				 break;
	};
  (*ModuleInit)(&SInit);
  if(SInit.LC0_STATUS == LC0_OK)
	::MessageBeep(0);
  if(SInit.LC0_STATUS == LC0_IS_INIT)
	MainWindow->MessageBox("Modu nie moe by wyzerowany , gdy zosta zainicjowany przez inne zadanie .",
	"Informacja");
}

//////////////////////////////////////////////////////////////////////////
// OnStatystyka - menu Satystyka
//////////////////////////////////////////////////////////////////////////
void t011App::OnStatystyka()
{
 TD10 *td10 ;
 int x=1;
 if(Mes.Dtype==0)
  x=0;
 if((Mes.ExMem)==1 && (Mes.ExBufEnable==0))
  x=0;
 if((Mes.ExMem)==0 && (Mes.ProgBufEnable==0))
  x=0;
 if(x==0)
  {
	MainWindow->MessageBox("Brak danych w aktywnym buforze .","LCWIN info");
	return;
  }
 td10 = new TD10(MainWindow);
 td10->Execute();
 WWW[3]->Scroller->ScrollTo(0,0);
 if(Mes.Dtype==3)
  {
	if(OldDtype==1)
	 OldDtype = 2;
	if(OldDtype==2)
	OldDtype = 1;
	MyUpdate(TRUE);
  }
 delete td10;
}

////////////////////////////////////////////////////////
// OWLMAIN
//////////////////////////////////////////////////////
int OwlMain(int /*argc*/, char* /*argv*/ [])
{
  return t011App().Run();
}

/////////////////////////////////////////////////////////////
// OnTestConfig - menu Konfiguracja DLL
/////////////////////////////////////////////////////////////
void t011App::OnTestConfig ()
{
	 // INSERT>> Your code here.

}

//////////////////////////////////////////////////////////////////////////
// OnMeasure - menu pomiar A/C
//////////////////////////////////////////////////////////////////////////
void t011App::OnMeasure()
{

 char err;
 MSG mes ;
 char er ;
 HCURSOR hcurSave;

 hcurSave = ::SetCursor(::LoadCursor(NULL, IDC_WAIT));
 //wykonujemy pomiar LC0_AnalogIn
 //Pom->EnableWindow(FALSE);
 int zx=0;
 SModuleInfo.LC0_MMODULE = SAnalogIn.LC0_AMODULE;
 (*GetModuleConfiguration)(&SModuleInfo);
 SAnalogIn.LC0_AMEMA=SModuleInfo.LC0_MMEMA;
 (*AnalogInput)(&SAnalogIn);
 Mes.TranslateBuf(&SAnalogIn,&SModuleInfo);

 er = SAnalogIn.LC0_STATUS ;
 if((SAnalogIn.LC0_STATUS==LC0_OK) || (SAnalogIn.LC0_STATUS == LC0_OTHER_LEN)
 || (SAnalogIn.LC0_STATUS == LC0_BROKEN))
  {
	SGAnalogIn = SAnalogIn;
	GSamples = /*Samples*/ SAnalogIn.LC0_ARMNUM  ;
	if((SAnalogIn.LC0_AMODE & LC0_MOD_EXT_MEM)!=0)
	 zx=1; //pami rozszerzona
	if((SAnalogIn.LC0_AMODE & LC0_MOD_EXT_MEM)==0)
	 zx=2;  //pami podstawowa
	if(((SAnalogIn.LC0_AMODE & LC0_MOD_EXT_MEM)!=0)&&
	((SAnalogIn.LC0_AMODE & LC0_MOD_MEM_W)!=0))
	zx=3; //pami podstawowa
	if(zx!=0)
	 {
	  if(zx>1)
		{
		 Mes.ProgBufEnable=TRUE;
		 //Mes.ExBufEnable=FALSE;
		 if(zx==2)
		  PSamples=SAnalogIn.LC0_ARMNUM ;
		 else
		  PSamples=SAnalogIn.LC0_ARLEN;
		 }
		if(zx!=2)
		 {
		  //Mes.ProgBufEnable=FALSE;
		  Mes.ExBufEnable=TRUE;
		 }
	  if(((Mes.ExMem==1) && (zx!=2)) || ((Mes.ExMem==0)&&(zx!=0)))
		{
		 if((Mes.Dtype==0) || (Mes.Dtype ==3))
		  Mes.Dtype = 2;
		 MyUpdate(TRUE);
		}
	  if(SAnalogIn.LC0_STATUS == LC0_OTHER_LEN)
		{
		 MError(SAnalogIn.LC0_STATUS);
		 SAnalogIn.LC0_STATUS = LC0_OK ;
		}
	 }
	::MessageBeep(-1);
  }
 else
  {
	MError(SAnalogIn.LC0_STATUS);
	SAnalogIn.LC0_STATUS = LC0_OK ;
  }
 //Pom->EnableWindow(TRUE);
 ::SetCursor(hcurSave);
}


//////////////////////////////////////////////////////////////////////////
// CmHelpAbout - menu O programie
//////////////////////////////////////////////////////////////////////////
void t011App::CmHelpAbout ()
{

	 t011AboutDlg(MainWindow).Execute();
	 PaintAll();
}

//////////////////////////////////////////////////////////////////////////
// OnTestFunction - menu Funkcje Biblioteki DLL
//////////////////////////////////////////////////////////////////////////
void t011App::OnTestFunction ()
{
	 // INSERT>> Your code here.
	static TTestD *Dptr=NULL ;
	if(TTestD::dWindow==NULL)
	 {
	  if(Dptr!=NULL)
		delete Dptr ;
	  Dptr = new TTestD(MainWindow)   ;
	  Dptr->Create();
	 }
	else
	 {
	  (TTestD::dWindow)->SetActiveWindow();
	  (TTestD::dWindow)->ShowWindow(SW_NORMAL);
	 }
	PaintAll();
}



//////////////////////////////////////////////////////////////////////////
// OnGen - menu Generator przebiegu
//////////////////////////////////////////////////////////////////////////
void t011App::OnGen ()
{
	 // INSERT>> Your code here.
	static TD7 *td7=NULL ;
	if(TD7::dWindow==NULL)
	 {
	  if(td7!=NULL)
		delete td7 ;
	  td7 = new TD7(MainWindow)   ;
	  td7->Create();
	 }
	else
	 {
	  (TD7::dWindow)->SetActiveWindow();
	  (TD7::dWindow)->ShowWindow(SW_NORMAL);
	 }

}

//////////////////////////////////////////////////////////////////////////
// OnMeasurePar - menu Parametry pomiaru
//////////////////////////////////////////////////////////////////////////
void t011App::OnMeasurePar ()
{
	 // INSERT>> Your code here.
	static TParMD *Dptr=NULL ;
	if(TParMD::dWindow==NULL)
	 {
	  if(Dptr!=NULL)
		delete Dptr ;
	  Dptr = new TParMD(MainWindow)   ;
	  Dptr->Create();
	 }
	else
	 {
	  (TParMD::dWindow)->SetActiveWindow();
	  (TParMD::dWindow)->ShowWindow(SW_NORMAL);
	 }

}

//////////////////////////////////////////////////////////////////////////
// OnInfo - menu Informacje
//////////////////////////////////////////////////////////////////////////
void t011App::OnInfo()
{
  TD9 *Dptr ;

  Dptr = new TD9(MainWindow)   ;
  Dptr->Execute();
  delete Dptr ;
}

//////////////////////////////////////////////////////////////////////////
// OnMeasureGraph - menu Przegdanie graficzne
//////////////////////////////////////////////////////////////////////////
void t011App::OnMeasureGraph()
{
 char er;
	 if(Mes.Dtype==0)
	  return;
	 PaintAll();
	 er=Mes.GetParam();
	 if(er!=LC0_OK)
	  MError(er);
	 else						//obrazowanie
	  {
		//OldDtype = 1;
		Mes.Dtype = 2;
		// ustawienie czuoci

		// opis staych
		if(OldDtype!=2 )     //
		 {
			((twnd0*)(WWW[0]))->ClearAll();

		 }
		OldDtype = 2;  //grafika
		WWW[0]->Invalidate(TRUE);
		WWW[0]->UpdateWindow();   //okno prezentacji
		WWW[2]->Invalidate(TRUE);
		WWW[2]->UpdateWindow();   //okno prezentacji
		WWW[3]->Invalidate(TRUE);
		WWW[3]->UpdateWindow();   //okno prezentacji

		// dodatkowa akcja na skrollbarach
		WWW[3]->Scroller->SetRange(60,40);
		WWW[3]->Scroller->ScrollTo(0,0);
		WPos[0]=1;
		WSampClear()  ;
	  }
}

//////////////////////////////////////////////////////////////////////////
// OnMEasureTekst - menu Przegldanie tekstowe
//////////////////////////////////////////////////////////////////////////
void t011App::OnMeasureTekst ()
{
	 // INSERT>> Your code here.
	 // nie wykonujemy pomiaru tylko obrazowanie na nowo
	 char er;
	 if(Mes.Dtype==0)
	  return;
	 PaintAll();
	 er=Mes.GetParam();
	 if(er!=LC0_OK)
	  MError(er);
	 else						//obrazowanie
	  {
		//OldDtype = 1;
		Mes.Dtype = 1;
		// ustawienie czuoci

		// opis staych
		if(OldDtype!=1)     //
		  {
			((twnd0*)(WWW[0]))->Opis();

		 }
		OldDtype = 1;  //tekst
		WWW[0]->Invalidate(TRUE);
		WWW[0]->UpdateWindow();   //okno prezentacji
		WWW[2]->Invalidate(TRUE);
		WWW[2]->UpdateWindow();   //okno prezentacji
		WWW[3]->Invalidate(TRUE);
		WWW[3]->UpdateWindow();   //okno prezentacji

		// dodatkowa akcja na skrollbarach
		WWW[3]->Scroller->SetRange(60,1024);
		WWW[3]->Scroller->ScrollTo(0,0);
		WPos[0]=1;
	  }
}

/////////////////////////////////////////////////////////////
// badziew
//////////////////////////////////////////////////////////////
void t011App::OnMeasureTekstEn (TCommandEnabler &tce)
{
	 // INSERT>> Your code here.
}


void t011App::OnMDIFileOpen ()
{
	 // INSERT>> Your code here.

}
/////////// koniec badziewa ///////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// OnMonitor1 - menu Monitor kanaowy 1
//////////////////////////////////////////////////////////////////////////
void t011App::OnMonitor1()
{

 TMenu MN(MainWindow->HWindow);
  if(MON1==FALSE)
	{
	 monptr1 = new tmonwnd(MainWindow,1,"Monitor 1 kanau A/C");
	 if(monptr1->Go==FALSE) //bd
	  {
		//((tpwnd*)(WWW[1]))->Mon1->EnableWindow(TRUE);
	  }
	 else
	  {
		monptr1->Create();
		monptr1->ShowWindow(SW_SHOW);
		((TFrameWindow *)(monptr1))->SetIcon(this, IDI_MEASURE);
		monptr1->SetTimer(1,TPER);
		MON1=TRUE;
		MN.CheckMenuItem(IDM_MON1,MF_CHECKED|MF_GRAYED|MF_DISABLED);
	  }
	}
  else
	{
	 monptr1->SetActiveWindow();
	 monptr1->ShowWindow(SW_NORMAL);
	}

}

//////////////////////////////////////////////////////////////////////////
// OnMonitor2 - menu Monitor kanaowy 2
//////////////////////////////////////////////////////////////////////////
void t011App::OnMonitor2()
{

 //stworzenie i wywietlenie okna monitora
 TMenu MN(MainWindow->HWindow);
 if(MON2==FALSE)
  {
	monptr2 = new tmonwnd(MainWindow,2,"Monitor 2 kanau A/C");
	if(monptr2->Go==FALSE) //bd
	 {
	  //((tpwnd*)(WWW[1]))->Mon2->EnableWindow(TRUE);
	 }
	else
	 {
	  monptr2->Create();
	  monptr2->ShowWindow(SW_SHOW);
	  monptr2->SetIcon(this, IDI_MEASURE);
	  monptr2->SetTimer(2,TPER);
	  MON2=TRUE;
	  MN.CheckMenuItem(IDM_MON2,MF_CHECKED|MF_GRAYED|MF_DISABLED);
	 }
  }
 else
  {
	 monptr2->SetActiveWindow();
	 monptr2->ShowWindow(SW_NORMAL);
  }
}

///////////////////////////////////////////////////////////////////////////
// MError()
// info o bdach funkcji DLL
// LCCode - kod statusu funkcji z DLL-a
//////////////////////////////////////////////////////////////////////////
void MError(char LCCode)
{
  char tab[60];
  if(LCCode !=0)
	{
	 if(LCCode<0)
	  sprintf(tab,"Bd wywoania funkcji z biblioteki DLL : %s",DriverErrors[-LCCode-1]);
	 else
	  sprintf(tab,"Bd wywoania funkcji z biblioteki DLL : %s",DriverWarnings[LCCode-1]);
	 ::MessageBeep(-1);
	 ::MessageBox(::GetActiveWindow(),tab,"Info",MB_OK);
	}
}

//////////////////////////////////////////////////////////////////////////
// PaintAll() - odmalowanie wszystkich okien programu
//////////////////////////////////////////////////////////////////////////
void PaintAll()
{
 int i ;
  for(i=0;i<3;i++)
	{
	 if(i!=1)
	  {
		WWW[i]->Invalidate(TRUE);
		WWW[i]->UpdateWindow();   //okno prezentacji
	  }
	}
}

//////////////////////////////////////////////////////////////////////////
// MyUpdate - odmalowanie okna prezentacji i opisw
// mes - 1 gdy w przypadku bedu ma by wyswietlany odpowiedni komunikat
//////////////////////////////////////////////////////////////////////////
void MyUpdate(BOOL mes)
{
 char er ;
 if(OldDtype==0)
  return;
	 int i;
	 //parametry do wywietlania
	 IValues.SetValues(1,SGAnalogIn.LC0_AMODULE,1);
	 er=Mes.GetParam();
	 if(er!=LC0_OK)
	  {
		if(mes)
		 MError(er);
	  }
	 else						//obrazowanie
	  {
		WWW[3]->Invalidate(TRUE);
		WWW[3]->UpdateWindow();   //okno prezentacji
		// opis staych
		if(OldDtype==1)
		 {
			((twnd0*)(WWW[0]))->Opis();

		 }
		if(OldDtype==2)
		 {
			((twnd0*)(WWW[0]))->ClearAll();
		 }
		WWW[0]->Invalidate(TRUE);
		WWW[0]->UpdateWindow();
	  }
}


void WSampClear()
{
 int i;
 WPos[0]=1;
}

////////////////////////////////////////////////////////////////////////
// okno monitora kanau
////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////
// tablica komunikatw dla okna
//////////////////////////////////////////////////////////
DEFINE_RESPONSE_TABLE1(tmonwnd, TFrameWindow)
 EV_WM_TIMER,
END_RESPONSE_TABLE;

//////////////////////////////////////////////////////////////////////////
// konstruktor klasy monitora kanaowego
// parent - ojciec okna
// monid  - identyfikator okna
// title - tytu okna
//////////////////////////////////////////////////////////////////////////
tmonwnd::tmonwnd(TWindow *parent,int monid,char *title):/*TWindow*/TFrameWindow(parent,title)
 {
	WNDCLASS wc;
	char far *x;
	x= GetClassName();

  Attr.Style |= /*WS_CHILD |*/ WS_VISIBLE |WS_TABSTOP|WS_POPUP|WS_SYSMENU|
  WS_THICKFRAME|WS_CAPTION | WS_MINIMIZEBOX ;
  MID = monid;
  if(MID==1)
	{
	 Attr.X = 100;
	 Attr.Y = 100;
	 Attr.W = 400;
	 Attr.H = 350;
	}
  else
	{
	 Attr.X = 120;
	 Attr.Y = 120;
	 Attr.W = 400;
	 Attr.H = 350;
	}

  Go=TRUE;
  first = TRUE;
  sampl = Mes.MonSamp ;
  if(MID==1)
	{
	 chan = Mes.MonChan1;
	 SAnIn.LC0_AMODULE=Mes.Mod1;
	}
  else
	{
	 chan = Mes.MonChan2;
	 SAnIn.LC0_AMODULE=Mes.Mod2;
	}
  //malloc
  buf = (int far *)malloc((sampl+10)*2);
  if(buf==NULL)
	{
	 Go=FALSE ;
	 return;
	}

  //ustalamy parametry struktury AnalogIn

  SAnIn.LC0_ANUM=1;
  SAnIn.LC0_AMODE=15;  //analiza parametrw

  SAnIn.LC0_APER=1000; //100 us
  SAnIn.LC0_ACHAN=128+chan;
  SAnIn.LC0_AADDR =buf ;
  if(strcmp(CurrentDLL,"LC1016A.DLL") != 0) //nie 10-a jeden pomiar i cay blok
	SAnIn.LC0_ALEN =sampl+2 ;
  else
	SAnIn.LC0_ALEN =1;

  // tryb blokowy dla LC-020-3212 dodac
  if(strcmp(CurrentDLL,"LC2032A.DLL") == 0) //praca przez DMA
	 SAnIn.LC0_AMODE |= LC0_MOD_BLOCK ;


  SAnIn.LC0_ASTST = LC0_SIMMED ;
  SAnIn.LC0_ASTOP.samples = sampl ;

  // inicjacja ACKod
  ACKod =0;
  // informacje dotyczce moduu
  SModule.LC0_MMODULE = SAnIn.LC0_AMODULE ;
  (*GetModuleConfiguration)(&SModule);
  if(SModule.LC0_STATUS == LC0_OK)
	{
	  if((SModule.LC0_MBASE2 & 0x0008)!=0)
		ACKod = 1;
	}

  //prbny pomiar
  (*AnalogInput)(&SAnIn);
  if((SAnIn.LC0_STATUS==LC0_OK) || (SAnIn.LC0_STATUS==LC0_OVERRUN))
	{
	}
  else
	{
	 MError(SAnIn.LC0_STATUS);
	 Go = FALSE ;
	}
  //Trect
  TR.left =30 ;
  TR.top =25;
  TR.bottom =400;
  TR.right = 1024;
 }

////////////////////////////////////////////////////////////////////////
// ->MyDraw()
//rysowanie okna monitora kanaowego
// dc - kontekst wyswietlania
////////////////////////////////////////////////////////////////////////
void tmonwnd::MyDraw(TDC &dc)
 {
  char tab[20],mod[]="ABCD";
  int xs = 28 , ys = 180 ,y;
  int Scale=3 ;

	 dc.SetMapMode(MM_TEXT);
	 //o pionowa
	 dc.MoveTo(xs,ys-50*Scale);
	 dc.LineTo(xs,ys+50*Scale);
	 //strzaka lewa
	 dc.MoveTo(xs-5,ys-50*Scale+5);
	 dc.LineTo(xs,ys-50*Scale);
	 //strzaka prawa
	 dc.MoveTo(xs+5,ys-50*Scale+5);
	 dc.LineTo(xs,ys-50*Scale);

	 //linia pozioma
	 if(Mes.Umin>=0) //0...x
	  {
		y=ys+50*Scale;
	  }
	 else           //+-x
	  {
		y=ys;
	  }
	 dc.MoveTo(xs,y);
	 dc.LineTo(xs+sampl,y);

	 //podpisujemy 0V
	 dc.TextOut(xs-20,y-8,"0V");
	 //modu

	 sprintf(tab,"Modu %c ",mod[SAnIn.LC0_AMODULE -1]);
	 dc.TextOut(xs-20,ys-50*Scale-20,tab);

	 //podpisujemy kana
	 sprintf(tab,"Kana %d ",chan);
	 dc.TextOut(xs-20+150,ys-50*Scale-20,tab);

	 //rysujemy przebieg
	 xs +=2;
	 int i;
	 unsigned int pr;
	 for(i=0;i<sampl;i++)
	  {
		 // tu zmiana
		 if(ACKod==0) //bin
		  pr =*(buf + i);
		 else             //u2
		  pr = IValues.U2Bin(*(buf + i));

		 y = (int)(ys+50.0*Scale - 100.0*Scale*(pr)/4096.0);
		 dc.SetPixel(xs+i,y,0);//czarny
	  }

 }


////////////////////////////////////////////////////////////////////////
// Paint() - odmalowanie okna monitora kanalowego
//rysowanie przebiegu
// dc - kontekst wyswietlania
////////////////////////////////////////////////////////////////////////
void tmonwnd::Paint(TDC& dc, BOOL, TRect&)
{
  if(Go)
	{
	  MyDraw(dc);

	}
}

//////////////////////////////////////////////////////////////////////////
// ->Destroy - niszczenie okna monitora
//////////////////////////////////////////////////////////////////////////
void tmonwnd::Destroy(int retVal)
{
  if(buf!=NULL)
	{
	 free(buf);
	 buf = NULL ;
	}
  KillTimer(MID);
  if(MID==1)
	MON1=FALSE ;
  else
	MON2 = FALSE;
  // mj kod
  if(nonend)
	{
	 HMENU hMenu  ;
	 hMenu = GetApplication()->MainWindow->GetMenu();
	 if(MID==1)
		{
		::CheckMenuItem(hMenu,IDM_MON1,MF_UNCHECKED|MF_ENABLED)  ;
		}
	 else
		{
		::CheckMenuItem(hMenu,IDM_MON2,MF_UNCHECKED|MF_ENABLED)  ;
		 }
	}
  TWindow::Destroy(retVal);
}


////////////////////////////////////////////////////////////////////////////
// EvTimer()
// odsuga timera okna monitora
// timerId - identyfikator timer'a
////////////////////////////////////////////////////////////////////////////
void tmonwnd::EvTimer (UINT timerId)
{
 unsigned int i ;
 if(Go)
  {
	if(strcmp(CurrentDLL,"LC1016A.DLL") != 0) //nie 10-a jeden pomiar i cay blok
	 (*AnalogInput)(&SAnIn);
	else  // dla 10-tki : ptla pomiarowa
	 {
	  if(SAnIn.LC0_STATUS==LC0_OK)
		{
		 for(i=0;i<SAnIn.LC0_ASTOP.samples ;i++)
		  {
			SAnIn.LC0_AADDR =(buf + i) ;
			(*AnalogInput)(&SAnIn);
		  }
		}
	 }
	if((SAnIn.LC0_STATUS==LC0_OK)|| (SAnIn.LC0_STATUS==LC0_OVERRUN))
	 {
	 }
	else
	{
	 KillTimer(MID);
	 Go = FALSE ;
	 MError(SAnIn.LC0_STATUS);
	 return ;
	}
	//odrysowanie okna
	InvalidateRect(TR);
	UpdateWindow();
  }
}

//////////////////////////////////////////////////////////////////////////
// SetScroll()
// Ustawia scrollbar okna
//////////////////////////////////////////////////////////////////////////
void SetScroll()
{
 WWW[3]->Scroller->SetRange(60,40);
}

/*

 Uwagi :
  27.02.1996 : dodana obsuga monitorw kanaowych dla LC-010-1612 i
					LC-020-3212 (przez DMA) ; pominicie OVERRUN-a

 2.03.1996 : dodana praca multi window


*/

