#if !defined(__t011_h)              // Sentry, use file only if it's not already included.
#define __t011_h

/*  Project lcwin.exe
	 t011.h - header dla t011.cpp

	 AUTHOR: Krzysztof Mroczek , 1995,96
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\statusba.h>
#include <owl\editview.h>
#include <owl\listview.h>

#include <owl\static.h>
#include <owl\button.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\combobox.h>

#include <owl\layoutwi.h>
#include <owl\layoutco.h>

//#include <owl\docmanag.h>
//#include <owl\filedoc.h>
#include "t011app.rh"            // Definition of all resources.
#include "lc1116a.h"					// DLL header

class t011App : public TApplication {
private:

public:
	 t011App ();
	 virtual ~t011App ();
//{{t011AppVIRTUAL_BEGIN}}
public:
	 virtual void InitMainWindow();
	 void CommonFun();
//{{t011AppVIRTUAL_END}}

//{{t011AppRSP_TBL_BEGIN}}
protected:
	 TGadgetWindow::THintMode HintMode;
	 TControlBar*             ControlBar;
	 /* funkcje obsugi komunikatw menu*/
	 void OnMeasure();
	 void CmHelpAbout ();
	 void OnTestConfig ();
	 void OnTestFunction ();
	 void OnTestDMA ();
	 void OnMeasurePar ();
	 void OnMeasureTekst ();
	 void OnMeasureGraph();
	 void OnMeasureTekstEn (TCommandEnabler &tce);
	 void OnMDIFileOpen ();
	 void	OnMonitor1();
	 void OnMonitor2();
	 void OnExit();
	 void OnGen();
	 void OnDriver();
	 void OnWeAC();
	 void OnWeWyC();
	 void OnStatystyka();
	 void OnInfo();
	 void OnClear();
	 /* pozostae funkcje obsugi komunikatw */
	 void EvVScroll (UINT scrollCode, UINT thumbPos, HWND hWndCtl);
//{{t011AppRSP_TBL_END}}
  DECLARE_RESPONSE_TABLE(t011App);
};    //{{t011App}}

////////////////////////////////////////////////////////////
// struktura informacji o oknach
////////////////////////////////////////////////////////////
struct ChildInfo
{
  TWindow *window ;
  TLayoutMetrics lm ;
};


////////////////////////////////////////////////////////////
// klasa gwnego okna
////////////////////////////////////////////////////////////
class t011Layout : public TLayoutWindow {
  public:
	 t011Layout(TWindow *parent);
	 ChildInfo child_info[4] ;//info o oknach
};


///////////////////////////////////////////////////////////////////
// Klasa dla okien pozostaych - grne  0
///////////////////////////////////////////////////////////////////
class twnd0 : public TWindow
{
  public:
  twnd0(TWindow *parent,int id);
  TStatic *e[5]				;//pole na informacje
  void Opis(void);
  void ClearAll();
};

///////////////////////////////////////////////////////////////////
// Klasa dla okien pozostaych - dolne  2
///////////////////////////////////////////////////////////////////
class twnd2 : public TWindow
{
  public:
  twnd2(TWindow *parent,int id);
  void Paint(TDC& dc, BOOL, TRect&);
};



/////////////////////////////////////////////////////////////////////
// okno prezentacji 3
/////////////////////////////////////////////////////////////////////
class t011wnd : public TWindow
{
 public :
 BOOL First ;
 t011wnd(TWindow *parent , int id);						//konstruktor
 void Paint(TDC& dc, BOOL, TRect&);						//malowanie okna
 void EvLButtonDown(UINT modKeys,TPoint &point) ;  //nacinicie L MOUSE
 void DrawAxis(TDC &dc,int xs,int ys);             // rysuje osie wykresu
 void DrawPixels(TDC &dc,int xs,int ys);           // rysuje wykres
 TPoint ppp ; 							//tu wsprzdne ostatniego narysowania linii
 DECLARE_RESPONSE_TABLE(t011wnd);
};

/////////////////////////////////////////////////////////////////////
// Klasa okna monitora kanau
/////////////////////////////////////////////////////////////////////
class tmonwnd : public TFrameWindow
{
 public :
 tmonwnd(TWindow *parent , int monid ,char *title);
 void MyDraw(TDC &dc);
 void Paint(TDC& dc, BOOL, TRect&);
 void Destroy(int retVal);
 void EvTimer (UINT timerId);
 int MID	;              // identyfikator timer'a
 BOOL Go ; 					// TRUE , gdy nie byo bedu pomiarowego
 int far *buf ;         // wsaknik dla bufora brbek
 lc0_analog_in SAnIn ;  // pomocnicza zmienna dla LC0_AnalogInput
 BOOL first ;           // flaga 1-o wejcia do timera
 unsigned int sampl ; 	//ilo prbek
 unsigned char chan ;   // numer kanau
 TRect TR ;
 unsigned char ACKod ; 	//prywatna zmienna dla monitorw : 0 NKB ; 1 - U2
 lc0_module SModule ; 	//tu info o module z LC0_ModuleInfo
 DECLARE_RESPONSE_TABLE(tmonwnd);
};

///////////////////////////////////////////////////////////////////
// funkcje globalne
////////////////////////////////////////////////////////////////////
void MError(char);              // LC*.DLL Error Message
void PaintAll();                // odmalowanie wszystkich okien programu
void MyUpdate(BOOL mes=TRUE);   // odmalowanie okien z danymi programu
void WSampClear();              //
int checkdriver();              // sprawdza czy jest jaki driver dostepny
int SearchFile(char *path);     // 1 jest gdzie 0 -nie ma
void FreeInstances() ;          // zwalnia instancje fukcji driver'a

#endif                                      // __t011_h sentry.
