/*  Project lcwin.exe
	 Implementacja parametrycznych okien dialogowych
	 Autor : Krzysztof Mroczek 1995,1996
*/


#include <owl\owlpch.h>
#include <owl\combobox.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\edit.h>
#include <owl\dialog.h>
#include <owl\gauge.h>
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include <math.h>
//#pragma hdrstop

#include "lc1116a.h"
#include "ttestd.h"
#include "user.h"
#define DLLNR 9

///////////////////////////////////////////////////////////////////////////
// z user.cpp
///////////////////////////////////////////////////////////////////////////
extern struct SD9 GlobalInfo ;


//////////////////////////////////////////////////////////////////////////////
// z t011.cpp
//////////////////////////////////////////////////////////////////////////////
extern char *DLLDrivers[] ;
void SetScroll();
void PaintAll();
void MyUpdate(BOOL mes=TRUE);

#define DLLNR 9
extern int DLLAct[DLLNR] ;
extern char CurrentDLL[20] ;
extern HINSTANCE	 hDriverInst	  ;		 /* desktyptor drivera				*/
extern HINSTANCE	 hInst ; /* deskryptor aplikacji */

extern void (FAR PASCAL _export *ModuleInit)(struct lc0_init FAR *param);
extern void (FAR PASCAL _export *GetTotalConfiguration)(struct lc0_total FAR *param);
extern void (FAR PASCAL _export *GetModuleConfiguration)(struct lc0_module FAR *param);
extern void (FAR PASCAL _export *GetInfo)(struct lc0_info FAR *param);
extern void (FAR PASCAL _export *Break)(struct lc0_break FAR *param);
extern void (FAR PASCAL _export *AnalogInput)(struct lc0_analog_in FAR *param);
extern void (FAR PASCAL _export *AnalogOutput)(struct lc0_analog_out FAR *param);
extern void (FAR PASCAL _export *Leave)(struct lc0_leave FAR *param);
extern void (FAR PASCAL _export *SetClock)(struct lc0_clock FAR *param)	;
extern void (FAR PASCAL _export *SetVoltage)(struct lc0_volt FAR *param)	;
extern void (FAR PASCAL _export *SetTime)(struct lc0_time FAR *param)	;
extern void (FAR PASCAL _export *WaitForInt)(struct lc0_wait FAR *param)	;
extern void (FAR PASCAL _export *Interrupt)(struct lc0_interrupt FAR *param)	;
extern void (FAR PASCAL _export *DigitalIn)(struct lc0_digital_in FAR *param)	;
extern void (FAR PASCAL _export *DigitalOut)(struct lc0_digital_out FAR *param)	;
extern void (FAR PASCAL _export *CTCWrite)(struct lc0_ctc_write FAR *param)	;
extern void (FAR PASCAL _export *CTCRead)(struct lc0_ctc_read FAR *param)	;
extern void (FAR PASCAL _export *Config)(struct lc0_config FAR *param)	;
extern void (FAR PASCAL _export *DataTransmit)(struct lc0_transmit FAR *param);
extern void (FAR PASCAL _export *MemoryUse)(struct lc0_memory FAR *param);

//////////////////////////////////////////////////////////////////////////////

// maksymalna dugo bufora pamici rozszerzonej dla memoryuse()
#define MAXEXTSIZE 1024000

extern TWindow *WWW[4];
///////////////////////////////////////////////////////////////////////
// ustawia domyslne parametry struktur driver'a i okien dialogowych
///////////////////////////////////////////////////////////////////////
void SetDefaultPar();
///////////////////////////////////////////////////////////////////////
// Nazwy bdw do wywietlania
///////////////////////////////////////////////////////////////////////
char	*DriverErrors[] =
{
						/* LC0_UNKN_FUNC	-1 */
"LC0_UNKN_FUNC",
						/* LC0_NO_MODULE	-2 */
"LC0_NO_MODULE",
						/* LC0_BAD_DEV_TYP	-3 */
"LC0_BAD_DEV_TYP",
						/* LC0_NONEX_DEV	-4 */
"LC0_NONEX_DEV",
						/* LC0_BAD_FREQ		-5 */
"LC0_BAD_FREQ",
						/* LC0_BAD_RANGE	-6 */
"LC0_BAD_RANGE",
						/* LC0_NO_OPER		-7 */
"LC0_NO_OPER",
						/* LC0_BAD_MARGIN	-8 */
"LC0_BAD_MARGIN",
						/* LC0_BAD_BUF_ADR	-9 */
"LC0_BAD_BUF_ADR",
						/* LC0_BAD_BUF_LEN     -10 */
"LC0_BAD_BUF_LEN",
						/* LC0_DEV_BUSY	       -11 */
"LC0_DEV_BUSY",
						/* LC0_BAD_PER	       -12 */
"LC0_BAD_PER",
						/* LC0_BAD_CHAN_N      -13 */
"LC0_BAD_CHAN_N",
						/* LC0_BAD_CHAN	       -14 */
"LC0_BAD_CHAN",
						/* LC0_BROKEN 	       -15 */
"LC0_BROKEN",
						/* LC0_INTR_NOT_INST   -16 */
"LC0_INTR_INST",
						/* LC0_ILL_START_CODE  -17 */
"LC0_ILL_START_CODE",
						/* LC0_ILL_STOP_CODE   -18 */
"LC0_ILL_STOP_CODE",
						/* LC0_BAD_PROC	       -19 */
"LC0_BAD_PROC",
						/* LC0_TOO_LONG_MARG   -20 */
"LC0_TOO_LONG_MARG",
						/* LC0_ILL_START       -21 */
"LC0_ILL_START",
						/* LC0_ILL_STOP	       -22 */
"LC0_ILL_STOP",
						/* LC0_BAD_MNUM	       -23 */
"LC0_BAD_MNUM",
						/* LC0_NOT_SUPPORTED   -24 */
"LC0_NOT_SUPPORTED",
						/* LC0_BAD_CTC_MODE    -25 */
"LC0_BAD_CTC_MODE",
						/* LC0_NO_PARAMS       -26 */
"LC0_NO_PARAMS",
						/* LC0_OVERRUN	       -27 */
"LC0_OVERRUN",
						/* LC0_NO_DMA	       -28 */
"LC0_NO_DMA",
						/* LC0_NO_IRQ	       -29 */
"LC0_NO_IRQ",
						/* LC0_NOT_FULLY_SUP   -30 */
"LC0_NOT_FULLY_SUP",
						/* LC0_NO_EXTMEM       -31 */
"LC0_NO_EXTMEM",
						/* LC0_NO_SEC_FREQ     -32 */
"LC0_NO_SEC_FREQ",
						/* LC0_INTR_INST       -33 */
"LC0_INTR_INST",
						/* LC0_BAD_PER2	       -34 */
"LC0_BAD_PER2",
						/* LC0_BAD_MODE	       -35 */
"LC0_BAD_MODE",
						/* LC0_BAD_EXTMEM      -36 */
"LC0_BAD_EXTMEM",
						/* LC0_NOT_PROGRAMMED  -37 */
"LC0_CTC_NOT_PROGRAMMED",
						/* LC0_REJECTED	       -38 */
"LC0_REJECTED",
"LC0_BAD_CONFIG", /* 39 */
"LC0_NOT_INIT",	/* 40 */
"LC0_NO_DMA_TRANS", /*41*/
"LC0_BAD_RAM_SEQ", /*42*/

};
#define ERR	-43

				/* ------ teksty ostrzezen                */
char	*DriverWarnings[] =
{
						/* LC0_NON_EX_MOD	1 */
"LC0_NON_EX_MOD",
						/* LC0_OTHER_LEN	2 */
"LC0_OTHER_LEN",
						/* LC0_PREMATURE_END	3 */
"LC0_PREMATURE_END",
						/* LC0_IN_PROGRESS      4 */
"LC0_IN_PROGRESS",
					  /* 5 */
"LC0_IS_INIT",
};

#define WARR 5
				/* ------- teksty informacji dodatkowych  */
char	*DriverAdditionalErrors[] =
{
						/* LC0_E_NO_MODULE	-1 */
"LC0_E_NO_MODULE",
						/* LC0_E_NONEX_DEV	-2 */
"LC0_E_NONEX_DEV",
						/* LC0_E_BAD_CHAN	-3 */
"LC0_E_BAD_CHAN",
						/* LC0_E_BAD_TIME	-4 */
"LC0_E_BAD_TIME",
						/* LC0_E_BAD_DATE	-5 */
"LC0_E_BAD_DATE",
						/* LC0_E_BAD_THRE	-6 */
"LC0_E_BAD_THRE",
						/* LC0_E_BROKEN_WAIT	-7 */
"LC0_E_BROKEN_WAIT",
						/* LC0_E_BROKEN_RUN	-8 */
"LC0_E_BROKEN_RUN",
						/* LC0_E_BAD_LEN        -9 */
"LC0_E_BAD_LEN",
"LC0_E_MOD_UNABLE",	 /*	-10  */
};

#define ADDERR -10
// nazwy fumkcji do combo-boxa
static DWORD funnum = 14 ;   //AnalogInput
char * FunNames[] = {
							"MODULE_INIT",              //0
							"GET_TOTAL_CONFIGURATION",  //1
							"GET_MODULE_CONFIGURATION", //2
							"GET_INFO",                 //3
							"SET_CLOCK",                //4
							"SET_VOLTAGE_RANGE",        //5
							"SET_TIME",                 //6
							"WAIT_FOR_END",             //7
							"BREAK",                    //8
							"DIGITAL_INPUT",            //9
							"DIGITAL_OUTPUT",           //10
							"CTC_WRITE",                //11
							"CTC_READ",                 //12
							"DATA_TRANSMIT",            //13
							"ANALOG_INPUT",             //14
							"ANALOG_OUTPUT",            //15
							"LEAVE_DRIVER",             //16
							"INTERRUPT_SERVICE",        //17
							"MEMORY_USE",               //18
							};
// nazwy poszczeglnych pl struktur - bez czci statusu
char  *TModuleInit[] = {
	"LC0_IMODULE",       /*1*/
	};

char *TTotal[] = {
	"LC0_TONF [Hex]",        /*1*/
	"LC0_TIAD",        /*1*/
	"LC0_TIDA",        /*1*/
	"LC0_TCTC",        /*1*/
	"LC0_TIDI",        /*1*/
	"LC0_TIDO",        /*1*/
};

char *TModuleInfo[] = {
	"LC0_MMODULE",                                             /*1 ++*/
	"LC0_MBASE1 [Hex]",
	"LC0_MIAD",			/* przetworniki a/c                */
	"LC0_MIDA",			/* przetworniki c/a                */
	"LC0_MCTC",			/* kanaly CTC                      */
	"LC0_MIDI",			/* porty wejsc cyfrowych           */
	"LC0_MIDO",			/* porty wyjsc cyfrowych           */
	"LC0_MCLOCK",			/* czestotliwosc zegara w kHz      */
	"LC0_MINT   [Hex]",
	"LC0_MMEMA",
	"LC0_MMEML",
	"LC0_MBASE2 [Hex]",/* FLAGI lc-015-1612 */
	};

char *TInfo[] = {
	"LC0_GTYPE",			/* rodzaj urzadzenia               */
	"LC0_GMODULE",		/* numer modulu                    */
	"LC0_GNUM",			/* numer przetwornika/portu/       */
												/*                      ukladu CTC */
	"LC0_GCHAN",			/* liczba kanalow                  */
	"LC0_GRES",			/* liczba bitow przetwornika       */
	"LC0_GTIME",			/* czas konwersji przetwornika w ns*/
	"LC0_GMINV",					/* dolna granica zakresu napiec w  */
												/*   dziesiatych czesciach volta   */
	"LC0_GMAXV",					/* gorna granica zakresu napiec w  */
												/*   dziesiatych czesciach volta   */
	"LC0_GDMA",		/* numer kanalu DMA                */
					 };
char *TClock[] = {"LC0_LCLOCK"};//1

char *TVolt[] = {
					  "LC0_VMODULE",
					  "LC0_VTYPE",
					  "LC0_VNUM",
					  "LC0_VMINV",
					  "LC0_VMAXV",
					  "LC0_VAMPL",//6
					 };

char *TSet[] = {"LC0_ETIME"};//1
char *TWait[] = {
					  "LC0_WMODULE",
					  "LC0_WTYPE",
					  "LC0_WNUM",
					  "LC0_WMODE",
					  "LC0_WRMNUM",
					  "LC0_WREMAR", //6
					 };
char *TInterrupt[] = {
					  "LC0_SMODULE",
					  "LC0_SPROC",
					  "LC0_SSTAT", //3
					 };

char 	*TBreak[] = {
						"LC0_BMODE",			/* tryb pracy                      */
						"LC0_BPROC",        /*p*/

						};

char *TDigIn[] = {
						 "LC0_DMODULE", /* numer modulu                    */
						 "LC0_DNUM",		/* numer portu                     */
						 "LC0_DVAL [Hex]",		/* odczytana wartosc               */
						};

char *TDigOut[] = {
						"LC0_OMODULE",	/* numer modulu                    */
						"LC0_ONUM",		/* numer portu                     */
						"LC0_OVAL [Hex]",		/* wartosc do wyslania             */
						};

char *TCTCW[] = {
					 "LC0_CMODULE",	/* numer modulu                    */
					 "LC0_CMODE [Hex]",		/* tryb pracy funkcji              */
					 "LC0_CFUN   [Hex]"	,	/* tryb pracy kanalu               */
					 "LC0_CVAL   [Hex]",		/* nowa wartosc licznika           *//*2*/
					 };
char *TCTCR[] = {
						"LC0_UMODULE",		/* numer modulu                    */
						"LC0_UNUM",			/* numer kanalu                    */
						"LC0_UVAL [Hex]",         /*2*/
					 };

char *TDataT[] = {
	"LC0_RMODULE",
	"LC0_RMODE [Hex]",			/* tryb przesylania                */
	"LC0_RADDR"	,			/* adres bufora DMA - pomiarowego  */ /*p*/
	"LC0_RLEN",	/* dlugosc bufora w DMA - pomiarowego    */    /*4*/
	"LC0_RMEAS",	/* numer pierwszej probki          */
	"LC0_RNUM",	/* liczba probek do przeslania     */
	"LC0_RMEMA",	/* adres bufora w pamieci          */
										/*   aplikacji (absolutny)(??)     */
	"LC0_RRNUM",
};

char *TAnalogIn[] = {
	"LC0_AMODULE",	/* numer modulu                    */
	"LC0_ANUM",		/* numer przetwornika              */
	"LC0_AMODE [Hex]",		/* tryb pracy funkcji              */         /*2*/
	"LC0_APER",		/* okres probkowania               */            /*4*/
	"LC0_ACHAN [Hex]",		/* liczba kanalow podstawowych     */
	"LC0_APER2",          /* dla LC0_15 dugo bufora cyklicznego lub pretr.  */

	"LC0_ALEN",		/* dlugosc bufora                  */             /*4*/
	"LC0_AMEMA",		/* adres bufora w pam. rozszerzonej*/          /*4*/
											/*   (absolutny)                   */
											/* ??? z auto transmisj				*/
	"LC0_ARDIV1",		/* pierwszy podzielnik zegara      */             /*2*/
	"LC0_ARDIV2",		/* drugi podzielnik zegara         */             /*2*/
	"LC0_ARMNUM",		/* rzeczywista liczba probek       */             /*4*/
	"LC0_ARLEN",		/* rzeczywista liczba przepisanych */             /*4*/
											/*   probek                        */
	"LC0_ARBUF",		/* wskanik bufora cyklicznego lub prerrig */
};

char *TAnalogOut[] = {
	"LC0_NMODULE",	/* numer modulu                    */
	"LC0_NNUM"	 ,	/* numer przetwornika              */
	"LC0_NMODE [Hex]"	 ,	/* tryb pracy funkcji              */                /*2*/
	"LC0_NCHAN [Hex]"	 ,	/* liczba kanalow (b8 okresla      */
											/*   czy praca wielokanalowa (0)   */
											/*   czy jednokanalowa (1))        */
	"LC0_NPER"	 ,	/* okres probkowania */                                /*4*/
											/*   pamieci podstawowej, absolutny*/
											/*   dla pamieci rozszerzonej)     */
	"LC0_NRMNUM" ,		/* rzeczywista liczba wyslanych    */               /*4*/
											/*   probek                        */
	"LC0_NADDR."	 , /* adres b.pomiarowego */
	"LC0_NLEN"   , /* dugo b.pomiarowego*/
	"UCA1 [V]"       , /* napicie na przetwornik 1 */
	"UCA2 [V]"		 , /*napicie na DAC2*/

};
char *TMemory [] = {
	"LC0_MMODULE",	/* nr moduu do ktrego odnosi si ta operacja */
	"LC0_MMODE [Hex]",		/* obecnie == 1						  */
	"LC0_MNUM",			/* dana liczba prbek w nowym buforze*/

	"LC0_MRNUM",		/* rzeczywista wielko bufora w prbkach */
	"LC0_MRMEMA",

	};

int FunT[] = {3,9,15,12,4,9,4,9,5,6,6,7,6,11,16,13,3,6,8}; //tyle jest pl dla funkcji

////////////////////////////////////////////////////////////////////////
// globalne zmienne struktur driver'a
////////////////////////////////////////////////////////////////////////
lc0_init 		SModuleInit ;
lc0_total      STotal ;
lc0_module		SModuleInfo ;
lc0_info			SInfo	;
lc0_clock		SClock ;
lc0_volt			SVolt	;
lc0_time			STime ;
lc0_wait			SWait ;
lc0_break		SBreak;
lc0_digital_in SDigIn ;
lc0_digital_out SDigOut;
lc0_ctc_write  SCTCW;
lc0_ctc_read	SCTCR;
lc0_transmit	STransmit;
lc0_analog_in	SAnalogIn,SGAnalogIn;
lc0_analog_out	SAnalogOut;
lc0_leave		SLeave;
lc0_interrupt	SInterrupt;
lc0_memory		SMemory;
//lc0_start      SStart	 ; //parametry startu

// zmienna klasy CValues
CValues IValues			;  // min i max napicia poszczeglnych torw

// parametry startu operacji : 5 bajtw i odcinek czasu
unsigned char Spar[5]    ; //5 bajty parametrw startu
unsigned long Sptime     ; // odcinek czasu


struct StartParam DebugPar,ACSPar,CASPar,CCSPar ; //dla debuger'a

int CAType					 ; //rodzaj wypeniacza bufora dla testu C/A
unsigned long  Samples,GSamples	; // parametrs STOP - ilo prbek do zmierzenia
unsigned long PSamples=0; //aktualna ilo prbek dla pomiarw do bufora programowego
int sel1 = 0 , sel2 =0   ; //pocztkowe parametry   radioboxw
BOOL AppProc = FALSE		 ; // == DLL info

// programowy  bufor na prbki
int ProgBuf[4096]        ; //tabela testowa bufor programowy


// wskanik do programowego bufora na prbki
int huge *ProgBufPtr = (int huge *)(&ProgBuf[0]);
static float vca1=0.0,vca2=0.0 ;			//na okno DAC w

// zmienne odpowiednich struktur dla okien dialogowych DIALOG6 i DIALOG7
struct SD6 sD6;
struct SD7 sD7 = {1,5.0,0.0,10.0};

// dla generatora C/A
lc0_analog_out	SD7AnalogOut={ANALOG_OUTPUT,0,0,1,1,LC0_MOD_BLOCK
|LC0_MOD_EXT_MEM | LC0_MOD_SYNCHR | LC0_MOD_NEW_PAR | LC0_MOD_START,
0,129,300,ProgBufPtr,4096,0,0,4096,0};
char *TST[] = {"Moduy do inicjacji" ,"Moduy zainstalowane"} ;

// klasa pomiarowa
# define MAXCHANNELS 32
//////////////////////////////////////////////////////////////////////
// Measure : klasa wspomagajca obrazowanie wynikw pomiarw A/C programu
//////////////////////////////////////////////////////////////////////
Measure::Measure()
{

 NumDispl = 4;
 GKan=1;
 MonChan1 = 1;
 MonChan2 = 2;
 MonSamp =  400;
 Mod1=1;Mod2=1;
 Chan = 2;
 Single = TRUE;
 ModNum = 1;
 PBuf =(int far *)ProgBufPtr ;
 EBuf = NULL ;
 Umin = -100; //bo w 0.1 V
 Umax = 100;
 ExMem = TRUE;
 Kor = TRUE;
 ptr = NULL ;
 Scale = 2;
 Samples = 1024;
 ACKod=0;  //NKB
 DMode=2 ;//mV
 TMin=(float *)malloc(MAXCHANNELS*sizeof(float));
 TMax=(float *)malloc(MAXCHANNELS*sizeof(float));
 TMean=(float *)malloc(MAXCHANNELS*sizeof(float));
 TStv=(float *)malloc(MAXCHANNELS*sizeof(float));
 ProgBufEnable=FALSE;
 ExBufEnable=FALSE;
}

////////////////////////////////////////////////////////////////////////////////
// ->TranslateBuf()
// translacja U2->BIN po wywoaniu LC0_ANALOGIN
// wczesniej trzeba wywoa GET_MODULEINFO
////////////////////////////////////////////////////////////////////////////////
void Measure::TranslateBuf(lc0_analog_in *ptr , lc0_module *ptrmod)
{
 //sprawdzamy czy nie bd
 if((ptrmod->LC0_STATUS != LC0_OK))
  return ;
 //sprawdzamy czy translowac
 if((ptrmod->LC0_MBASE2 & 0x0008)==0)//przetwornik z kodem binarnym
  return;
 if((ptr->LC0_STATUS!=LC0_OK)&&(ptr->LC0_STATUS!=LC0_OVERRUN)&&
 (ptr->LC0_STATUS!=LC0_BROKEN)&&(ptr->LC0_STATUS!=LC0_OTHER_LEN))
  return;
 // translujemy

 unsigned long int I;
 unsigned int huge *ptrext = (unsigned int huge *)(ptr->LC0_AMEMA);
 unsigned int huge *ptrprog = (unsigned int huge*)(ptr->LC0_AADDR);
 unsigned int sampl;
 // translacja bufora pamici rozszerzonej
 if((ptr->LC0_AMODE & LC0_MOD_EXT_MEM)!=0)
  {
	 for(I=0;I<ptr->LC0_ARMNUM;I++)
	  {
		 if(*(ptrext+I)<=0x07ff)
		  *(ptrext+I) +=0x0800;
		 else
		  *(ptrext+I) -= 0x0800;
	  }
  }
 // translacja bufora pamici podstawowej
 // 1. pomiar tylko do pamici podstawowej
 if((ptr->LC0_AMODE & LC0_MOD_EXT_MEM)==0)
  {
	for(I=0;I<ptr->LC0_ARMNUM;I++)
	  {
		 if(*(ptrprog+I)<=0x07ff)
		  *(ptrprog+I) +=0x0800;
		 else
		  *(ptrprog+I) -= 0x0800;
	  }
  }
 // pomiar do pamici rozszerzonej z przepisaniem do pamici podstawowej
 if(((ptr->LC0_AMODE & LC0_MOD_EXT_MEM)!=0)&&((ptr->LC0_AMODE & LC0_MOD_MEM_W)!=0))
  {
	for(I=0;I<ptr->LC0_ARLEN;I++)
	  {
		 if(*(ptrprog+I)<=0x07ff)
		  *(ptrprog+I) +=0x0800;
		 else
		  *(ptrprog+I) -= 0x0800;
	  }
  }

}

/////////////////////////////////////////////////////////////////////////////////
// funkcja nie uywana
/////////////////////////////////////////////////////////////////////////////////
int Measure::Statistic(unsigned long samples,TGauge *sk=NULL,int min=0 ,int max=100)
{
 signed int s1,s2;
 unsigned int u1,u2,ch,i,zakres;
 unsigned long Blocks,Smp,I,displ;
 long minv[32],maxv[32],sum[32];

 if(samples==0)
  {
	if(Samples==0)
	 return 0;
	else
	 Smp=Samples;
  }
 else
	Smp=samples;
 if(Chan==0)
  return 0;
 if(Single)
  {
	ch=1;
	Blocks = Smp;
  }
 else
  {
	if(Chan==1)
	 return 0;
	Blocks=Smp/(unsigned long)Chan;
	if(Blocks==0)
	 return 0;
	ch=Chan;
  }

 //ch - liczba kanaw do skanowania
 // Blocks - liczba blokw do skanowania
 // Smp - liczba prbek cakowita

 for(i=0;i<ch;i++)
  {
	*(TMin+i)=0.0; *(TMax+i)=0.0;
	*(TMean+i)=0.0;*(TStv+i)=0.0;
	minv[i] = 0;maxv[i]=0 ;sum[i]=0;
  }

zakres = max-min;
if(Blocks>zakres)
 displ = Blocks/(unsigned long)zakres; //ilo skokw na zakres
else
 displ=0;
///////////////////////////////////////////////////////////////////////////
// liczymy
///////////////////////////////////////////////////////////////////////////
//Minv , Maxv , Suma
unsigned long K=1;
unsigned int k=1;
if(sk!=NULL)
 sk->SetValue(0);
for(I=0;I<Blocks;I++)
 {
  for(i=0;i<ch;i++)
	{
	  for(long int ii=0;ii<20000;ii++)
		{
		 minv[1]+=10;
		}

	}
  if(I==displ*K)
	{
	  K++;
	  sk->SetValue(k++);
	}
  if(GetAsyncKeyState(VK_CANCEL)& 0x8000)
	return 0;
 }

}

////////////////////////////////////////////////////////////////////////
// ->GetParam()
// ustawia zmienne klasy i globalne na podstawie danych z  SAnalogIn
// Rezultat :
//  0 gdy OK lub kod bdu
////////////////////////////////////////////////////////////////////////
char Measure::GetParam()
{
  unsigned char imod=SModuleInfo.LC0_MMODULE;
  char err=LC0_OK ;

  ModNum = SGAnalogIn.LC0_AMODULE ;
  Chan	= SGAnalogIn.LC0_ACHAN & 0x7f ;
  if((SGAnalogIn.LC0_ACHAN & 0x80) !=0)
	Single = TRUE ;
  else
	Single = FALSE ;
  //bufor pamici rozszerzonej
  SModuleInfo.LC0_MMODULE = SGAnalogIn.LC0_AMODULE;
  (*GetModuleConfiguration)(&SModuleInfo);
  //SModuleInfo.LC0_MMODULE = imod;
  if(SModuleInfo.LC0_STATUS != LC0_OK)
	return SModuleInfo.LC0_STATUS;

  // ustawienie flagi ACKod
  if((SModuleInfo.LC0_MBASE2 & 0x0008)!=0)
	ACKod = 1;
  else
	ACKod = 0;

  EBuf = SModuleInfo.LC0_MMEMA ;
  SGAnalogIn.LC0_AMEMA = SModuleInfo.LC0_MMEMA ;
  if(ExMem)
	ptr = EBuf;
  else
	ptr = (int far *)ProgBufPtr;

  //zakres mapi
  lc0_info LI ;
  LI.LC0_GTYPE 	= 3;
  LI.LC0_GMODULE = ModNum ;
  LI.LC0_GNUM = 1;
  (*GetInfo)(&LI);
  if(LI.LC0_STATUS != LC0_OK)
	return LI.LC0_STATUS ;
  Umin = (float)LI.LC0_GMINV /10.0 ;
  Umax = (float)LI.LC0_GMAXV / 10.0;
  Samples=::GSamples ;
  unsigned char c;
  c=Chan;
  if(c==0)
	c=1;
  if(c>16)
	c=16;
  int k ,zakres;
  if(Single)
	k = 1;
  else
	{
	 // zakres wywietlania wikszy ni liczba kanaw
	 if(4*(GKan-1)+1>c)
		 GKan=1;
	 if(c <= NumDispl)
	  k=c;
	 else
	  {
		zakres=4*GKan;
		if(c>=zakres)
		 k=4;
		else
		  k=c-4*(GKan-1);
	  }
	}
  NumD = k;
  return LC0_OK ;
}

////////////////////////////////////////////////////////////////////////
// przeksztacenie kodu przetwornika do wartoci napicia w mV
///////////////////////////////////////////////////////////////////////
float Measure::CodeToFloat(int code) //do wywietlenia na ekranie w mV
{
 float x1;
 if(code<0)
  return -10.0;
 if(code >4095)
  return 9.995;
 x1=(Umax-Umin)*code/(4096.0) +Umin;
 return x1;
}

// zmienna globalna programu : klasa Measure
Measure Mes ;
/////////////////////////////////////////////////////////////////////////
//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TTestD, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_BN_CLICKED(IDC_PARAM, OnParamClicked),
	 EV_BN_CLICKED(IDRUN, OnRunClicked),
	 EV_CBN_SELENDOK(IDC_COMBOBOX1, OnCBNSelendok),
	 EV_BN_CLICKED(IDC_MODE,OnMode),
	 EV_WM_QUERYDRAGICON,
	 EV_WM_PAINT,
	 EV_WM_CLOSE,
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TTestD Implementation}}

////////////////////////////////////////////////////////////////////////
// TTestD : klasa okna dialogu debuger'a funkcji biblioteki DLL
////////////////////////////////////////////////////////////////////////
TTestD::TTestD (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 MyIcon = ::LoadIcon(hInst,MAKEINTRESOURCE(IDI_FUNDIALOG));
	 SetDefaultPar();
	 for(i=0;i<16;i++)
	  e[i]= (TEdit*)(new TEdit(this,IDC_EDIT1+i));
	 for(i=0;i<13;i++)
	  l[i] = (TStatic*)(new TStatic(this,IDC_L1+i,15));
	 for(i=0;i<4;i++)
	  MOD[i] = (TCheckBox*)(new TCheckBox(this,IDC_MOD_A+i));
	 ST = (TStatic*)(new TStatic(this,IDC_STATIC1));
	 combo = new TComboBox(this,IDC_COMBOBOX1);
	 (int huge *)(SAnalogOut.LC0_NADDR.base_memory) = ProgBufPtr ;
	 SAnalogOut.LC0_NLEN	= 4096 ;
	 vca1 = *ProgBuf;
	 vca2 = *(ProgBuf+1);
	 SAnalogIn.LC0_ALEN = 4096 ;
	 (int huge *)(SAnalogIn.LC0_AADDR) = ProgBufPtr ;
	 dWindow = this;
}

// destruktor
TTestD::~TTestD ()
{
	 //Destroy();

	 // INSERT>> Your destructor code here.

}

////////////////////////////////////////////////////////////////////
// PONIEJ : FUNKCJE ODPOWIEDZI NA ZADEKLAROWANE KOMUNIKATY
////////////////////////////////////////////////////////////////////

HANDLE TTestD::EvQueryDragIcon()
 {
	return(MyIcon)   ;

 }

void TTestD::EvPaint()
{
 TRect R;
 HDC dc;
 DWORD kol;
  ((TDialog*)(this))->EvPaint();
	if (this->IsIconic())
	 {
		// wyswietlic ikone
		R=this->GetClientRect();
		dc=::GetWindowDC(this->HWindow);
		::DrawIcon(dc,R.left+2,R.top+2,MyIcon);
		::ReleaseDC(this->HWindow,dc);
		//this -> SetBkgndColor(kol);
	 }
}

void TTestD::EvClose()
{
  dWindow = NULL;
  Destroy();
}

void TTestD::OnOKClicked ()
{
	 // INSERT>> Your code here.
	 dWindow = NULL;
	 Destroy();
}

void TTestD::OnCancelClicked ()
{
	 // INSERT>> Your code here.
	 dWindow = NULL;
	 Destroy();
}

void TTestD::OnParamClicked ()
{
	 // INSERT>> Your code here.
	TParD *Dptr ;
	Dptr = new TParD(this)   ;
	 if(Dptr->Execute()==IDOK)
	  {

	  }
	 else
	  {


	  }
	delete Dptr ;
}

////////////////////////////////////////////////////////////////////////////
// funkcja AAMod : ustawia zmienn *lc_par zgodnie z mask zdefiniowan
// przez sD6.mode[]
////////////////////////////////////////////////////////////////////////////
void AAMod(unsigned int *lc_par) //ustawia par.
{
 unsigned int umask[] = {0xfffe,0xfffd,0xfffb,0xfff7,0xffef,0xffdf,0xffbf,0xff7f,
								 0xfeff,0xfdff,0xfbff,0xf7ff,0xefff,0xdfff,0xbfff,0x7fff};
 unsigned int mask[] = {1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768};

 if(sD6.mode[0]==TRUE)
  *lc_par |= mask[0];
 else
  *lc_par &= umask[0];
 if(sD6.mode[1]==TRUE)
  *lc_par |= mask[1];
 else
  *lc_par &= umask[1];
 if(sD6.mode[2]==TRUE)
  *lc_par |= mask[2];
 else
  *lc_par &= umask[2];
 if(sD6.mode[3]==TRUE)
  *lc_par |= mask[5];
 else
  *lc_par &= umask[5];
 if(sD6.mode[4]==TRUE)
  *lc_par |= mask[8];
 else
  *lc_par &= umask[8];
 if(sD6.mode[5]==TRUE)
  *lc_par |= mask[10];
 else
  *lc_par &= umask[10];

 if(sD6.mode[6]==TRUE)  //page
  *lc_par |= mask[12];
 else
  *lc_par &= umask[12];

 if(sD6.mode[7]==TRUE)
  *lc_par |= mask[9];
 else
  *lc_par &= umask[9];

 //dodatkowo wprowadzone
 if(sD6.xmode[0]==TRUE)
  *lc_par |= mask[3];
 else
  *lc_par &= umask[3];

 if(sD6.xmode[1]==TRUE)
  *lc_par |= mask[4];
 else
  *lc_par &= umask[4];

 if(sD6.xmode[2]==TRUE) //ramseq
  *lc_par |= mask[11];
 else
  *lc_par &= umask[11];

 if(sD6.xmode[3]==TRUE)
  *lc_par |= mask[6];
 else
  *lc_par &= umask[6];

}
/////////////////////////////////////////////////////////////////////////////

void TTestD::OnMode()
{
	TD6 *Dptr ;

	Dptr = new TD6(this)   ;
	Dptr->Execute();
	if(sD6.go==TRUE)
	  {
		sD6.go=FALSE;
		if(funnum==2)
		 SModuleInfo.LC0_MMODULE = sD6.mod+1;
		if(funnum==3)
		 SInfo.LC0_GMODULE = sD6.mod+1;
		if(funnum==5)
		 SVolt.LC0_VMODULE = sD6.mod+1;
		if(funnum==7)
		 SWait.LC0_WMODULE = sD6.mod+1;
		if(funnum==17)
		 SInterrupt.LC0_SMODULE = sD6.mod+1;
		if(funnum==9)
		 SDigIn.LC0_DMODULE = sD6.mod+1;
		if(funnum==10)
		 SDigOut.LC0_OMODULE = sD6.mod+1;
		if(funnum==11)
		 SCTCW.LC0_CMODULE = sD6.mod+1;
		if(funnum==12)
		 SCTCR.LC0_UMODULE = sD6.mod+1;
		if(funnum==13)
		 {
		  STransmit.LC0_RMODULE = sD6.mod+1;
		  //transmit
		  STransmit.LC0_RMODE=sD6.dmode;
		 }
		if(funnum==14)
		 {
		  SAnalogIn.LC0_AMODULE = sD6.mod+1;
		  SAnalogIn.LC0_AMODE = 0;
		  AAMod(&SAnalogIn.LC0_AMODE);
		  if(sD6.amode==1)
			SAnalogIn.LC0_ACHAN =(unsigned char)sD6.sk;
		  else
			SAnalogIn.LC0_ACHAN =(unsigned char)sD6.mk;
		  SAnalogIn.LC0_ACHAN +=128*sD6.amode;
		 }
		if(funnum==15)
		 {
		  SAnalogOut.LC0_NMODULE = sD6.mod+1;
		  SAnalogOut.LC0_NMODE = 0;
		  AAMod(&SAnalogOut.LC0_NMODE);
		  if(sD6.mode[5]==TRUE) //pami rozszerzona
			SAnalogOut.LC0_NADDR.extended_memory = SModuleInfo.LC0_MMEMA ;
		  else
			SAnalogOut.LC0_NADDR.base_memory = ProgBufPtr ;
		 }
		if(funnum==18)
		 SMemory.LC0_MMODULE = sD6.mod+1;
		//break
		if(funnum==8)
			SBreak.LC0_BMODE = sD6.bmode;

	  DisplayValues(funnum);

	  }
	 else
	  {


	  }
	delete Dptr ;
}

////////////////////////////////////////////////////////////////////////
// ->StrToPar....() : grupa funkcji konwertujcych string do postaci numerycznej
// konwersja stringu do parametru numerycznego :
////////////////////////////////////////////////////////////////////////
void TTestD::StrToParHex(char * str , unsigned char *par)
{
  unsigned int x;
  sscanf(str,"%X",&x);
  *par=(unsigned char)x;
}

void TTestD::StrToParHex(char * str , unsigned int *par)
{
  unsigned int x;
  sscanf(str,"%X",&x);
  *par=(unsigned int)x;
}

void TTestD::StrToPar(char * str , unsigned char *par)
{
  unsigned int x;
  sscanf(str,"%u",&x);
  *par=(unsigned char)x;
}
void TTestD::StrToPar(char * str , char *par)
{
  unsigned int x;
  sscanf(str,"%d",&x);
  *par=(char)x;
}
void TTestD::StrToPar(char * str , unsigned int *par)
{
  sscanf(str,"%u",par);
}
void TTestD::StrToPar(char * str , unsigned long *par)
{

 sscanf(str,"%U",par);
}
void TTestD::StrToPar(char * str , int far* *par)
{
 sscanf(str,"%p",par);
}

void TTestD::StrToPar(char * str , float *par)
{
 sscanf(str,"%f",par);
}

char Spath[40];

////////////////////////////////////////////////////////////////////
// ->GetModInfo() : wykonuje funkcj LC0_ModuleInit
////////////////////////////////////////////////////////////////////
void TTestD::GetModInfo(int funnum)
{
 int i;
 int maska[]={1,2,4,8};
  if(funnum==0) //MODULE_INIT
	{
	  SModuleInit.LC0_IMODULE = 0 ;
	  for(i=0;i<4;i++)
		{
		  if((MOD[i]->GetCheck())==BF_CHECKED)
			SModuleInit.LC0_IMODULE |=maska[i];
		}
	}
}

/////////////////////////////////////////////////////////////////////////
// ->ReadParameters()
// Odczyt parametrw dialogu i ustawienie struktury funkcji o numerze
// 'funnames'
////////////////////////////////////////////////////////////////////////
void TTestD::ReadParameters(int funnames)			 //odczytuje parametry
{
 int j = 3;
 char str[20];
 unsigned char *ptr ;
 unsigned long lnum;
  switch(funnames)
	{
	  case 			0 :
							GetModInfo(funnum);
							//e[j++]->GetText(str,19);
							//StrToPar(str,&SModuleInit.LC0_IMODULE);
							break;
	  case 			1 :j=3;                     //gettotal

							break;
	  case 			2 :j=3;                     //getmodule
							e[j++]->GetText(str,19);
							StrToPar(str,&SModuleInfo.LC0_MMODULE);
							break;
	  case 			3 :j=3;                     //getinfo
							e[j++]->GetText(str,19);
							StrToPar(str,&SInfo.LC0_GTYPE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SInfo.LC0_GMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SInfo.LC0_GNUM);
							break;
	  case 			4 :j=3;                         //setclock
							e[j++]->GetText(str,19);
							StrToPar(str,&SClock.LC0_LCLOCK);
							break;
	  case 			5 :j=3;                     //setvoltage
							e[j++]->GetText(str,19);
							StrToPar(str,&SVolt.LC0_VMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SVolt.LC0_VTYPE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SVolt.LC0_VNUM);
							e[j++]->GetText(str,19);
							StrToPar(str,&(SVolt.LC0_VMINV));
							e[j++]->GetText(str,19);
							StrToPar(str,&(SVolt.LC0_VMAXV));
							e[j++]->GetText(str,19);
							StrToPar(str,&(SVolt.LC0_VAMPL));
							break;
	  case 			6 :j=3;                       //settime
							e[j++]->GetText(str,19);
							StrToPar(str,&STime.LC0_ETIME);
							break;
	  case 			7 :j=3;                     //waitforend
							e[j++]->GetText(str,19);
							StrToPar(str,&SWait.LC0_WMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SWait.LC0_WTYPE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SWait.LC0_WNUM);
							e[j++]->GetText(str,19);
							StrToPar(str,&SWait.LC0_WMODE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SWait.LC0_WRMNUM);
							e[j++]->GetText(str,19);
							StrToPar(str,&SWait.LC0_WREMAR);
							break;
	  case 			8 :j=3;                     //break
							e[j++]->GetText(str,19);
							StrToPar(str,&SBreak.LC0_BMODE);
							e[j++]->GetText(str,19);
							if(AppProc)
							 SBreak.LC0_BPROC = &(BreakProcApp);
							else
							 SBreak.LC0_BPROC = NULL ;
							//StrToPar(str,&((int far *)(SBreak.LC0_BPROC)));
							break;
	  case 			9 :j=3;                     //digin
							e[j++]->GetText(str,19);
							StrToPar(str,&SDigIn.LC0_DMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SDigIn.LC0_DNUM);

							SDigIn.LC0_DSTST = sel1 ;
							ptr = (unsigned char*)(&(SDigIn.LC0_DSTART));
							if(sel1!=6)
							 {
								*ptr = Spar[0];*(ptr+1) = Spar[1];*(ptr+2)=Spar[2];
								*(ptr+3) = Spar[3];*(ptr+4) = Spar[4];
							 }
							else
							 SDigIn.LC0_DSTART.time = Sptime ;

							break;
	  case 			10 :j=3;                    //digout
							e[j++]->GetText(str,19);
							StrToPar(str,&SDigOut.LC0_OMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SDigOut.LC0_ONUM);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SDigOut.LC0_OVAL);

							SDigOut.LC0_OSTST = sel1 ;
							ptr = (unsigned char*)(&(SDigOut.LC0_OSTART));
							if(sel1!=6)
							 {
								*ptr = Spar[0];*(ptr+1) = Spar[1];*(ptr+2)=Spar[2];
								*(ptr+3) = Spar[3];*(ptr+4) = Spar[4];
							 }
							else
							 SDigOut.LC0_OSTART.time = Sptime ;
							break;
	  case 			11 :j=3;                     //ctcwrite
							e[j++]->GetText(str,19);
							StrToPar(str,&SCTCW.LC0_CMODULE);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SCTCW.LC0_CMODE);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SCTCW.LC0_CFUN);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SCTCW.LC0_CVAL);
							break;
	  case 			12 :j=3;                    //ctcread
							e[j++]->GetText(str,19);
							StrToPar(str,&SCTCR.LC0_UMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SCTCR.LC0_UNUM);
							break;
	  case 			13 :j=3 ; //datatransm
							e[j++]->GetText(str,19);
							StrToPar(str,&STransmit.LC0_RMODULE);
							e[j++]->GetText(str,19);
							StrToParHex(str,&STransmit.LC0_RMODE);
							e[j++];//->GetText(str,19);
							//StrToPar(str,&STransmit.LC0_RADDR);
							(int huge *)(STransmit.LC0_RADDR) =ProgBufPtr ;
							e[j++]->GetText(str,19);
							StrToPar(str,&STransmit.LC0_RLEN);
							e[j++]->GetText(str,19);
							StrToPar(str,&STransmit.LC0_RMEAS);
							//korekcja bufora dla operacji A/C
							if((Mes.Single == FALSE) && (Mes.Kor ==TRUE) )
							 {
								ldiv_t lll;
								lll = ldiv(STransmit.LC0_RMEAS,(unsigned long)Mes.Chan);
								STransmit.LC0_RMEAS=(unsigned)lll.quot*(unsigned long)Mes.Chan +1L ;
							 }

							e[j++]->GetText(str,19);
							StrToPar(str,&STransmit.LC0_RNUM);
							e[j++]->GetText(str,19);
							StrToPar(str,&STransmit.LC0_RMEMA);
							break;
	  case 			14 :j=3;                               //analog input
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogIn.LC0_AMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogIn.LC0_ANUM);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SAnalogIn.LC0_AMODE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogIn.LC0_APER);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SAnalogIn.LC0_ACHAN);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogIn.LC0_APER2);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogIn.LC0_ALEN);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogIn.LC0_AMEMA);
							SAnalogIn.LC0_AADDR =ProgBufPtr ;
							SAnalogIn.LC0_ASTST = sel1 ;
							ptr = (unsigned char*)(&(SAnalogIn.LC0_ASTART));
							if(sel1!=6)
							 {
								*ptr = Spar[0];*(ptr+1) = Spar[1];*(ptr+2)=Spar[2];
								*(ptr+3) = Spar[3];*(ptr+4) = Spar[4];
							 }
							else
							 SAnalogIn.LC0_ASTART.time = Sptime ;
							SAnalogIn.LC0_ASTOP.samples = Samples ;

							break;
	  case 			15 :j=3;                                //analog output
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogOut.LC0_NMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogOut.LC0_NNUM);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SAnalogOut.LC0_NMODE);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SAnalogOut.LC0_NCHAN);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogOut.LC0_NPER);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogOut.LC0_NRMNUM);

							e[j++]->GetText(str,19);
							if(SAnalogOut.LC0_NMODE & LC0_MOD_EXT_MEM)
							 StrToPar(str,&SAnalogOut.LC0_NADDR.extended_memory);
							else
							 StrToPar(str,&SAnalogOut.LC0_NADDR.base_memory);
							e[j++]->GetText(str,19);
							StrToPar(str,&SAnalogOut.LC0_NLEN);
							//czytamy prbki
							e[j++]->GetText(str,19);
							StrToPar(str,&vca1);
							e[j++]->GetText(str,19);
							StrToPar(str,&vca2);
							//zapychamy nimi bufor
							int x1 , x2 ;
							if(vca1<-10.0)
							 vca1 = -10.0  ;
							if(vca2<-10.0)
							 vca2 = -10.0  ;
							if(vca1>=10.0)
							 vca1 = 9.9975  ;
							if(vca2>=10.0)
							 vca2 = 9.9975  ;

							unsigned char np ;
							np = SAnalogOut.LC0_NNUM ;
							if((np == 0) || (np > 2))
							 np = 1 ;
							IValues.SetValues(np+1,SAnalogOut.LC0_NMODULE,np);
							x1 = IValues.FloatToCode(np+1,vca1);
							x2 = IValues.FloatToCode(np+1,vca2);

							ProgBuf[0]=x1;
							ProgBuf[1]=x2;
							x1=ProgBuf[0];
							x2=ProgBuf[1];
							SAnalogOut.LC0_NSTST = sel1 ;
							//SAnalogOut.LC0_NADDR =ProgBufPtr ;
							ptr = (unsigned char*)(&(SAnalogOut.LC0_NSTART));
							if(sel1!=6)
							 {
								*ptr = Spar[0];*(ptr+1) = Spar[1];*(ptr+2)=Spar[2];
								*(ptr+3) = Spar[3];*(ptr+4) = Spar[4];
							 }
							else
							 SAnalogOut.LC0_NSTART.time = Sptime ;
							SAnalogOut.LC0_NSTOP.samples = Samples ;
							break;
	  case 			16 :                                    //leave
							break;
	  case 			17 :j=3;                                //interrupt
							e[j++]->GetText(str,19);
							StrToPar(str,&SInterrupt.LC0_SMODULE);
							e[j++]->GetText(str,19);
							StrToPar(str,&(int far *)SInterrupt.LC0_SPROC);
							e[j++]->GetText(str,19);
							StrToPar(str,&SInterrupt.LC0_SSTAT);
							break;
	  case 			18 :j=3;                                    //memory use
							e[j++]->GetText(str,19);
							StrToPar(str,&SMemory.LC0_MMODULE);
							e[j++]->GetText(str,19);
							StrToParHex(str,&SMemory.LC0_MMODE);
							e[j++]->GetText(str,19);
							StrToPar(str,&lnum);
							if(lnum > MAXEXTSIZE)
::MessageBox(this->HWindow,
"Przekroczony rozmiar bufora pamici\n\r rozszerzonej dla tej wersji programu",
"Info",MB_OK);
							else
							 SMemory.LC0_MNUM = lnum ;
							e[j++]->GetText(str,19);
							StrToPar(str,&SMemory.LC0_MRNUM);
							e[j++]->GetText(str,19);
							StrToPar(str,&SMemory.LC0_MRMEMA);
							break;
	}


}


/////////////////////////////////////////////////////////////////////////
// Po wciniciu przycisku WYKONAJ
/////////////////////////////////////////////////////////////////////////
void TTestD::OnRunClicked ()
{
	 // INSERT>> Your code here.
	 int f ,zx=0;
	 char err;
	 unsigned char mod;
	 HCURSOR hcurSave;
	 hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
	 f=(int)funnum;
	 // zbieramy parametry  z gwnego okna
	 ReadParameters(f);

	 //Zbieramy pozostae parametry , w tym warunki startu

	 switch(f)
	  {
		 case		0 :(*ModuleInit)(&SModuleInit);
						err=SModuleInit.LC0_STATUS ;
						break; //moduleinit
		 case		1 :(*GetTotalConfiguration)(&STotal);
						err=STotal.LC0_STATUS ;
						break; //gettotalconf
		 case		2 :(*GetModuleConfiguration)(&SModuleInfo);
						err=SModuleInfo.LC0_STATUS ;
						break; //getmoduleinf
		 case		3 :(*GetInfo)(&SInfo);
						err=SInfo.LC0_STATUS ;
						break; //getinfo
		 case		4 :(*SetClock)(&SClock);
						err=SClock.LC0_STATUS ;
						break; //setclock
		 case		5 :(*SetVoltage)(&SVolt);
						err=SVolt.LC0_STATUS ;
						break; //setvolt
		 case		6 :(*SetTime)(&STime);
						err=STime.LC0_STATUS ;
						break; //settime
		 case		7 :(*WaitForInt)(&SWait);
						err=SWait.LC0_STATUS ;
						break; //wait
		 case		8 :(*Break)(&SBreak);
						err=SBreak.LC0_STATUS ;
						break;
		 case		9 :(*DigitalIn)(&SDigIn);
						err=SDigIn.LC0_STATUS ;
						break; //digin
		 case		10 :(*DigitalOut)(&SDigOut);
						err=SDigOut.LC0_STATUS ;
						break; //digin
		 case		11 :(*CTCWrite)(&SCTCW)  ;
						err=SCTCW.LC0_STATUS ;
						break;
		 case		12 :(*CTCRead)(&SCTCR)  ;
						err=SCTCR.LC0_STATUS ;
						break;
		 case		13:(*DataTransmit)(&STransmit);
						err=STransmit.LC0_STATUS ;
						if(err==LC0_OK)
						{
						 if((Mes.Dtype ==0) ||(Mes.Dtype ==3))
						  Mes.Dtype =2;     //grafika
						 //szczegy
						 if((STransmit.LC0_RMODE & 0x01)==0) //z pam.rozszerzonej
						  {
							if(Mes.ProgBufEnable==FALSE)
							 {
							  Mes.ProgBufEnable=TRUE;
							  PSamples=STransmit.LC0_RRNUM;
							 }
						  }
						 else                               //do rozszerzonej
						  {
							 if(Mes.ExBufEnable==FALSE)
							 {
							  Mes.ExBufEnable=TRUE;
							  GSamples=STransmit.LC0_RRNUM;
							 }
						  }
						 MyUpdate(TRUE);
						}
						break;
		 case		14: SModuleInfo.LC0_MMODULE = SAnalogIn.LC0_AMODULE;
						(*GetModuleConfiguration)(&SModuleInfo);
						SAnalogIn.LC0_AMEMA=SModuleInfo.LC0_MMEMA;
						(*AnalogInput)(&SAnalogIn);
						Mes.TranslateBuf(&SAnalogIn,&SModuleInfo);

						err=SAnalogIn.LC0_STATUS ;
						if((err==LC0_OK) || (err == LC0_OTHER_LEN)|| (err == LC0_BROKEN))
						{
						 SGAnalogIn = SAnalogIn;
						 GSamples = /*Samples*/SAnalogIn.LC0_ARMNUM ;
						 if((SAnalogIn.LC0_AMODE & LC0_MOD_EXT_MEM)!=0)
							zx=1; //pami rozszerzona
						 if((SAnalogIn.LC0_AMODE & LC0_MOD_EXT_MEM)==0)
						  zx=2;  //pami podstawowa
						 if(((SAnalogIn.LC0_AMODE & LC0_MOD_EXT_MEM)!=0)&&
						 ((SAnalogIn.LC0_AMODE & LC0_MOD_MEM_W)!=0))
							zx=3; //pami podstawowa
						 if(zx!=0)
						  {
							if(zx>1)
							 {
							  Mes.ProgBufEnable=TRUE;
							  //Mes.ExBufEnable=FALSE;
							  if(zx==2)
								PSamples=SAnalogIn.LC0_ARMNUM ;
							  else
								PSamples=SAnalogIn.LC0_ARLEN;
							 }
							if((zx==1)||(zx==3))
							 {
							  //Mes.ProgBufEnable=FALSE;
							  Mes.ExBufEnable=TRUE;
							 }
							if(((Mes.ExMem==1) && (zx!=2)) || ((Mes.ExMem==0)&&(zx!=0)))
							 {
							  if((Mes.Dtype ==0) || (Mes.Dtype ==3))
								Mes.Dtype =2;     //grafika
							  MyUpdate(TRUE);
							 }
						  }
						}
						break;
		 case		15:(*AnalogOutput)(&SAnalogOut);
						err=SAnalogOut.LC0_STATUS ;
						break;
		 case		16 :(*Leave)(&SLeave);
						err=SLeave.LC0_STATUS ;
						if(err==LC0_OK)
						 {
						  Mes.Dtype=0; //zablokowanie wywietlania
						  Mes.ExBufEnable=FALSE;
						  MyUpdate();
						 }
						break; //leave
		 case		17 :(*Interrupt)(&SInterrupt);
						err=SInterrupt.LC0_STATUS ;
						break; //interrupt service
		 case		18 :(*MemoryUse)(&SMemory);
						//uzupenienie informacji o pamici rozszerzonej
						mod = SModuleInfo.LC0_MMODULE;
						SModuleInfo.LC0_MMODULE=SMemory.LC0_MMODULE;
						(*GetModuleConfiguration)(&SModuleInfo);
						SModuleInfo.LC0_MMODULE=mod;
						err=SMemory.LC0_STATUS ;
						if(err==LC0_OK)
						 {
						  Mes.Dtype=0; //zablokowanie wywietlania
						  Mes.ExBufEnable=FALSE;
						  MyUpdate(TRUE);
						 }
						break ; //memoty use
		 default		:  ::MessageBeep(-1);
							::MessageBox(this->HWindow,"Jeszcze nie zaimplementowane","I",MB_OK);
							break;

	  }

	 // przepisanie namiarw na bufor pamici rozszerzonej
	 STransmit.LC0_RMEMA =SModuleInfo.LC0_MMEMA ;
	 SAnalogIn.LC0_AMEMA =SModuleInfo.LC0_MMEMA ;

	 //wywietlenie wartoci
	 DisplayValues(funnum) ; //uzupenia pozostae pola w zalenoci od wybranej
									//funkcji
	 ::MessageBeep(-1);
	 ::SetCursor(hcurSave);

}

// moje funkcje
// wypenienie listy funkcji w zmiennej "combo"
void TTestD::FillCombo(char *FName[], int count)
{
  while (combo->DeleteString(0) > 0)	 ;
  for (int i = 0; i < count; i++)
  {
	 int index = combo->AddString(FName[i]);
	 combo->SetItemData(index, (DWORD)i);
  }
}

// ustawia combobox zgodnie ze zmienn itemData
void TTestD::SelectItemData(DWORD itemData)
{
  int count = combo->GetCount();
  combo->SetSelIndex(-1); //Clear the selection
  for (int i = 0; i < count; i++)
	 if (combo->GetItemData(i) == itemData) {
		combo->SetSelIndex(i);
		return;
	 }
}

///////////////////////////////////////////////////////////////////
// ->ParToStr...() : grupa funkcji zamieniajcych warto numeryczn
// na string
///////////////////////////////////////////////////////////////////

void TTestD::ParToStrHex(unsigned char par,char* str)
{
 sprintf(str,"%X",par);
 ZeroToStr(str,2);
}

void TTestD::ParToStrHex(unsigned int par,char* str)
{
 sprintf(str,"%X",par);
 ZeroToStr(str,4);
}

void TTestD::ParToStr(float par,char* str)
{
 sprintf(str,"%.3f",par);
}
void TTestD::ParToStr(int par , char* str ) //dla charw i int
{
  sprintf(str,"%d",par);
}
void TTestD::ParToStr(unsigned int par , char* str ) //dla charw i int
{
  sprintf(str,"%u",par);
}
void TTestD::ParToStr(unsigned long par, char* str)//4 b
{
 sprintf(str,"%lu",par);
}
void TTestD::ParToStr(int far * par , char* str) //wskazania
{
 sprintf(str,"%p",par);
}

////////////////////////////////////////////////////////////////////////
// ->SetModInfo()
// uaktualnienie informacji o moduach : jakie s zainstalowane
// Parametr : funnum : numer funkcji driver'a z dialogu
////////////////////////////////////////////////////////////////////////
void TTestD::SetModInfo(int funnum)
{
 int i ;
 int mask[]={1,2,4,8};
  if(funnum==0) //MODULE_INIT
	{
		ST->SetText(TST[0]);
		for(i=0;i<4;i++)
		 {
		  if((SModuleInit.LC0_IMODULE & mask[i]) !=0)
			MOD[i]->SetCheck(BF_CHECKED);
		  else
			MOD[i]->SetCheck(BF_UNCHECKED);
		  MOD[i]->EnableWindow(TRUE);
		 }

	}
  else
	{
		ST->SetText(TST[1]);
		for(i=0;i<4;i++)
		 {
		  if((STotal.LC0_TONF & mask[i]) !=0)
			MOD[i]->SetCheck(BF_CHECKED);
		  else
			MOD[i]->SetCheck(BF_UNCHECKED);
		  MOD[i]->EnableWindow(FALSE);
		 }
	}
}


//////////////////////////////////////////////////////////////////////
// DisplayValues
// ustawienie wszystkich pl zgodnie z wybran funkcj 'funnames'
//////////////////////////////////////////////////////////////////////
void TTestD::DisplayValues(DWORD funnames)
{
 int i ,f;
 char err,ex , str[20];


 f=(int)funnames ;
 //czyszcenie pl
 for(i=0;i<16;i++)
  {
	e[i]->SetText("");
  }
 for(i=0;i<13;i++)
  l[i]->SetText("");
 int j=3;
 switch(f)
  {
	case		0		:
						 SModuleInit.LC0_CODE=0 ;
						 err=SModuleInit.LC0_STATUS;
						 ex=SModuleInit.LC0_ERR_STAT;
						 break;
	case		1		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TTotal[i]);
						 STotal.LC0_CODE=1 ;
						 err=STotal.LC0_STATUS;
						 ex=STotal.LC0_ERR_STAT;
						 j =3;
						 ParToStrHex(STotal.LC0_TONF,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)STotal.LC0_TIAD,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)STotal.LC0_TIDA,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)STotal.LC0_TCTC,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)STotal.LC0_TIDI,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)STotal.LC0_TIDO,str);
						 e[(j++)]->SetText(str);
						 break;
	case		2		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TModuleInfo[i]);
						 SModuleInfo.LC0_CODE =2;
						 err=SModuleInfo.LC0_STATUS;
						 ex=SModuleInfo.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SModuleInfo.LC0_MMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SModuleInfo.LC0_MBASE1,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SModuleInfo.LC0_MIAD,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SModuleInfo.LC0_MIDA,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SModuleInfo.LC0_MCTC,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SModuleInfo.LC0_MIDI,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SModuleInfo.LC0_MIDO,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SModuleInfo.LC0_MCLOCK,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SModuleInfo.LC0_MINT,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SModuleInfo.LC0_MMEMA,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SModuleInfo.LC0_MMEML,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SModuleInfo.LC0_MBASE2,str);
						 e[(j++)]->SetText(str);
						 break;
  case		3		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TInfo[i]);
						 SInfo.LC0_CODE=3;
						 err=SInfo.LC0_STATUS;
						 ex=SInfo.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SInfo.LC0_GTYPE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GMODULE,str);
						 e[+(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GCHAN,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GRES,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GTIME,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GMINV,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GMAXV,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SInfo.LC0_GDMA,str);
						 e[(j++)]->SetText(str);
						 break;
  case		4		:SClock.LC0_CODE=4 ;
						 err=SClock.LC0_STATUS;
						 ex=SClock.LC0_ERR_STAT;
						 for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TClock[i]);
						 ParToStr((unsigned int)SClock.LC0_LCLOCK,str);
						 e[(j++)]->SetText(str);
						 j=3;
						 break;
  case		5		:
						 SVolt.LC0_CODE=5 ;
						 err=SVolt.LC0_STATUS;
						 ex=SVolt.LC0_ERR_STAT;
						 for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TVolt[i]);
						 j=3;
						 ParToStr((int)SVolt.LC0_VMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SVolt.LC0_VTYPE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SVolt.LC0_VNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SVolt.LC0_VMINV,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SVolt.LC0_VMAXV,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SVolt.LC0_VAMPL,str);
						 e[(j++)]->SetText(str);
						 break;
  case		6		:STime.LC0_CODE=6 ;
						 err=STime.LC0_STATUS;
						 ex=STime.LC0_ERR_STAT;
						 for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TSet[i]);
						 j=3;
						 ParToStr((unsigned int)STime.LC0_ETIME,str);
						 e[(j++)]->SetText(str);
						 break;
  case		7		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TWait[i]);
						 j=3;
						 ParToStr((int)SWait.LC0_WMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SWait.LC0_WTYPE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SWait.LC0_WNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SWait.LC0_WMODE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((unsigned long)SWait.LC0_WRMNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr((unsigned int)SWait.LC0_WREMAR,str);
						 e[(j++)]->SetText(str);
						 SWait.LC0_CODE=7 ;
						 err=SWait.LC0_STATUS;
						 ex=SWait.LC0_ERR_STAT;
						 break;
  case		8		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TBreak[i]);
						 SBreak.LC0_CODE=0 ;
						 err=SBreak.LC0_STATUS;
						 ex=SBreak.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SBreak.LC0_BMODE,str);
						 e[(j++)]->SetText(str);
						 if(AppProc)
						  SBreak.LC0_BPROC = &(BreakProcApp);
						 else
						  SBreak.LC0_BPROC = NULL ;
						 ParToStr((int far*)SBreak.LC0_BPROC,str);
						 e[(j++)]->SetText(str);
						 break;

  case		9		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TDigIn[i]);
						 SDigIn.LC0_CODE =9;
						 err=SDigIn.LC0_STATUS;
						 ex=SDigIn.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SDigIn.LC0_DMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SDigIn.LC0_DNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SDigIn.LC0_DVAL,str);
						 e[(j++)]->SetText(str);
						 break;
  case		10		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TDigOut[i]);
						 SDigOut.LC0_CODE =10;
						 err=SDigOut.LC0_STATUS;
						 ex=SDigOut.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SDigOut.LC0_OMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SDigOut.LC0_ONUM,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SDigOut.LC0_OVAL,str);
						 e[(j++)]->SetText(str);
						 break;
  case		11		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TCTCW[i]);
						 SCTCW.LC0_CODE=11 ;
						 err=SCTCW.LC0_STATUS;
						 ex=SCTCW.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SCTCW.LC0_CMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SCTCW.LC0_CMODE,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SCTCW.LC0_CFUN,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SCTCW.LC0_CVAL,str);
						 e[(j++)]->SetText(str);
						 break;
  case		12		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TCTCR[i]);
						 SCTCR.LC0_CODE=12 ;
						 err=SCTCR.LC0_STATUS;
						 ex=SCTCR.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SCTCR.LC0_UMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SCTCR.LC0_UNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SCTCR.LC0_UVAL,str);
						 e[(j++)]->SetText(str);
						 break;
  case		13		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TDataT[i]);
						 STransmit.LC0_CODE=13 ;
						 err=STransmit.LC0_STATUS;
						 ex=STransmit.LC0_ERR_STAT;
						 j=3;

						 ParToStr((int)STransmit.LC0_RMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(STransmit.LC0_RMODE,str);
						 e[(j++)]->SetText(str);
						 ParToStr(STransmit.LC0_RADDR,str);
						 e[(j++)]->SetText(str);
						 ParToStr(STransmit.LC0_RLEN,str);
						 e[(j++)]->SetText(str);
						 ParToStr(STransmit.LC0_RMEAS,str);
						 e[(j++)]->SetText(str);
						 ParToStr(STransmit.LC0_RNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr(STransmit.LC0_RMEMA,str);
						 e[(j++)]->SetText(str);
						 ParToStr(STransmit.LC0_RRNUM,str);
						 e[(j++)]->SetText(str);
						 break;
  case		14		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TAnalogIn[i]);
						 SAnalogIn.LC0_CODE=14 ;
						 err=SAnalogIn.LC0_STATUS;
						 ex=SAnalogIn.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SAnalogIn.LC0_AMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SAnalogIn.LC0_ANUM,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SAnalogIn.LC0_AMODE,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_APER,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SAnalogIn.LC0_ACHAN,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_APER2,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_ALEN,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_AMEMA,str);
						 e[(j++)]->SetText(str);
						 ParToStr((unsigned int)SAnalogIn.LC0_ARDIV1,str);
						 e[(j++)]->SetText(str);
						 ParToStr((unsigned int)SAnalogIn.LC0_ARDIV2,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_ARMNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_ARLEN,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogIn.LC0_ARBUF,str);
						 e[(j++)]->SetText(str);
						 break;
  case		15		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TAnalogOut[i]);
						 SAnalogOut.LC0_CODE=15 ;
						 err=SAnalogOut.LC0_STATUS;
						 ex=SAnalogOut.LC0_ERR_STAT;
						 j=3;
						 ParToStr((int)SAnalogOut.LC0_NMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int)SAnalogOut.LC0_NNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SAnalogOut.LC0_NMODE,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SAnalogOut.LC0_NCHAN,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogOut.LC0_NPER,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SAnalogOut.LC0_NRMNUM,str);
						 e[(j++)]->SetText(str);

						 if(SAnalogOut.LC0_NMODE & LC0_MOD_EXT_MEM)
						  ParToStr(SAnalogOut.LC0_NADDR.extended_memory,str);
						 else
						  ParToStr(SAnalogOut.LC0_NADDR.base_memory,str);
						 e[(j++)]->SetText(str);

						 ParToStr(SAnalogOut.LC0_NLEN,str);
						 e[(j++)]->SetText(str);
						 UINT x1,x2;
						 x1=*(ProgBufPtr);
						 x2=*(ProgBufPtr+1) ;

						 unsigned char np ;
						 np = SAnalogOut.LC0_NNUM ;
						 if((np == 0) || (np > 2))
						  np = 1 ;

						 IValues.SetValues(np+1,SAnalogOut.LC0_NMODULE,np);
						 vca1=IValues.CodeToFloat(np+1,x1);
						 vca2=IValues.CodeToFloat(np+1,x2);

						 ParToStr(vca1,str);
						 e[(j++)]->SetText(str);
						 ParToStr(vca2,str);
						 e[(j++)]->SetText(str);
						 break;
  case		16		:SLeave.LC0_CODE=16 ;
						 err=SLeave.LC0_STATUS;
						 ex=SLeave.LC0_ERR_STAT;
						 break;
  case		17		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TInterrupt[i]);
						 j=3;
						 ParToStr((int)SInterrupt.LC0_SMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStr((int far*)SInterrupt.LC0_SPROC,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SInterrupt.LC0_SSTAT,str);
						 e[(j++)]->SetText(str);
						 SInterrupt.LC0_CODE=17 ;
						 err=SInterrupt.LC0_STATUS;
						 ex=SInterrupt.LC0_ERR_STAT;
						 break;
  case		18		:for(i=0;i<FunT[f]-3;i++)
							l[i]->SetText(TMemory[i]);
						 j=3;
						 ParToStr((int)SMemory.LC0_MMODULE,str);
						 e[(j++)]->SetText(str);
						 ParToStrHex(SMemory.LC0_MMODE,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SMemory.LC0_MNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SMemory.LC0_MRNUM,str);
						 e[(j++)]->SetText(str);
						 ParToStr(SMemory.LC0_MRMEMA,str);
						 e[(j++)]->SetText(str);
						 err=SMemory.LC0_STATUS;
						 ex=SMemory.LC0_ERR_STAT;
						 break;
  }
  SetModInfo(funnum);
  sprintf(str,"%d",f+16);
  e[0]->SetText(str); //kod
  if(err==LC0_OK)
	e[1]->SetText("LC0_OK")    ;
  else
	{
	  if(err>= 1 && err<= WARR)
		 e[1]->SetText(DriverWarnings[err -1]) ;
	  if(err<=-1 && err>= ERR)
		 e[1]->SetText(DriverErrors[-err -1]) ;
	}
  if(ex==LC0_E_OK)
	e[2]->SetText("LC0_E_OK");
  else
	if(ex<=-1 && ex>= ADDERR)
	  e[2]->SetText(DriverAdditionalErrors[-ex -1]);
}


///////////////////////////////////////////////////////////////////////
// Pozostae funkcje wirtualne i obsugi komunikatw
///////////////////////////////////////////////////////////////////////

void TTestD::SetupWindow ()
{
	 TDialog::SetupWindow();

	 // INSERT>> Your code here.

	 unsigned char np ;
	 np = SAnalogOut.LC0_NNUM ;
	 if((np == 0) || (np > 2))
	  np = 1 ;
	 IValues.SetValues(np+1,SAnalogOut.LC0_NMODULE,np);
	 vca1=IValues.CodeToFloat(np+1,*(ProgBufPtr));
	 vca2=IValues.CodeToFloat(np+1,*(ProgBufPtr+1));
	 FillCombo(FunNames,19);
	 SelectItemData(funnum);
	 //dalsza inicjacja
	 DisplayValues(funnum) ; //uzupenia pozostae pola w zalenoci od wybranej
									//funkcji
}

// po wyborze nowej funkcji z listy
void TTestD::OnCBNEditchange ()
{
	 // INSERT>> Your code here.
}


void TTestD::OnCBNSelendok ()
{
	 // INSERT>> Your code here.
	 unsigned char np ;
	 np = SAnalogOut.LC0_NNUM ;
	 if((np == 0) || (np > 2))
	  np = 1 ;
	 IValues.SetValues(np+1,SAnalogOut.LC0_NMODULE,np);
	 vca1=IValues.CodeToFloat(np+1,*(ProgBufPtr));
	 vca2=IValues.CodeToFloat(np+1,*(ProgBufPtr+1));
	 int inx ;

	 inx=combo->GetSelIndex();
	 funnum= combo->GetItemData(inx);
	 DisplayValues(funnum);

}

//////////////////////////////////////////////////////////////////////////////
//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TParD, TDialog)
//{{TParDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_BN_CLICKED(IDC_RADIO1, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO2, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO3, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO4, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO5, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO6, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO7, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO8, OnRadio),
	 EV_BN_CLICKED(IDC_RADIO9, OnRadio),
//{{TParDRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TParD Implementation}}

char *PS3[]=
{
 "nr moduu",
 "nr portu",
 "nr wejcia",
 "warto",
};
char *PS4[]=
{
 "nr moduu",
 "nr portu",
 "nr wejcia",
 "rodzaj zbocza",
};
char *PS5[]=
{
 "nr moduu",
 "nr portu",
 "maska   [Hex]",
 "wzorzec [Hex]",
};

char *PS6[]=
{
 "sekunda",
 "minuta ",
 "godzina",
 "dzie",
};
char *PS8[]=
{
 "nr moduu",
 "nr przetwornika ",
 "kana/tryb [HEX]",
 "prg       [HEX]",
};


static TParDXfer TParDData;

//////////////////////////////////////////////////////////////////////
// Klasa 'TParD' : okno dialogowe dla parametrw startu
//////////////////////////////////////////////////////////////////////
TParD::TParD (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
//{{TParDXFER_USE}}
	 Radio1 = new TRadioButton(this, IDC_RADIO1, 0);
	 Radio2 = new TRadioButton(this, IDC_RADIO2, 0);
	 Radio3 = new TRadioButton(this, IDC_RADIO3, 0);
	 Radio4 = new TRadioButton(this, IDC_RADIO4, 0);
	 Radio5 = new TRadioButton(this, IDC_RADIO5, 0);
	 Radio6 = new TRadioButton(this, IDC_RADIO6, 0);
	 Radio7 = new TRadioButton(this, IDC_RADIO7, 0);
	 Radio8 = new TRadioButton(this, IDC_RADIO8, 0);
	 Radio9 = new TRadioButton(this, IDC_RADIO9, 0);


SetTransferBuffer(&TParDData);
//{{TParDXFER_USE_END}}

	 // INSERT>> Your constructor code here.
	 TR1[0] = Radio1 ;TR1[1] = Radio2 ;TR1[2] = Radio3 ;TR1[3] = Radio4 ;
	 TR1[4] = Radio5 ;TR1[5] = Radio6 ;TR1[6] = Radio7 ;TR1[7] = Radio8 ;
	 TR1[8] = Radio9 ;

	 int i;
	 for(i=0;i<3;i++)
	  e[i]= (TEdit*)(new TEdit(this,IDC_EDIT17+i,3));

	 e[3] = (TEdit*)(new TEdit(this,IDC_EDIT20,5));
	 e[4] = (TEdit*)(new TEdit(this,IDC_EDIT21,3));

	 for(i=0;i<5;i++)
	  O[i]=new TStatic(this,IDC_PS_1+i);
}

//destruktor
TParD::~TParD ()
{
	 Destroy();

	 // INSERT>> Your destructor code here.

}

///////////////////////////////////////////////////////////////////////////
// PONIEJ UYWANE FUNKCJIE WIRTUALNE I OBSUGI KOMUNIKATW DLA KLASY
// 'TParD'
///////////////////////////////////////////////////////////////////////////

void TParD::OnOKClicked ()
{
	 // INSERT>> Your code here.
	 GetRadio(&Psel,&sel2);
	 GetParam();
	 int i;
	 for(i=0;i<5;i++)
	  Spar[i]=PPar[i];
	 Sptime = PTime;
	 sel1=Psel;
	 Destroy();
}


void TParD::SetupWindow ()
{
	 TDialog::SetupWindow();
	 int i;

	 // INSERT>> Your code here.
	 for(i=0;i<5;i++)
	  PPar[i]=Spar[i];
	 PTime = Sptime;
	 Psel=sel1;
	 SetRadio(Psel,sel2);
	 SetParam();
	 //opis okienek
	 switch(Psel)
	  {
		case	0 :
		case	1 :for(i=0;i<5;i++)
					 {
						O[i]->ShowWindow(SW_HIDE);
						e[i]->ShowWindow(SW_HIDE);
					 }
					break;//simmed i hard
		case	2 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW);
						O[i]->SetText(PS3[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//level
		case	3 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW);
						O[i]->SetText(PS4[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//slope
		case  4 :
		case	5 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW) ;
						O[i]->SetText(PS5[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//eq  neq
		case	7 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW) ;
						O[i]->SetText(PS6[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//date
		case	6 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_HIDE);
						e[i]->ShowWindow(SW_HIDE);
					 }
					O[4]->ShowWindow(SW_SHOW);
					e[4]->ShowWindow(SW_SHOW);
					break;//time
		case	8 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW) ;
						O[i]->SetText(PS8[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//analog

	  };
}

void TParD::OnRadio()
{
 int i;
 GetRadio(&Psel,&sel2);
 GetParam() ;
 switch(Psel)
	  {
		case	0 :
		case	1 :for(i=0;i<5;i++)
					 {
						O[i]->ShowWindow(SW_HIDE);
						e[i]->ShowWindow(SW_HIDE);
					 }
					break;//simmed i hard
		case	2 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW);
						O[i]->SetText(PS3[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//level
		case	3 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW);
						O[i]->SetText(PS4[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//slope
		case  4 :
		case	5 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW) ;
						O[i]->SetText(PS5[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//eq  neq
		case	7 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW) ;
						O[i]->SetText(PS6[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//date
		case	6 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_HIDE);
						e[i]->ShowWindow(SW_HIDE);
					 }
					O[4]->ShowWindow(SW_SHOW);
					e[4]->ShowWindow(SW_SHOW);
					break;//time
		case	8 :for(i=0;i<4;i++)
					 {
						O[i]->ShowWindow(SW_SHOW);
						e[i]->ShowWindow(SW_SHOW) ;
						O[i]->SetText(PS8[i]);
					 }
					O[4]->ShowWindow(SW_HIDE);
					e[4]->ShowWindow(SW_HIDE);
					break;//analog

	  };
	  SetParam();
}


//sprawdza ktry button jest wcinity
void TParD::GetRadio(int *r1 ,int *r2)
{
  int i ;
  for(i=0;i<9;i++)
	{
	  if(TR1[i]->GetCheck() == BF_CHECKED)
		{
		  *r1 = i ;
		  break ;
		}
	}

}

//ustawia odpowiedni button -1 , 0 ++
void TParD::SetRadio(int r1 , int r2)
{
  int i ;
 for(i=0;i<9;i++)
  {
	TR1[i]->SetCheck(BF_UNCHECKED);
  }
  TR1[r1]->SetCheck(BF_CHECKED);

}


//pobiera parametry z okna i ustawia zmienne
void TParD::GetParam()
{
  int i ;
  char tab[10];
  unsigned int PP[4];
  for(i=0;i<5;i++)
	{
		e[i]->GetText(tab,9);
		if(i<2)
		 sscanf(tab,"%u",&(PP[i]));

		if((i==2) || (i==3))
		 {
		  if((Psel==4) || (Psel==5) || (Psel==8))
			sscanf(tab,"%X",&(PP[i])); //hex
		  else
			sscanf(tab,"%u",&(PP[i]));
		 }
		if(i==4)
		 sscanf(tab,"%lu",&PTime);
		else
		 {
		  if((Psel==8) && (i==3))
			{
			 PPar[3]=(unsigned char)(PP[3] & 0x00ff);
			 PPar[4]=(unsigned char)(PP[3]>>8);
			}
		  else
			PPar[i]=(unsigned char)PP[i];
		 }
	}
}


//ustawia parametry okna
void TParD::SetParam()
{
  char tab[10];
  int i ;
  unsigned int val ;
  for(i=0;i<5;i++)
	{
	  if(i<2)
		sprintf(tab,"%u",PPar[i]);
	  if((i==2) || (i==3))
		{
		 if((Psel==4) || (Psel==5) || ((Psel==8)&&(i==2)))
		  {
			sprintf(tab,"%X",PPar[i]);
			ZeroToStr(tab,2);
		  }
		 else
		  if((Psel==8)&&(i==3))
			{
			 val = (unsigned int)PPar[3] + ((unsigned int)PPar[4]<<8) ;
			 sprintf(tab,"%X",val);
			 ZeroToStr(tab,4);
			}
		  else
			sprintf(tab,"%u",PPar[i]);
		}
	  if(i==4)
		sprintf(tab,"%lu",PTime);
	  e[i]->SetText(tab);
	}
}

//////////////////////////////////////////////////////////////////////
// funkcja BreakProcApp() : obsuga CTRL-BRAK programu
///////////////////////////////////////////////////////////////////////
void FAR BreakProcApp()
{
  ::MessageBeep(-1);
  ::MessageBox(NULL,"Sygna z aplikacji : przerwanie procesu","LCWIN.EXE info",MB_OK);
}


// float to code -10 .. 10 zaoenie rozdzielczo : nie uywana
int FloatToCode(float val)
{
  int x1 ;
  if(val>10.0)
	return 4095;

  if(val<-10.0)
	return 0.0;
  x1=(int)(((val +10.0)*4096.0)/20.0);
  return x1;
}

//  code -10 .. 10 to float zaoenie rozdzielczo : nie uywana
float CodeToFloat(int val)
{
 float x1;
 if(val<0)
  return -10.0;
 if(val >4095)
  return 9.995;
 x1=20.0*val/(4096.0) - 10.0;
 return x1;
}

////////////////////////////////////////////////////////////////////////
// klasa CValues : opreracje konwersji prbka <> warto mV i inne
////////////////////////////////////////////////////////////////////////
CValues::CValues()
{
  ACV1 = -10.0 ; ACV2 = 10.0 ;
  CA1V1 = -10.0 ; CA1V2 = 10.0 ;
  CA2V1 = -10.0 ; CA2V2 = 10.0 ;
  M1V1 = -10.0 ; M1V2 = 10.0 ;
  M2V1 = -10.0 ; M2V2 = 10.0 ;
}

// konwersja U2 -> BIN
unsigned int CValues::U2Bin(unsigned int code)
{
 if(code<=0x07ff)
  return (0x0800+code);
 else
  return(code - 0x0800);
}

////////////////////////////////////////////////////////////////////////////////
// ->SetValues() : ustawia zmienne wewnetrzne klasy
// Parametry :
//  nr : 1,4,5 : dotyczy A/C ; 2,3 - C/A
// modnum		: numer moduu
// num			: numer preztwornika
////////////////////////////////////////////////////////////////////////////////
void CValues::SetValues(int nr , unsigned char modnum,unsigned char num)  //ustawia zmienne
{
 lc0_info Info ;
 Info.LC0_CODE = 3 ;
 Info.LC0_GMODULE = modnum ;
 float v1,v2 ;
  switch(nr)
	{
	  case 1		:    /* A/C */
	  case 4		:
	  case 5		:
						Info.LC0_GTYPE = 3 ;
						Info.LC0_GNUM = 1 ;
						break ; //A/C pomiar
	  case 2		:
	  case 3		:
						 Info.LC0_GTYPE = 4 ;
						Info.LC0_GNUM = num ;
						break ; //C/A pomiar
	}
  (*GetInfo)((struct lc0_info FAR *)&Info); //pobranie informacji
  if(Info.LC0_STATUS == LC0_OK)
	{
	  v1 = (float)Info.LC0_GMINV /10.0  ;v2 = (float)Info.LC0_GMAXV / 10.0 ;
	  if((v2-  v1 < 5.0) || (v2-  v1 > 20.0) ) //bd
		return ; //bez zmiany parametrw
	  switch(nr)
		{
			case 1	:ACV1 = v1 ; ACV2 = v2 ;
						 break ;
			case 2	:CA1V1 = v1 ; CA1V2 = v2 ;
						 break ;
			case 3	:CA2V1 = v1 ; CA2V2 = v2 ;
						 break ;
			case 4	:M1V1 = v1 ; M1V2 = v2 ;
						 break ;
			case 5	:M2V1 = v1 ; M2V2 = v2 ;
						 break ;
		}

	}
  else //gdy jaki bd
	{
	 ACV1 = -10.0 ; ACV2 = 10.0 ;
	 CA1V1 = -10.0 ; CA1V2 = 10.0 ;
	 CA2V1 = -10.0 ; CA2V2 = 10.0 ;
	 M1V1 = -10.0 ; M1V2 = 10.0 ;
	 M2V1 = -10.0 ; M2V2 = 10.0 ;
	}
}

// konwersja prbka -> V
int CValues::FloatToCode(int nr , float f)
{
 float v1 , v2 ,vv;
 unsigned int x1 ;
 switch(nr)
  {
	 case 1	:v1 = ACV1 ; v2 = ACV2 ;
				 break ;
	 case 2	:v1 = CA1V1 ; v2 = CA1V2 ;
				 break ;
	 case 3	:v1 = CA2V1 ; v2 = CA2V2 ;
				 break ;
	 case 4	:v1 = M1V1 ; v2 = M1V2 ;
				 break ;
	 case 5	:v1 = M2V1 ; v2 = M2V2 ;
				 break ;
  }
	 if(f>v2)
	  return 4095;
	 if(f<v1)
	  return 0;
	 vv=((f - v1)*4096.0)/(v2 - v1);
	 x1=(unsigned int)vv ;
	 if(vv-(float)x1 >= 0.5)
	  x1+=1;
	 if(x1 > 4095)
		x1 = 4095 ;

  return x1;
}

// konwersja prbka -> V zarwno dla A/C jak i C/A
float CValues::CodeToFloat(int nr ,  int c)
{
 float v1 , v2 ;
 float x1 ;
 switch(nr)
  {
	 case 1	:v1 = ACV1 ; v2 = ACV2 ;
				 break ;
	 case 2	:v1 = CA1V1 ; v2 = CA1V2 ;
				 break ;
	 case 3	:v1 = CA2V1 ; v2 = CA2V2 ;
				 break ;
	 case 4	:v1 = M1V1 ; v2 = M1V2 ;
				 break ;
	 case 5	:v1 = M2V1 ; v2 = M2V2 ;
				 break ;
  }

	if(c<0)
	 return v1;//Umin
	if(c >4095)
	 return (v2 - (1.0/4096.0));
	x1=(v2-v1)*(float)c/(4096.0) +v1;

 return x1;
}

////////////////////////////////////////////////////////////////////////
// ->CodeToDisplay()
// Do Wywietlania w mV , 10 i HEX
// nr - nr urzdzenia : 1,3,4 - A/C
// code - kod przetwornika
// typ - rodzaj do wywietlenia : 0 - 10
//											 1 - HEX
//											 2-  MV
// str - acuch reprezentujcy dan
/////////////////////////////////////////////////////////////////////////
void CValues::CodeToDisplay(int nr , int code,int typ,char *str,int x)
{
 switch(typ)
  {
	 case 0 :sprintf(str,"%u",code);
				break;
	 case 1 :sprintf(str,"%X",code);
				ZeroToStr(str,3);
				break;
	 case 2 :if(x==0)
				 sprintf(str,"%.0f",CodeToFloat(nr,code)*1000.0);
				else
				 sprintf(str,"%.2f",CodeToFloat(nr,code)*1000.0);
				break;
  };
}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TParMD, TDialog)
//{{TParMDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_BN_CLICKED(IDCANCEL, OnCancelClicked),
	 EV_WM_QUERYDRAGICON,
	 EV_WM_PAINT,
	 EV_WM_CLOSE,
//{{TParMDRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TParMD Implementation}}


static TParMDXfer TParMDData;

///////////////////////////////////////////////////////////////////////////
// klasa TParMD : parametry programu - okno dialogowe
///////////////////////////////////////////////////////////////////////////
TParMD::TParMD (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
//{{TParMDXFER_USE}}
	 MyIcon = ::LoadIcon(hInst,MAKEINTRESOURCE(IDI_PARDIALOG));
	 dWindow = this;
	 MonChan1 = new TEdit(this, IDC_EP2, 255);
	 MonChan2 = new TEdit(this, IDC_EP3, 255);
	 MonSamp = new TEdit(this, IDC_EP4, 255);
	 Mod1 = new TEdit(this, IDC_EP5, 255);
	 Mod2 = new TEdit(this, IDC_EP6, 255);
	 ExBuf	= new TCheckBox(this,IDC_CHP1,0);
	 Kod[0]=new TRadioButton(this,IDC_D3_NKB);
	 Kod[1]=new TRadioButton(this,IDC_D3_U2);
	 DMod[0]=new TRadioButton(this,IDC_D3_D);
	 DMod[1]=new TRadioButton(this,IDC_D3_HEX);
	 DMod[2]=new TRadioButton(this,IDC_D3_MV);
	 int i;
	 for(i=0;i<4;i++)
	  WK[i]=new TRadioButton(this,IDC_WK1+i);

	 SetTransferBuffer(&TParMDData);
//{{TParMDXFER_USE_END}}

	 // INSERT>> Your constructor code here.

}

//destruktor
TParMD::~TParMD ()
{
	 //Destroy();

	 // INSERT>> Your destructor code here.

}

/////////////////////////////////////////////////////////////////////////
// POMIEJ FUNKCJE WIRTUALNE I ZADEKLAROWANE OBSUGI KOMUNIKATW
/////////////////////////////////////////////////////////////////////////

HANDLE TParMD::EvQueryDragIcon()
 {
	return(MyIcon)   ;

 }


void TParMD::EvPaint()
{
 TRect R;
 HDC dc;
 DWORD kol;
  ((TDialog*)(this))->EvPaint();
	if (this->IsIconic())
	 {
		// wyswietlic ikone
		R=this->GetClientRect();
		dc=::GetWindowDC(this->HWindow);
		::DrawIcon(dc,R.left+2,R.top+2,MyIcon);
		::ReleaseDC(this->HWindow,dc);
	 }
}

void TParMD::EvClose()
{
  dWindow=NULL;
  Destroy();
}

void TParMD::OnCancelClicked()
{
  dWindow = NULL;
  Destroy();

}

void TParMD::SetupWindow ()
{
	 int i;
	 TDialog::SetupWindow();

	 // INSERT>> Your code here.
	 char tab[20];


	 sprintf(tab,"%u",Mes.MonChan1);
	 MonChan1->SetText(tab);
	 sprintf(tab,"%u",Mes.MonChan2);
	 MonChan2->SetText(tab);


	 sprintf(tab,"%u",Mes.Mod1);
	 Mod1->SetText(tab);
	 sprintf(tab,"%u",Mes.Mod2);
	 Mod2->SetText(tab);

	 sprintf(tab,"%u",Mes.MonSamp);
	 MonSamp->SetText(tab);

	 if(Mes.ExMem)
	  ExBuf->SetCheck(BF_CHECKED);
	 else
	  ExBuf->SetCheck(BF_UNCHECKED);

	 for(i=0;i<2;i++)
	  if(Mes.ACKod==i)
		Kod[i]->SetCheck(BF_CHECKED);
	  else
		Kod[i]->SetCheck(BF_UNCHECKED);

	 for(i=0;i<3;i++)
	  if(Mes.DMode==i)
		DMod[i]->SetCheck(BF_CHECKED);
	  else
		DMod[i]->SetCheck(BF_UNCHECKED);

	  for(i=0;i<4;i++)
	  if(Mes.GKan==i+1)
		WK[i]->SetCheck(BF_CHECKED);
	  else
		WK[i]->SetCheck(BF_UNCHECKED);

}


void TParMD::OnOKClicked ()
{
	 // INSERT>> Your code here.
	 char tab[20];
	 int i;
	 int k = Mes.Chan ;

	 MonChan1->GetText(tab,3);
	 sscanf(tab,"%u",&(Mes.MonChan1));
	 if((Mes.MonChan1==0) || (Mes.MonChan1>16))
	  Mes.MonChan1=1;

	 MonChan2->GetText(tab,3);
	 sscanf(tab,"%u",&(Mes.MonChan2));
	 if((Mes.MonChan2==0) || (Mes.MonChan2>16))
	  Mes.MonChan2=1;

	 Mod1->GetText(tab,3);
	 sscanf(tab,"%u",&(Mes.Mod1));
	 if((Mes.Mod1==0) || (Mes.Mod1>4))
	  Mes.Mod1=1;

	 Mod2->GetText(tab,3);
	 sscanf(tab,"%u",&(Mes.Mod2));
	 if((Mes.Mod2==0) || (Mes.Mod2>4))
	  Mes.Mod2=1;

	 MonSamp->GetText(tab,10);
	 sscanf(tab,"%u",&(Mes.MonSamp));
	 if((Mes.MonSamp==0) || (Mes.MonSamp>4096))
	  Mes.MonSamp=400;

	 if(ExBuf->GetCheck()==BF_CHECKED)
	  Mes.ExMem = TRUE ;
	 else
	  Mes.ExMem = FALSE ;

	 Mes.Kor = TRUE ;

	 Mes.GetParam();
	 k = Mes.Chan ;

	 for(i=0;i<2;i++)
	  if(Kod[i]->GetCheck()==BF_CHECKED )
		{
		 Mes.ACKod=i;
		 break;
		}
	 for(i=0;i<3;i++)
	  if(DMod[i]->GetCheck()==BF_CHECKED )
		{
		 Mes.DMode=i;
		 break;
		}
	 for(i=0;i<4;i++)
	  if(WK[i]->GetCheck()==BF_CHECKED )
		{
		 Mes.GKan=i+1;
		 break;
		}
	//korekcja w.g liczby kanaw wielokanaowo
	if(!Mes.Single)
	 {
		if(4*(Mes.GKan-1)+1>Mes.Chan)
		 Mes.GKan=1;
	 }
	//Destroy();
	if((Mes.Dtype==3)&&(Mes.Dtype!=0))
	 {
	  Mes.Dtype=2; //grafika
	  SetScroll();
	 }
	MyUpdate(TRUE);
	PaintAll();
}


//////////////////////////////////////////////////////////////////////////
// ustawia domylne parametry dla struktur funkcji
//////////////////////////////////////////////////////////////////////////
void SetDefaultPar()
{
static BOOL first=TRUE  ;
if(first)
 {
  SModuleInit.LC0_IMODULE = 15;


  SInfo.LC0_GTYPE = 3	;
  SInfo.LC0_GNUM = 1	;

  SClock.LC0_LCLOCK=8000;

  SVolt.LC0_VNUM =1	;
  SVolt.LC0_VTYPE =3	;
  SVolt.LC0_VMINV =-100	;
  SVolt.LC0_VMAXV =100	;
  SVolt.LC0_VAMPL =1	;

  SWait.LC0_WTYPE = 3 ;
  SWait.LC0_WNUM = 1 ;
  SWait.LC0_WMODE = 1 ;

  SBreak.LC0_BMODE=1;
  SDigIn.LC0_DNUM=1 ;
  SDigOut.LC0_ONUM=1 ;

  STransmit.LC0_RMODE=0;
  STransmit.LC0_RLEN=4096;
  STransmit.LC0_RMEAS=1;
  STransmit.LC0_RNUM=4096;
  STransmit.LC0_RADDR=ProgBufPtr;
  STransmit.LC0_RMEMA=SModuleInfo.LC0_MMEMA;

  SAnalogIn.LC0_ANUM=1;
  SAnalogIn.LC0_AMODE=LC0_MOD_START|LC0_MOD_NEW_PAR|LC0_MOD_SYNCHR|LC0_MOD_BLOCK|LC0_MOD_EXT_MEM;
  SAnalogIn.LC0_APER=2000;
  SAnalogIn.LC0_ACHAN=4;
  Samples = 4096;
  SAnalogIn.LC0_AADDR =ProgBufPtr ;
  SAnalogIn.LC0_APER2 =1000 ;
  SAnalogIn.LC0_AMEMA = SModuleInfo.LC0_MMEMA;
  SAnalogIn.LC0_ASTST = sel1 ;
  SAnalogIn.LC0_ASTOP.samples = Samples ;

  SAnalogOut.LC0_NNUM=1;
  SAnalogOut.LC0_NMODE=/*15*/LC0_MOD_START|LC0_MOD_NEW_PAR|LC0_MOD_SYNCHR|LC0_MOD_BLOCK;
  SAnalogOut.LC0_NCHAN=1;
  SAnalogOut.LC0_NPER=200;
  SAnalogOut.LC0_NSTOP.samples = Samples ;

  SMemory.LC0_MMODE=1;
  SMemory.LC0_MRNUM=SModuleInfo.LC0_MMEML;
  SMemory.LC0_MRMEMA=SModuleInfo.LC0_MMEMA;

  sD6.bmode = 1;sD6.mode[0] = TRUE;
  sD6.mode[1] = TRUE;sD6.mode[2] = TRUE;sD6.mode[3] = TRUE;
  sD6.mode[4] = FALSE;sD6.mode[5] = TRUE;sD6.mode[6] = FALSE;
  sD6.dmode = 0;
  sD6.amode = 0 ; //wielokanaowo
  sD6.sk = 1;
  sD6.mk = 4;
  (*GetTotalConfiguration)(&STotal);
  first = FALSE ;
  GSamples = Samples ;
  SGAnalogIn = SAnalogIn;

  GlobalInfo.Device = 1; //A/C
  GlobalInfo.Number = 1;

 }

}

///////////////////////////////////////////////////////////////////////////
// ustawienie parametrw po uruchomieniu programu
///////////////////////////////////////////////////////////////////////////
void SetDefModule(int i)
{
  SModuleInfo.LC0_MMODULE=i+1 ;
  SInfo.LC0_GMODULE = i+1	;
  SVolt.LC0_VMODULE =i+1	;
  SWait.LC0_WMODULE = i+1 ;
  SDigIn.LC0_DMODULE=i+1 ;
  SDigOut.LC0_OMODULE=i+1 ;
  SCTCW.LC0_CMODULE=i+1;
  SCTCR.LC0_UMODULE=i+1;
  STransmit.LC0_RMODULE=i+1;
  SAnalogIn.LC0_AMODULE=i+1;
  SAnalogOut.LC0_NMODULE=i+1;
  SInterrupt.LC0_SMODULE=i+1;
  SMemory.LC0_MMODULE=i+1;
  sD6.mod = i;
  Mes.Mod1=Mes.Mod2=i+1;
  GlobalInfo.Module = i+1;
}

//////////////////////////////////////////////////////////
// dialog 6
//////////////////////////////////////////////////////////
DEFINE_RESPONSE_TABLE1(TD6, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_CBN_SELENDOK(IDC_CB1, OnCBNSelendok),
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;


///////////////////////////////////////////////////////////
// klasa TD6 - okno dialogowe DIALOG_6 : parametry wywoania
// funkcji LC0_AnalogIn i LC0_AnalogOut
///////////////////////////////////////////////////////////
TD6::TD6 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 combo = new TComboBox(this,IDC_CB1,0);
	 for(i=0;i<3;i++)
	  RB[i]= new TRadioButton(this,IDC_XR1 + i,0);
	 CB[0]= new TCheckBox(this,IDC_XC1 ,0);
	 for(i=0;i<6;i++)
	  CB[i+1]= new TCheckBox(this,IDC_XC2 + i,0);
	 CB[7]= new TCheckBox(this,IDC_XC8,0);CB[8]= new TCheckBox(this,IDC_XC9,0);

	 for(i=0;i<4;i++)
	  CBX[i]= new TCheckBox(this,IDC_XC10 + i,0);

	XR4= new TRadioButton(this,IDC_XR4 ,0);XR5= new TRadioButton(this,IDC_XR5 ,0);
	XE1=new TEdit(this,IDC_XE1,4);XE2=new TEdit(this,IDC_XE2,4);
	XE3 = new TEdit(this,IDC_EDIT23,10);
	CBL = new TCheckBox(this, IDC_CHECKBOX2, 0);
}

TD6::~TD6 ()
{
	 Destroy();
}

char *MODSTR[] = {"Modu A","Modu B","Modu C","Modu D"};

void TD6::FillCombo()  //wypenia combobox
{
 while (combo->DeleteString(0) > 0)	 ;
  for (int i = 0; i < 4; i++)
  {
	 int index = combo->AddString(MODSTR[i]);
	 combo->SetItemData(index, (DWORD)i);
  }
}

void TD6::SelectItemData(DWORD itemData)        //ustawia combobox
{
 int count = combo->GetCount();
  combo->SetSelIndex(-1); //Clear the selection
  for (int i = 0; i < count; i++)
	 if (combo->GetItemData(i) == itemData) {
		combo->SetSelIndex(i);
		return;
	 }

}

//wypenia pola dialogu i je wyswietla
void TD6::DisplayValues()
{
  int i ;
  char tab[20];
  if(sD6.bmode==0)
	RB[0]->SetCheck(BF_CHECKED);
  else
	RB[0]->SetCheck(BF_UNCHECKED);
  if(sD6.bmode==1)
	RB[1]->SetCheck(BF_CHECKED);
  else
	RB[1]->SetCheck(BF_UNCHECKED);
  if(sD6.bmode==2)
	RB[2]->SetCheck(BF_CHECKED);
  else
	RB[2]->SetCheck(BF_UNCHECKED);
  if(sD6.dmode==1)
	CB[0]->SetCheck(BF_CHECKED);
  else
	CB[0]->SetCheck(BF_UNCHECKED);
  for(i=0;i<6;i++)
	{
	 if(sD6.mode[i]==TRUE)
	  CB[i+1]->SetCheck(BF_CHECKED);
	 else
	  CB[i+1]->SetCheck(BF_UNCHECKED);
	}
  if(sD6.mode[6]==TRUE)
	  CB[7]->SetCheck(BF_CHECKED);
  else
	  CB[7]->SetCheck(BF_UNCHECKED);
  if(sD6.mode[7]==TRUE)
	  CB[8]->SetCheck(BF_CHECKED);
  else
	  CB[8]->SetCheck(BF_UNCHECKED);

  for(i=0;i<4;i++)
	{
	 if(sD6.xmode[i]==TRUE)
	  CBX[i]->SetCheck(BF_CHECKED);
	 else
	  CBX[i]->SetCheck(BF_UNCHECKED);
	}

  if(sD6.amode==0)
	XR5->SetCheck(BF_CHECKED);
  else
	XR4->SetCheck(BF_CHECKED);
  char str[10];
  sprintf(str,"%u",sD6.sk);
  XE1->SetText(str);
  sprintf(str,"%u",sD6.mk);
  XE2->SetText(str);

  sprintf(tab,"%lu",Samples);
  XE3->SetText(tab);
  if(AppProc)
	CBL->SetCheck(BF_CHECKED);
  else
	CBL->SetCheck(BF_UNCHECKED);


}

//odczytuje parametry z pl dialogu
void TD6::ReadParameters()
{
  int i ;
  char tab[20];
  if(XR5->GetCheck() ==BF_CHECKED)
	sD6.amode = 0;
  else
	sD6.amode = 1;
  char str[10];

  XE1->GetText(str,3);
  sscanf(str,"%d",&(sD6.sk));
  XE2->GetText(str,3);
  sscanf(str,"%d",&(sD6.mk));

  for(i=0;i<3;i++)
	{
	  if(RB[i]->GetCheck() == BF_CHECKED)
		{
		 sD6.bmode = i;
		 break;
		}
	}
  if(CB[0]->GetCheck()==BF_CHECKED)
	  sD6.dmode=1;
	 else
		sD6.dmode=0;
  for(i=0;i<8;i++)
	{
	 if(CB[i+1]->GetCheck()==BF_CHECKED)
	  sD6.mode[i]=TRUE;
	 else
		sD6.mode[i]=FALSE;
	}

  for(i=0;i<4;i++)
	{
	 if(CBX[i]->GetCheck()==BF_CHECKED)
	  sD6.xmode[i]=TRUE;
	 else
		sD6.xmode[i]=FALSE;
	}

	XE3->GetText(tab,9);
	sscanf(tab,"%lu",&Samples);
	if(CBL->GetCheck() == BF_CHECKED)
	 AppProc = TRUE; //flaga wywoawcza odp. procedury
	else
	 AppProc = FALSE ; //flaga z DLL -a
}

///////////////////////////////////////////////////////////////////
//PONIEJ FUNKCJE WIRTUALNE I OBSUGI KOMUNIKATW
///////////////////////////////////////////////////////////////////
void TD6::SetupWindow ()
{
 TDialog::SetupWindow();
 FillCombo();
 SelectItemData(sD6.mod);
 DisplayValues();
}

void TD6::OnOKClicked ()
{

  ReadParameters() ;
  sD6.go = TRUE ;
  Destroy();
}

void TD6::OnCBNSelendok()
{
	 int inx ;
	 inx=combo->GetSelIndex();
	 sD6.mod= combo->GetItemData(inx);
}


//////////////////////////////////////////////////////////
// dialog 7 - generator
//////////////////////////////////////////////////////////
static int DAC=3 ;
static float CAVal=0.0;

DEFINE_RESPONSE_TABLE1(TD7, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_BN_CLICKED(IDC_P ,OnPClicked),
	 EV_BN_CLICKED(IDC_J ,OnJClicked),
	 EV_BN_CLICKED(IDC_7_START, OnParam),
	 EV_BN_CLICKED(IDC_7_ZAPIS,OnZapis),
	 EV_WM_QUERYDRAGICON,
	 EV_WM_PAINT,
	 EV_WM_CLOSE,
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;

///////////////////////////////////////////////////////////////////
// klasa TD7 : okno dialogowe generatora C/A
///////////////////////////////////////////////////////////////////
TD7::TD7 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 MyIcon = ::LoadIcon(hInst,MAKEINTRESOURCE(IDI_CADIALOG));
	 dWindow = this;
	 for(i=0;i<4;i++)
	  RP[i]= new TRadioButton(this,IDC_SIN + i,0);
	 RM[0]= new TRadioButton(this,IDC_DAC1 ,0);RM[1]= new TRadioButton(this,IDC_DAC12 ,0);

	Umax=new TEdit(this,IDC_UMAX,6);Umin=new TEdit(this,IDC_UMIN,6);
	Nper=new TEdit(this,IDC_NPER,10);Per=new TEdit(this,IDC_PER,10);
	Samp=new TEdit(this,IDC_SAMP,8);
	DAC1 = new TCheckBox(this,IDC_7_DAC1);DAC2 = new TCheckBox(this,IDC_7_DAC2);
	Value = new TEdit(this,IDC_7_VALUE,10);
}

TD7::~TD7 ()
{
	 //Destroy();
}

/////////////////////////////////////////////////////////////////
//PONIEJ FUNKCJE WIRTUALNE I OBSUGI KOMUNIKATW
////////////////////////////////////////////////////////////////
HANDLE TD7::EvQueryDragIcon()
 {
	return(MyIcon)   ;

 }


void TD7::EvPaint()
{
 TRect R;
 HDC dc;
 DWORD kol;
  ((TDialog*)(this))->EvPaint();
	if (this->IsIconic())
	 {
		// wyswietlic ikone
		R=this->GetClientRect();
		dc=::GetWindowDC(this->HWindow);
		::DrawIcon(dc,R.left+2,R.top+2,MyIcon);
		::ReleaseDC(this->HWindow,dc);
		//this -> SetBkgndColor(kol);
	 }
}

void TD7::EvClose()
{
  dWindow = NULL;
  Destroy();
}

//wypenia pola dialogu i je wywietla
void TD7::DisplayValues()
{
 int i ;
 static int first =1;

 if(first)
  {
	SD7AnalogOut.LC0_NSTOP.samples = 4096 ;
	first =0;
  }

 // rodzaj przebiegu
 for(i=0;i<4;i++)
  {
	if(sD7.przebieg ==i+1)
	  RP[i]->SetCheck(BF_CHECKED);
	else
	  RP[i]->SetCheck(BF_UNCHECKED);
  }
 switch(DAC)
  {
	  case 0	:  DAC1->SetCheck(BF_UNCHECKED);
					DAC2->SetCheck(BF_UNCHECKED);
					break;
	  case 1 :  DAC1->SetCheck(BF_CHECKED);
					DAC2->SetCheck(BF_UNCHECKED);
					break ;
	  case 2 :  DAC1->SetCheck(BF_UNCHECKED);
					DAC2->SetCheck(BF_CHECKED);
					break ;
	  case 3 :  DAC1->SetCheck(BF_CHECKED);
					DAC2->SetCheck(BF_CHECKED);
					break ;
  } ;

 // parametry statyczne
 char str[15];
 sprintf(str,"%.3f",CAVal);Value->SetText(str);

 sprintf(str,"%.3f",sD7.Umax);Umax->SetText(str);
 sprintf(str,"%.3f",sD7.Umin);Umin->SetText(str);
 sprintf(str,"%.2f",sD7.period);Per->SetText(str);
 sprintf(str,"%.3f",(float)SD7AnalogOut.LC0_NPER /10000.0 );Nper->SetText(str);
 sprintf(str,"%ld",SD7AnalogOut.LC0_NSTOP.samples);Samp->SetText(str);
 // tryb generacji DAC1 DAC2
	 if(SD7AnalogOut.LC0_NCHAN ==129)
	  {
		RM[0]->SetCheck(BF_CHECKED);
		RM[1]->SetCheck(BF_UNCHECKED);
	  }
	 else
	  {
		RM[1]->SetCheck(BF_CHECKED);
		RM[0]->SetCheck(BF_UNCHECKED);
	  }

}

//odczytuje parametry ustawione z dialogu
void TD7::ReadParameters()
{
  int i ;
  lc0_module LL ;

  SD7AnalogOut.LC0_NMODULE =GlobalInfo.Module ;
  LL.LC0_CODE = GET_MODULE_CONFIGURATION ;
  LL.LC0_MMODULE = SD7AnalogOut.LC0_NMODULE  ;
  (*GetModuleConfiguration)(&LL);
  SD7AnalogOut.LC0_NADDR.extended_memory=LL.LC0_MMEMA ;
  sD7.L = LL.LC0_MMEML ; // w prbkach
  //przebieg
  for(i=0;i<4;i++)
	{
	  if(RP[i]->GetCheck() == BF_CHECKED)
		{
		 sD7.przebieg = i+1;
		 break;
		}
	}

  //parametry statyczne
  char str[15];
  float f;
  Value->GetText(str,10);sscanf(str,"%f",&(CAVal));
  Umax->GetText(str,10);sscanf(str,"%f",&(sD7.Umax));
  Umin->GetText(str,10);sscanf(str,"%f",&(sD7.Umin));
  Per->GetText(str,10);sscanf(str,"%f",&(sD7.period));
  Nper->GetText(str,10);sscanf(str,"%f",&(f)); //w [ms]

  SD7AnalogOut.LC0_NPER = (unsigned long int)(f*10000) ;
  if(f*10000.0 - (float)SD7AnalogOut.LC0_NPER >=0.5)
	SD7AnalogOut.LC0_NPER ++ ;
  Samp->GetText(str,10);sscanf(str,"%ld",&(SD7AnalogOut.LC0_NSTOP.samples)); //

  // tryb DAC1 DAC2
  if(RM[0]->GetCheck()==BF_CHECKED) //DAC1
	SD7AnalogOut.LC0_NCHAN =129 ;
  else
	SD7AnalogOut.LC0_NCHAN =1 ;
  DAC = 0;
  if(DAC1->GetCheck()==BF_CHECKED)
	DAC |=1;
  if(DAC2->GetCheck()==BF_CHECKED)
	DAC |=2;
}

void TD7::SetupWindow ()
{
 TDialog::SetupWindow();
 DisplayValues();
}

void TD7::OnOKClicked ()
{

  ReadParameters() ;
  dWindow = NULL;
  Destroy();
}

void TD7::OnParam () //parametry startu
{
 TParD *Dptr ;
 unsigned long SPT;
 unsigned char SPA[5];
 unsigned char SEL1,*ptr;
 int i;

 for(i=0;i<5;i++)
  {
	 SPA[i]=Spar[i] ;
	 Spar[i]=CASPar.Spar[i];
  }
 SEL1 = sel1 ;
 SPT = Sptime;
 sel1= CASPar.typ ;
 Sptime = CASPar.Sptime ;
 Dptr = new TParD(this)   ;
 Dptr->Execute();
 for(i=0;i<5;i++)
  {
	 CASPar.Spar[i] = Spar[i];
	 Spar[i]=SPA[i];

  }
 CASPar.typ = sel1 ;
 CASPar.Sptime = Sptime ;
 sel1 = SEL1 ;
 Sptime = SPT;

 //ustalamy lokalne parametry startu i stopu f.analog_output
 SD7AnalogOut.LC0_NSTST = CASPar.typ ;
 ptr = (unsigned char*)(&(SD7AnalogOut.LC0_NSTART));
 if(CASPar.typ!=6)
  {
	*ptr = CASPar.Spar[0];*(ptr+1) = CASPar.Spar[1];*(ptr+2)=CASPar.Spar[2];
	*(ptr+3) = CASPar.Spar[3]; *(ptr+4) = CASPar.Spar[4];
  }
 else
  SD7AnalogOut.LC0_NSTART.time = CASPar.Sptime ;

 delete Dptr ;
}

void TD7::OnPClicked()
{
 ReadParameters() ;
 DisplayValues();
 Action(1);
 DisplayValues();
}
void TD7::OnJClicked()
{
 ReadParameters() ;
 DisplayValues();
 Action(0);
 DisplayValues();
}

 void TD7::OnZapis()
 {
  lc0_analog_out AO ;
  lc0_break		SBreak = {BREAK , 0,0,LC0_BREAK_INST,NULL};
  lc0_info s_info ;
  HCURSOR hcurSave;
  char tabs[100];

  ReadParameters() ;
  DisplayValues();
  if(DAC==0)
	return ;
  AO = SD7AnalogOut ;
  unsigned int tab[2];
  int *ptr ;
  unsigned char np ;
  np = SD7AnalogOut.LC0_NNUM ;
 if((np == 0) || (np > 2))
  np = 1 ;
 IValues.SetValues(np+1,SD7AnalogOut.LC0_NMODULE,np);

 //instalacja BREAK
 (*Break)(&SBreak);
				/* spytanie o konfiguracje toru c/a*/
 s_info.LC0_GMODULE = SD7AnalogOut.LC0_NMODULE;
 s_info.LC0_GTYPE   = LC0_AOUTPUT;
 s_info.LC0_GNUM    = 1;
 /* GET_INFO        */
 (*GetInfo)((struct lc0_info FAR * )&s_info);
 if(s_info.LC0_STATUS!=LC0_OK)
  {
	sprintf(tabs,"Bd ANALOG_OUT : %s" ,DriverErrors[-s_info.LC0_STATUS -1] );
	MessageBox(tabs,"Bd",MB_OK);
	return;
  }
 else
  ptr = (int far *)(&tab[0])  ;
  SD7AnalogOut.LC0_NADDR.base_memory = ptr ;
 // przygotowanie bufora z prbkami
 SD7AnalogOut.LC0_NSTOP.samples = DAC;
 SD7AnalogOut.LC0_NLEN = 2;
 //zapeniamy bufor wartociami wysyanymi
 hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
 tab[0] = IValues.FloatToCode(np+1,CAVal);
 tab[1] = IValues.FloatToCode(np+1,CAVal);
 sprintf(tabs,"%f6.3",IValues.CodeToFloat(np+1,tab[0]));
 Value->SetText(tabs);
 //parametry wywoania
 SD7AnalogOut.LC0_NMODE = LC0_MOD_START |LC0_MOD_NEW_PAR |LC0_MOD_SYNCHR ;
 if(DAC==1)
  {
	SD7AnalogOut.LC0_NCHAN =129 ;
	SD7AnalogOut.LC0_NNUM = 1;
  }
 if(DAC==2) //2
  {
	SD7AnalogOut.LC0_NCHAN =129 ;
	SD7AnalogOut.LC0_NNUM = 2;
  }
 if(DAC==3)
  {
	SD7AnalogOut.LC0_NCHAN =1 ;
	SD7AnalogOut.LC0_NNUM = 1;
  }

 //wywalamy
 ::MessageBeep(-1);
 (*AnalogOutput)(&SD7AnalogOut);
 ::SetCursor(hcurSave);
 if((SD7AnalogOut.LC0_STATUS!=LC0_OK) && (SD7AnalogOut.LC0_STATUS!=LC0_BROKEN))
	 {
	  if(SD7AnalogOut.LC0_STATUS<0)
		sprintf(tabs,"Bd ANALOG_OUT : %s" ,DriverErrors[-SD7AnalogOut.LC0_STATUS -1] );
	  else
		sprintf(tabs,"Bd ANALOG_OUT : %s" ,DriverWarnings[SD7AnalogOut.LC0_STATUS -1] );
	  MessageBox(tabs,"Bd",MB_OK);
	 }

 SD7AnalogOut = AO;

 }

/////////////////////////////////////////////////////////////////////////////
// ->Action()
// Wykonanie LC0_AnalogOut i odpowiednie przygotowanie do generacji wybranych
// sygnaw .
// Prbki s pobierane z bufora pamici rozszerzonej
// Parametr :
//  cycl : 1 - praca cykliczna
/////////////////////////////////////////////////////////////////////////////
void TD7::Action(int cycl)
{
 lc0_break		SBreak = {BREAK , 0,0,LC0_BREAK_INST,NULL};
 lc0_info s_info ;
 int huge *ptr ;
 unsigned int ilpr;
 unsigned long int IL;
 float st,f,am;
 unsigned int i ;
 unsigned long int I ;
 char tab[100];
 HCURSOR hcurSave;


 unsigned char np ;
 np = SD7AnalogOut.LC0_NNUM ;
 if((np == 0) || (np > 2))
  np = 1 ;
 IValues.SetValues(np+1,SD7AnalogOut.LC0_NMODULE,np);

 //instalacja BREAK
 (*Break)(&SBreak);
				/* spytanie o konfiguracje toru c/a*/
 s_info.LC0_GMODULE = SD7AnalogOut.LC0_NMODULE;
 s_info.LC0_GTYPE   = LC0_AOUTPUT;
 s_info.LC0_GNUM    = 1;
 /* GET_INFO        */
 (*GetInfo)((struct lc0_info FAR * )&s_info);
 if(s_info.LC0_STATUS!=LC0_OK)
  {
	sprintf(tab,"Bd ANALOG_OUT : %s" ,DriverErrors[-s_info.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
	return;
  }
 if(SD7AnalogOut.LC0_NADDR.extended_memory == NULL)
  {
	MessageBox("Brak bufora w pamici rozszerzonej !!!","Bd",MB_OK);
	return ;
  }
 else
  ptr = (int huge *)SD7AnalogOut.LC0_NADDR.extended_memory ;

 // przygotowanie bufora z prbkami
 st=(sD7.Umax + sD7.Umin)/2.0 ;
 am=(sD7.Umax - sD7.Umin)/2.0 ;
 if(cycl==1) //przebieg okresowy
  {
	ilpr = (unsigned int)((sD7.period *1000.0)/((float)SD7AnalogOut.LC0_NPER/10.0)) ;
	if((ilpr > 32767) || (ilpr <5))
	 {
	  MessageBox("Ze parametry przebiegu : ilo prbek > 32767 lub < 5","Bd",MB_OK);
	  return ;
	 }
	if(ilpr>sD7.L)
	 {

	  MessageBox("Zwiksz rozmiar pamici rozszerzonej do 64 KB !!!","Bd",MB_OK);
	  return ;
	 }
	SD7AnalogOut.LC0_NSTOP.samples = ilpr;
	hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
	switch(sD7.przebieg)
	 {
		case		1 :for(i=0;i<ilpr;i++)
						{
						 f=st + am*sin(2*3.141592654*i/(float)ilpr);
						 *(ptr+i) = IValues.FloatToCode(np+1,f);
						}
						break;//sinusoida
		case		2 :for(i=0;i<ilpr;i++)
						{
						 f=st +am*trojkat1((int)((8000.0*i)/(float)ilpr));
						 *(ptr+i) = IValues.FloatToCode(np+1,f);
						}
						break;//trjkt
		case		3 :for(i=0;i<ilpr;i++)
						{
						 if(i<=ilpr/2)
						  f=sD7.Umax;
						 else
						  f=sD7.Umin;
						 *(ptr+i) = IValues.FloatToCode(np+1,f);
						}
						break;//prostokt
	  case 4		  :
						break ; //warto zmierzona
	 } ;
	// jest zapeniony przebieg prbkami]
	//wysyamy go
	unsigned int nmode = SD7AnalogOut.LC0_NMODE ;
	//CYCL = 1
	SD7AnalogOut.LC0_NMODE |=LC0_MOD_CYCL ;
	::MessageBeep(-1);
	(*AnalogOutput)(&SD7AnalogOut);
	::SetCursor(hcurSave);
	if((SD7AnalogOut.LC0_STATUS!=LC0_OK) && (SD7AnalogOut.LC0_STATUS!=LC0_BROKEN))
	 {
	  if(SD7AnalogOut.LC0_STATUS<0)
		sprintf(tab,"Bd ANALOG_OUT : %s" ,DriverErrors[-SD7AnalogOut.LC0_STATUS -1] );
	  else
		sprintf(tab,"Bd ANALOG_OUT : %s" ,DriverWarnings[SD7AnalogOut.LC0_STATUS -1] );
	  MessageBox(tab,"Bd",MB_OK);
	 }
	SD7AnalogOut.LC0_NMODE = nmode ;
  }
 else 		// przebieg pojedynczy
  {
	if(sD7.L < SD7AnalogOut.LC0_NSTOP.samples)
	 {
	  MessageBox("Za may rozmiar bufora na prbki !!!","Bd",MB_OK);
	  return ;
	 }

	hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
	IL=SD7AnalogOut.LC0_NSTOP.samples ;
	switch(sD7.przebieg)
	 {
		case		1 :for(I=0;I<SD7AnalogOut.LC0_NSTOP.samples;I++)
						{
						 f=st + am*sin(2*3.141592654*I/(float)IL);
						 *(ptr+I) = IValues.FloatToCode(np+1,f);
						}
						break;//sinusoida
		case		2 :for(I=0;I<SD7AnalogOut.LC0_NSTOP.samples;I++)
						{
						 f=st +am*trojkat1((int)((8000.0*I)/(float)IL));
						 *(ptr+I) = IValues.FloatToCode(np+1,f);
						}
						break;//trjkt
		case		3 :for(I=0;I<SD7AnalogOut.LC0_NSTOP.samples;I++)
						{
						 if(I<=IL/2)
						  f=sD7.Umax;
						 else
						  f=sD7.Umin;
						 *(ptr+I) = IValues.FloatToCode(np+1,f);
						}
						break;//prostokt
	  case 4		  :
						break ; //warto zmierzona
	 } ;

	::MessageBeep(-1);
	(*AnalogOutput)(&SD7AnalogOut);
	::SetCursor(hcurSave);
	if((SD7AnalogOut.LC0_STATUS!=LC0_OK) && (SD7AnalogOut.LC0_STATUS!=LC0_BROKEN))
	 {
	  if(SD7AnalogOut.LC0_STATUS<0)
		sprintf(tab,"Bd ANALOG_OUT : %s" ,DriverErrors[-SD7AnalogOut.LC0_STATUS -1] );
	  else
		sprintf(tab,"Bd ANALOG_OUT : %s" ,DriverWarnings[SD7AnalogOut.LC0_STATUS -1] );
	  MessageBox(tab,"Bd",MB_OK);
	 }
  }
}

//definicja przebiegu trojkatnego
float TD7::trojkat1(int indeks)
 {
		if((indeks>=0)&&(indeks<=2000))
		 return(indeks/2000.0);
		if((indeks>=2001)&&(indeks<=6000))
		 return(1.0-(indeks-2000.0)/2000.0);
		if((indeks>=6001)&&(indeks<=8000))
		 return(-1.0+(indeks-6000.0)/2000.0);
		return(0.0);
 }


//////////////////////////////////////////////////////////
// dialog 4
//////////////////////////////////////////////////////////
DEFINE_RESPONSE_TABLE1(TD4, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_CBN_SELENDOK(IDC_CB1, OnCBNSelendok),
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;

//////////////////////////////////////////////////////////////////
// TD4 : klasa dialogu wyboru biblioteki DLL
/////////////////////////////////////////////////////////////////
TD4::TD4 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 combo = new TComboBox(this,IDC_COMBODLL,0);
}

//destruktor
TD4::~TD4 ()
{
	 Destroy();
}

//wypenia combobox
void TD4::FillCombo()
{
 int index,j=0 ;
 while (combo->DeleteString(0) > 0)	 ;
  for (int i = 0; i < DLLNR; i++)
  {
	 if(DLLAct[i]==1)
	  {
		index = combo->AddString(DLLDrivers[i]);
		combo->SetItemData(index,(DWORD)i);
	  }
  }

}

//ustawia combobox
void TD4::SelectItemData(DWORD inx)
{
 int count = combo->GetCount();
  combo->SetSelIndex(-1); //Clear the selection
  combo->SetSelIndex(inx);

}

//wypenia pola
void TD4::DisplayValues()
{

}

//odczytuje parametry
void TD4::ReadParameters()
{
  int inx ;
  inx=combo->GetSelIndex();
  strcpy(CurrentDLL,DLLDrivers[combo->GetItemData(inx)]) ;
}

// setup okna
void TD4::SetupWindow ()
{
 TDialog::SetupWindow();
 FillCombo();
 SelectItemData(0);
 DisplayValues();
}

//po wcisniciu OK
void TD4::OnOKClicked ()
{

  ReadParameters() ;
  Destroy();
}

void TD4::OnCBNSelendok()
{
	 int inx ;
	 inx=combo->GetSelIndex();
	 strcpy(CurrentDLL,DLLDrivers[combo->GetItemData(inx)]) ;
}

//////////////////////////////////////////////////////////////////////////
//
// 1. Doda obsug NKB i U2 przy wywietlaniu - OK
// 2. Wymusic NKB dla C/A !!!                  - OK
//////////////////////////////////////////////////////////////////////////

