#if !defined(__ttestd_h)              // Sentry, use file only if it's not already included.
#define __ttestd_h

/*
	Project lcwin.exe
	Autor : Krzysztof Mroczek 1995,1996
*/

#define IDW_STATUSBAR       32000   // Copied from include\owl\messageb.h
#define IDW_TOOLBAR         1000    // Assigned to toolbar in BuildControlBar()

#include <owl\static.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\combobox.h>
#include <owl\edit.h>
#include <owl\owlpch.h>
#include <owl\owldefs.h>
//#pragma hdrstop

#include <owl\dialog.h>

#include "t011app.rh"            // Definition of all resources.

/////////////////////////////////////////////////
// struktura okrelajca par. pomiaru
////////////////////////////////////////////////
class Measure
{
 public :
 unsigned char Dtype			;//0 nic 1 tekst 2 grafika 3-statystyka
 Measure()						; //konstruktor
 //void Calc()					; //prowadzi obliczenia
 char GetParam()				; //ustala zmienne na podstawie SAnalogIn
 float CodeToFloat(int code);
 int Statistic(unsigned long samples,TGauge *sk,int min ,int max);
 unsigned char NumDispl		; //ilo wywietlanych kanaw przy pracy mult.==4
 unsigned char GKan			; //0 - 1..4 1-5..8 ...
 unsigned char MonChan1,MonChan2		; //nr. monitorowanego kanau
 unsigned int Mod1,Mod2		; //nr modw skojarzonych z kanaami
 unsigned int MonSamp		;
 unsigned char Chan			; //kana/liczba kanaw z SAnalogIn
 BOOL	Single					; //tryb pracy z SAnalogIn
 unsigned char ModNum		; //nr aktualnie ustawionego moduu z SAnalogIn
 int far *PBuf				; //wskanik do bufora programu rozmaiar stay 4096
 int far *EBuf				; //wskanik do bufora pam.rozszerzonej
 BOOL ExMem					; //TRUE z pam. rozszerzonej
 BOOL Kor					; //TRUE : korekcja dla pracy wielokana. DataTransmitt
 //rozmiar jest znany - pomiary na 4096 prbek
 float Umin,Umax			; //napicia zakresowe dla A/C
 unsigned char NumD		; //ilo kanaw do wywietlania po przeliczeniu
 int far *ptr			 ;
 int Scale				 ; //skala rys. grafiki ==2
 int Samples			 ; //ilo prbek wywietlanych
 int ACKod				 ; //NKB 0 - 1 U2
 int DMode				 ; //0-10;1-HEX;2-MV
 // tablice na watoci statystyczne
 float *TMin,*TMax,*TMean,*TStv;
 BOOL ProgBufEnable	 ; // 1 - mona wykona obliczenia statystyczne na ProgBuf
 BOOL ExBufEnable		 ; // 1 - mona wykona obliczenia statystyczne na EXBuf

  void TranslateBuf(lc0_analog_in *ptr,lc0_module *ptrmod); // robi korekcj buforw po zmierzeniu
 // U2->BIN
};

struct StartParam
{
  unsigned long Sptime;
  unsigned char Spar[6];
  int typ ;

};

//{{TDialog = TTestD}}
class TTestD : public TDialog {
public:
	 TTestD (TWindow* parent, TResId resId = FUN_DIALOG, TModule* module = 0);
	 virtual ~TTestD ();
	 // moje zmienne
	 TComboBox *combo					; //wybr funkcji
	 TEdit	  *e[16]					; //okna edycyjne parametrw
	 TStatic	  *l[13]					; //opisy parametrw
	 TCheckBox *MOD[4]            ; //moduy do inicjacji / zainstalowane
	 TStatic	  *ST						; //tekst

	 // moje funkcje
	 void ParToStr(float par,char* str)   ;
	 void ParToStr(int par , char* str ) ;//dla charw i int
	 void ParToStr(unsigned int par , char* str ) ;//dla uint
	 void ParToStr(unsigned long  par , char* str );
	 void ParToStr(int far *par , char* str ) ;

	 void ParToStrHex(unsigned char par , char* str ) ;
	 void ParToStrHex(unsigned int par , char* str ) ;

	 void FillCombo(char *FName[],int count) ; //wypenia combobox
	 void SelectItemData(DWORD funnum)       ; //ustawia combobox
	 void DisplayValues(DWORD funnames)		  ; //wypenia pola

	 void StrToPar(char * str , unsigned char *par);
	 void StrToPar(char * str , char *par);
	 void StrToPar(char * str , unsigned int *par);
	 void StrToPar(char * str , unsigned long *par);
	 void StrToPar(char * str , int far* *par);
	 void StrToPar(char * str , float *par) ;

	 void StrToParHex(char * str ,unsigned char *par) ;
	 void StrToParHex(char * str ,unsigned int *par) ;

	 void ReadParameters(int funnames);			 //odczytuje parametry
	 void SetModInfo(int funnum);
	 void GetModInfo(int funnum);//aktualizacja informacji omoduach
	 HICON MyIcon ;
	 static TTestD* dWindow ;
//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnCancelClicked ();
	 void OnParamClicked ();
	 void OnRunClicked ();
	 void OnCBNEditchange ();
	 void OnCBNSelendok ();
	 void OnMode();
	 HANDLE EvQueryDragIcon() ;
	 void EvPaint();
	 void EvClose();
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TTestD);
};    //{{TTestD}}



//{{TDialog = TParD}}
struct TParDXfer {
//{{TParDXFER_DATA}}
	 BOOL    Radio1;
	 BOOL    Radio2;
	 BOOL    Radio3;
	 BOOL    Radio4;
	 BOOL    Radio5;
	 BOOL    Radio6;
	 BOOL    Radio7;
	 BOOL    Radio8;
	 BOOL		Radio9;
	 BOOL    TCAR1;
	 BOOL    TCAR2;
	 BOOL    TCAR3;
	 BOOL    TCAR4;
	 BOOL    TCAR5;
	 BOOL    TCAR6;
	 BOOL    Check1;
//{{TParDXFER_DATA_END}}
};


class TParD : public TDialog {
public:
	 TParD (TWindow* parent,TResId resId = PAR_DIALOG, TModule* module = 0);
	 virtual ~TParD ();

//{{TParDVIRTUAL_BEGIN}}
public:
	 TRadioButton *TR1[9],*TR2[6];
	 TEdit *e[6];
	 TStatic *O[5];
	 unsigned char PPar[5];
	 int Psel;
	 unsigned long int PTime;
	 virtual void SetupWindow ();
	 void GetRadio(int *r1 ,int *r2) ;//sprawdza ktry button jest wcinity
	 void SetRadio(int r1 , int r2)  ;//ustawia odpowiedni button -1 , 0 ++
	 void GetParam()						;//pobiera parametry z okna i ustawia zmienne
	 void SetParam()						;//ustawia parametry okna



//{{TParDVIRTUAL_END}}

//{{TParDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 VOID OnRadio();
//{{TParDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TParD);

//{{TParDXFER_DEF}}
protected:
	 TRadioButton *Radio1;
	 TRadioButton *Radio2;
	 TRadioButton *Radio3;
	 TRadioButton *Radio4;
	 TRadioButton *Radio5;
	 TRadioButton *Radio6;
	 TRadioButton *Radio7;
	 TRadioButton *Radio8;
	 TRadioButton *Radio9;

	 TRadioButton *TCAR1;
	 TRadioButton *TCAR2;
	 TRadioButton *TCAR3;
	 TRadioButton *TCAR4;
	 TRadioButton *TCAR5;
	 TRadioButton *TCAR6;
	 TCheckBox *Check1;

//{{TParDXFER_DEF_END}}
};    //{{TParD}}

void FAR BreakProcApp();
int FloatToCode(float val);
float CodeToFloat(int val);


//{{TDialog = TParMD}}
struct TParMDXfer {
//{{TParMDXFER_DATA}}
	 char    NumChan[ 255 ];
	 char    MonChan[ 255 ];
//{{TParMDXFER_DATA_END}}
};

class TParMD : public TDialog
{
public:
	 TParMD (TWindow* parent, TResId resId = DIALOG_3, TModule* module = 0);
	 virtual ~TParMD ();

//{{TParMDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
	 HICON MyIcon ;
	 static TParMD* dWindow ;
//{{TParMDVIRTUAL_END}}

//{{TParMDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
//{{TParMDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TParMD);

//{{TParMDXFER_DEF}}
protected:
	 //TEdit *NumChan;
	 TEdit *MonChan1;
	 TEdit *MonChan2;
	 TEdit *Mod1;
	 TEdit *Mod2;
	 TEdit *MonSamp;
	 TCheckBox *ExBuf ;
	 TRadioButton *Kod[2] ; //NKB,U2
	 TRadioButton *DMod[3];//10;HEX;mV
	 TRadioButton *WK[4];
	 HANDLE EvQueryDragIcon() ;
	 void EvPaint();
	 void OnCancelClicked();
	 void EvClose();
//{{TParMDXFER_DEF_END}}
};    //{{TParMD}}


///////////////////////////////////////////////////////////
// DIALOG4 - wybr aktualnego driver'a
//////////////////////////////////////////////////////////
class TD4 : public TDialog
{
public:
	 TD4 (TWindow* parent, TResId resId = DIALOG_4, TModule* module = 0);
	 virtual ~TD4 ();

	 // moje zmienne
	 TComboBox *combo					; //wybr funkcji

	 // moje funkcje
	 void FillCombo() ; //wypenia combobox
	 void SelectItemData(DWORD funnum)       ; //ustawia combobox

	 void DisplayValues()		  ; //wypenia pola
	 void ReadParameters();			 //odczytuje parametry

//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnCBNSelendok();
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD4);
};    //{{TD4}}


///////////////////////////////////////////////////////////
// DIALOG6
//////////////////////////////////////////////////////////
class TD6 : public TDialog
{
public:
	 TD6 (TWindow* parent, TResId resId = DIALOG_6, TModule* module = 0);
	 virtual ~TD6 ();
	 // moje zmienne
	 TComboBox *combo					; //wybr funkcji
	 TCheckBox *CB[9] ;  //podstawowe bity trybu pracy
	 TCheckBox *CBX[4];    //dodatkowe bity trybu pracy
	 TRadioButton *RB[3];
	 TRadioButton *XR4,*XR5;
	 TEdit *XE1,*XE2;
	 TEdit *XE3; //ilo prbek
	 TCheckBox *CBL ; //lokalny BREAK

	 // moje funkcje
	 void FillCombo() ; //wypenia combobox
	 void SelectItemData(DWORD funnum)       ; //ustawia combobox
	 void DisplayValues()		  ; //wypenia pola

	 void ReadParameters();			 //odczytuje parametry

//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnCancelClicked ();
	 void OnCBNSelendok();
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD6);
};    //{{TTestD}}


///////////////////////////////////////////////////////////
// DIALOG7 - generator
//////////////////////////////////////////////////////////
class TD7 : public TDialog
{
public:
	 TD7 (TWindow* parent, TResId resId = DIALOG_7, TModule* module = 0);
	 virtual ~TD7 ();
	 // moje zmienne
	 TRadioButton *RP[4],*RM[2];
	 TEdit *Umax,*Umin,*Nper,*Per,*Samp;
	 TCheckBox *DAC1,*DAC2 ;
	 TEdit *Value ;
	 HICON MyIcon ;
	 static TD7* dWindow ;
	 // moje funkcje
	 void DisplayValues()		  ; //wypenia pola
	 void ReadParameters();			 //odczytuje parametry
	 void Action(int cycl);
	 float trojkat1(int indeks) ;

//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnPClicked ();
	 void OnJClicked ();
	 void OnParam ();
	 void OnZapis();
	 HANDLE EvQueryDragIcon() ;
	 void EvPaint();
	 void EvClose();

//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD7);
};    //{{TTestD}}

/////////////////////////////////////////////////////////////
// struktury do wspomagania dialogow DIALOG6 i DIALOG7
/////////////////////////////////////////////////////////////
struct SD6
{
 int mod ;
 int bmode;
 int dmode ;
 BOOL mode[8];
 BOOL xmode[4];
 BOOL go;
 unsigned char amode ;
 unsigned int sk,mk;
} ;

struct SD7
{
  int przebieg ;
  float Umax ;
  float Umin ;
  float   period ; //ms
  unsigned long int L ; //w prbkach
}  ;

// klasa do przeliczania zakresw min i max napi C/A i A/C
class CValues
{
  public :
  CValues();
  float ACV1,ACV2,CA1V1,CA1V2,CA2V1,CA2V2,M1V1,M1V2,M2V1,M2V2 ;
  void SetValues(int nr , unsigned char modnum , unsigned char num) ; //ustawia zmienne
  int FloatToCode(int nr , float f);
  float CodeToFloat(int nr , int c);
  void CodeToDisplay(int nr , int code,int typ,char *str,int x=0);
  unsigned int inline U2Bin(unsigned int code);
};
void SetDefaultPar(void) ;//ustawia domylne parametry dla struktur funkcji
void SetDefModule(int);   //ustawia domyslna nazwe pierwszego obecnego modulu

#endif                                      // __ttestd_h sentry.

