 #if !defined(__user_h)              // Sentry, use file only if it's not already included.
#define __user_h

/*
 Project lcwin.exe
 Autor :
  Krzysztof Mroczek 1995,96

*/

#include <owl\static.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\combobox.h>
#include <owl\edit.h>
#include <owl\owlpch.h>
#include <owl\owldefs.h>

//#pragma hdrstop

#include <owl\dialog.h>
#include <owl\gauge.h>

#include "t011app.rh"            // Definition of all resources.

// klasa do przeliczania zakresw min i max napi C/A i A/C
void SetDefaultPar(void) ;//ustawia domylne parametry dla struktur funkcji
void SetDefModule(int);   //ustawia domyslna nazwe pierwszego obecnego modlu
void ZeroToStr(char *,int );

///////////////////////////////////////////////////////////
// DIALOG8 - Wejcie analogowe
//////////////////////////////////////////////////////////
class TD8 : public TDialog {
public:
	 TD8 (TWindow* parent, TResId resId = DIALOG_8, TModule* module = 0);
	 virtual ~TD8 ();
	 // moje zmienne
	 TRadioButton *MOD[2],*TKAN[2];
	 TCheckBox *ExClk;
	 TEdit *Kan,*Per,*Samp;

	 // moje funkcje
	 void DisplayValues()		  ; //wypenia pola
	 void ReadParameters();			 //odczytuje parametry
	 void Action();
	 HICON MyIcon ;
	 static TD8* dWindow ;

//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnParamClicked ();
	 void OnStartClicked ();
	 HANDLE EvQueryDragIcon() ;
	 void EvClose();
	 void EvPaint();
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD8);
};    //{{TTestD}}*/


///////////////////////////////////////////////////////////
// DIALOG5 - Wejcie/wyjcie/CTC
//////////////////////////////////////////////////////////
class TD5 : public TDialog {
public:
	 TD5 (TWindow* parent, TResId resId = DIALOG_5, TModule* module = 0);
	 virtual ~TD5 ();
	 // moje zmienne
	 TEdit *EPort,*EOut,*EIn;
	 TEdit *ECTCK,*ECTCM ,*ECTCR,*ECTCW;
	 TCheckBox *CCTC;
	 TRadioButton *RCTCCode[2],*RCTCMode[3];
	 TButton *Push1,*Push2,*Push3,*Push4;

	 void DisplayValues()		  ; //wypenia pola
	 void ReadParameters();			 //odczytuje parametry
	 void Action();                //robi akcj
	 BOOL IsCTC	;						 //1-jest 0-nie
	 HICON MyIcon ;
	 static TD5* dWindow ;
//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnParamClicked ();
	 void OnWriteClicked ();
	 void OnReadClicked ();
	 void OnCTCProgramClicked ();
	 void OnCTCReadClicked ();
	 void OnCTCWriteClicked ();
	 void OnCTCStatusClicked ();
	 void OnByteClicked();
	 void OnWordClicked();
	 HANDLE EvQueryDragIcon() ;
	 void EvPaint();
	 void EvClose();
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD5);
};    //{{TTestD}}*/


struct SD9
{
  unsigned char Module ; //nr moduu 1..4 aktywnego
  unsigned char Device ; //typ urzdzenia
  unsigned int Number ; // numer portu/przetwornika
};


///////////////////////////////////////////////////////////
// DIALOG9 - Informacje o module
//////////////////////////////////////////////////////////
class TD9 : public TDialog {
public:
	 TD9 (TWindow* parent, TResId resId = DIALOG_9, TModule* module = 0);
	 virtual ~TD9 ();
	 // moje zmienne
	 TEdit *Num; //nr przetwornika
	 TStatic *Adres,*Clock,*IRQ,*ExMem,*Ilp,*Ilpo,*Ilx,*S[9];
	 TComboBox *C1,*C2;
	 struct lc0_total STotal;
	 struct lc0_info SInfo;
	 struct lc0_module SModule;
//{{TTestDVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();

//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void OnOKClicked ();
	 void OnInfo ();
	 void OnClear();
	 void OnCBNSelendok1();
	 void OnCBNSelendok2();

	 void ClearStr();
	 void DisplayValues();
	 void FillCombo(TComboBox *cb,char *Str[],int VStr[],int count) ; //wypenia combobox
	 void SelectItemData(TComboBox *cb,int itemData)       ; //ustawia combobox 1-2
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD9);
};    //{{TTestD}}*/


///////////////////////////////////////////////////////////
// DIALOG10 - Informacje o trwaniu oblicze parametrw statystycznych
//////////////////////////////////////////////////////////
class TD10 : public TDialog {
public:
	 TD10 (TWindow* parent, TResId resId = DIALOG_10, TModule* module = 0);
	 virtual ~TD10 ();
	 TGauge*  Skala;
	 unsigned int sk;
	 signed int s1,s2;
	 unsigned int u1,u2,ch,i,zakres,ii,phase;
	 unsigned long Blocks,Smp,I,displ,Imax,Imin,R,Skok;
	 int minv[32],maxv[32];
	 long int sum[32];
	 double ssum[32],msum[32];
	 int huge *PtrBuf;


	 // moje zmienne
public:
	 virtual void SetupWindow ();

//{{TTestDVIRTUAL_END}}

//{{TTestDRSP_TBL_BEGIN}}
protected:
	 void EvTimer(UINT timerId);
	 void OnCancelClicked();
//{{TTestDRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TD10);
};    //{{TTestD}}*


#endif                                      // __user_h sentry.
